SystemOrganization addCategory: #'Xpf-CodeTalk'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Commands'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Kernel'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Tests'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Morphs'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Models'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Browsers'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Nodes'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Panels'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Filters'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Database'!

!Time methodsFor: '*xpf-codetalk' stamp: 'topa 10/27/2009 16:22'!
print24WithoutSeconds
	"Return as 8-digit string 'hh:mm', with leading zeros if needed"

	^ String streamContents:
		[ :aStream | self print24: true showSeconds: false on: aStream ]! !

!OBMonticelloPackageNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 13:06'!
hasMarkups

	^ true! !

!OBMonticelloPackageNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 14:24'!
markupSourceName

	^ 'mc package "{1}"' format: {self packageName}! !

!OBMonticelloPackageNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 13:48'!
referencesForMarkups

	^ (PackageOrganizer default
		packageNamed: self packageName
		ifAbsent: [^ #()]) methods! !

!OBCodeNode methodsFor: '*xpf-codetalk' stamp: 'mt 6/5/2009 16:07'!
filterAllFor: markupNodes

	^ XpfCtMarkupFilterNode
		named: '-- all{1} --'
		nodes: markupNodes
		description: 'Display all markups in this scope. See the window title to determine the scope.'! !

!OBCodeNode methodsFor: '*xpf-codetalk' stamp: 'mt 6/8/2009 10:12'!
filterForCreator: aString for: markupNodes

	^ XpfCtMarkupFilterNode
		named: aString, '{1}'
		nodes: (markupNodes
			select: [:node | node attribute creator = aString])
		description: 'Display only markups that were created by a specific developer. See the window title to determine the current scope.'! !

!OBCodeNode methodsFor: '*xpf-codetalk' stamp: 'mt 6/5/2009 16:07'!
filterForMeFor: markupNodes

	^ XpfCtMarkupFilterNode
		named: '-- for me{1} --'
		nodes: (markupNodes
			select: [:node | node attribute isAuthorMentioned])
		description: 'Display only markups for me in this scope. Those are markups with chat messages which include my initials. See the window title to determine the current scope.'! !

!OBCodeNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 13:05'!
hasMarkups

	^ false! !

!OBCodeNode methodsFor: '*xpf-codetalk' stamp: 'mt 6/5/2009 16:20'!
isDescendantOfMarkup: anOBCodeNode

	^ false! !

!OBCodeNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 17:22'!
isMarkupNode

	^ false! !

!OBCodeNode methodsFor: '*xpf-codetalk' stamp: 'mt 6/8/2009 10:26'!
markupFilters

	| m creators |
	m := self markups.
	creators := (m collect: [:node | node attribute creator]) asSet asSortedArray.
	^ {self filterAllFor: m. self filterForMeFor: m},
		(creators collect: [:c | self filterForCreator: c for: m]).! !

!OBCodeNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 12:56'!
markupSourceName
	"Return name of markup source, e.g. package name, class category, ..."

	^ self subclassResponsibility! !

!OBCodeNode methodsFor: '*xpf-codetalk' stamp: 'mt 1/17/2010 11:55'!
markups

	| result src markups |
	result := OrderedCollection new.
	self referencesForMarkups
		do: [:methodRef |
			markups := XpfCtMarkupDatabase local markupsForMethodReference: methodRef.
			src := methodRef sourceCode asText. "slow..."
			markups do: [:markup |
				result add: ((XpfCtMarkupNode
					forAttribute: markup
					method: methodRef)
					snippet: (markup codeSnippetFor: methodRef sourceCode asString))]]
		displayingProgress: 'Collecting markups...'.
	^ result! !

!OBCodeNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 13:46'!
referencesForMarkups

	^ self subclassResponsibility! !

OBCodeNode subclass: #XpfCtMarkupFilterNode
	instanceVariableNames: 'name description markupNodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Nodes'!

!XpfCtMarkupFilterNode class methodsFor: 'instance creation' stamp: 'mt 6/5/2009 16:04'!
named: aString nodes: someMarkupNodes

	^ self
		named: aString
		nodes: someMarkupNodes
		description: ''! !

!XpfCtMarkupFilterNode class methodsFor: 'instance creation' stamp: 'mt 6/5/2009 16:03'!
named: aString nodes: someMarkupNodes description: anotherString

	^ self new
		name: aString;
		markupNodes: someMarkupNodes;
		description: anotherString! !

!XpfCtMarkupFilterNode methodsFor: 'accessing' stamp: 'mt 6/5/2009 16:03'!
description

	description ifNil: [self description: ''].
	^ description! !

!XpfCtMarkupFilterNode methodsFor: 'accessing' stamp: 'mt 6/5/2009 16:02'!
description: anObject

	description := anObject.! !

!XpfCtMarkupFilterNode methodsFor: 'testing' stamp: 'mt 6/5/2009 15:05'!
hasMarkups

	^ false! !

!XpfCtMarkupFilterNode methodsFor: 'testing' stamp: 'mt 6/5/2009 15:05'!
hasSelector

	^ false! !

!XpfCtMarkupFilterNode methodsFor: 'testing' stamp: 'mt 6/5/2009 15:05'!
hasVersions

	^ false! !

!XpfCtMarkupFilterNode methodsFor: 'ancestry' stamp: 'mt 6/5/2009 16:24'!
isDescendantOfMarkup: anOBCodeNode

	^ true! !

!XpfCtMarkupFilterNode methodsFor: 'accessing' stamp: 'mt 6/5/2009 14:59'!
markupNodes

	^ markupNodes! !

!XpfCtMarkupFilterNode methodsFor: 'accessing' stamp: 'mt 6/5/2009 14:59'!
markupNodes: anObject

	markupNodes := anObject.! !

!XpfCtMarkupFilterNode methodsFor: 'navigation' stamp: 'mt 6/5/2009 15:03'!
markupsByChatSize

	| result groups actualGroup |
	result := OrderedCollection new.
	groups := {
		25 -> '25+ posts'.
		10 -> '10-24 posts'.
		5 -> '5-9 posts'.
		1 -> '1-4 posts'.
		0 -> '(no posts)'}.
	
	self sortMarkupsByChatSize do: [:node | |g|
		g := groups detect: [:s | node attribute chat size >= s key].
		actualGroup = g key ifFalse: [
			result add: (XpfCtSeparatorNode text: g value)].
		actualGroup := g key.
		result add: node].
	^ result! !

!XpfCtMarkupFilterNode methodsFor: 'navigation' stamp: 'mt 6/5/2009 15:03'!
markupsByCreationTime

	| result lastDate |
	result := OrderedCollection new.
	self sortMarkupsByCreationTime do: [:node | |d|
			d := node attribute timestamp date.
			lastDate = d ifFalse: [
				result add: (XpfCtSeparatorNode text: d printRelativeDate)].
			lastDate := d.
			result add: node].
	^ result! !

!XpfCtMarkupFilterNode methodsFor: 'navigation' stamp: 'mt 6/5/2009 15:03'!
markupsByLastActivity

	| result lastDate |
	result := OrderedCollection new.
	self sortMarkupsByLastActivity do: [:node | |d|
			d := node attribute chat
				ifEmpty: [node attribute timestamp date]
				ifNotEmpty: [(node attribute chat last at: #timestamp) date].
			lastDate = d ifFalse: [
				result add: (XpfCtSeparatorNode text: d printRelativeDate)].
			lastDate := d.
			result add: node].
	^ result! !

!XpfCtMarkupFilterNode methodsFor: 'navigation' stamp: 'mt 6/5/2009 15:03'!
markupsByTag

	| result lastTag |
	result := OrderedCollection new.
	self sortMarkupsByTag do: [:node | |t|
			t := node attribute tag.
			lastTag = t ifFalse: [
				result add: (XpfCtSeparatorNode text: ('#{1}' format: {t}))].
			lastTag := t.
			result add: node].
	^ result! !

!XpfCtMarkupFilterNode methodsFor: 'accessing' stamp: 'mt 6/5/2009 16:09'!
name
	"Use the usual placeholder to display the number of nodes."
	
	^ name format: {' (', self markupNodes size asString, ')'}! !

!XpfCtMarkupFilterNode methodsFor: 'accessing' stamp: 'mt 6/5/2009 14:58'!
name: anObject

	name := anObject.! !

!XpfCtMarkupFilterNode methodsFor: 'sorting' stamp: 'mt 6/5/2009 15:02'!
sortMarkupsByChatSize

	^ self markupNodes sortBy: [:n1 :n2 | 
		n1 attribute chat size > n2 attribute chat size]! !

!XpfCtMarkupFilterNode methodsFor: 'sorting' stamp: 'mt 6/5/2009 15:02'!
sortMarkupsByCreationTime

	^ self markupNodes sortBy: [:n1 :n2 |
		n1 attribute timestamp > n2 attribute timestamp]! !

!XpfCtMarkupFilterNode methodsFor: 'sorting' stamp: 'mt 6/5/2009 15:03'!
sortMarkupsByLastActivity

	^ self markupNodes sortBy: [:n1 :n2 | |t1 t2|
		t1 := n1 attribute chat
			ifEmpty: [n1 attribute timestamp]
			ifNotEmpty: [n1 attribute chat last at: #timestamp].
		t2 := n2 attribute chat
			ifEmpty: [n2 attribute timestamp]
			ifNotEmpty: [n2 attribute chat last at: #timestamp].
		t1 > t2]! !

!XpfCtMarkupFilterNode methodsFor: 'sorting' stamp: 'mt 6/5/2009 15:03'!
sortMarkupsByTag

	^ self markupNodes sortBy: [:n1 :n2 |
		n1 attribute tag asString < n2 attribute tag asString]! !

!XpfCtMarkupFilterNode methodsFor: 'public' stamp: 'mt 6/5/2009 18:24'!
text

	| txt |
	txt := self description asText.
	txt addAttribute: (TextColor color: Color gray muchDarker).
	^ txt! !

OBCodeNode subclass: #XpfCtMarkupNode
	instanceVariableNames: 'attribute method snippet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Nodes'!

!XpfCtMarkupNode class methodsFor: 'instance creation' stamp: 'mt 5/30/2009 10:42'!
forAttribute: aComplexAttribute method: aMethodReference

	^ self new
		attribute: aComplexAttribute;
		method: aMethodReference! !

!XpfCtMarkupNode methodsFor: 'accessing' stamp: 'mt 5/30/2009 10:25'!
attribute

	^ attribute! !

!XpfCtMarkupNode methodsFor: 'accessing' stamp: 'mt 5/30/2009 10:25'!
attribute: anObject

	attribute := anObject.! !

!XpfCtMarkupNode methodsFor: 'public' stamp: 'mt 5/30/2009 17:29'!
browse

	OBCodeBrowser defaultBrowserClass
		openOnClass: self method actualClass
		selector: self method methodSymbol.! !

!XpfCtMarkupNode methodsFor: 'public' stamp: 'mt 6/8/2009 11:23'!
chatMessageFor: aChatLine

	^ self txtChatMessageFor: ('"{1}"'
		format: {aChatLine at: #message}).  ! !

!XpfCtMarkupNode methodsFor: 'public' stamp: 'mt 6/8/2009 10:30'!
chatStampFor: aChatLine

	| txt |
	txt := self txtChatStampFor: ('{1} - {2}' format: {
		(aChatLine at: #timestamp) printRelativeTimeStamp.
		(aChatLine at: #author)}).
		
	"(aChatLine at: #author) = Utilities authorInitials
		ifTrue: [txt append: (self txtHeadFor: ' (You!!)')]."

	^ txt! !

!XpfCtMarkupNode methodsFor: 'public' stamp: 'mt 6/8/2009 10:31'!
creatorFor: aCreatorString

	| txt |
	txt := self txtValueFor: aCreatorString.
		
	"self attribute isMine
		ifTrue: [txt append: (self txtHeadFor: ' (You!!)')]."

	^ txt! !

!XpfCtMarkupNode methodsFor: 'testing' stamp: 'mt 5/30/2009 17:17'!
hasMarkups

	^ false! !

!XpfCtMarkupNode methodsFor: 'testing' stamp: 'mt 5/30/2009 10:26'!
hasSelector

	^ false! !

!XpfCtMarkupNode methodsFor: 'testing' stamp: 'mt 5/30/2009 10:26'!
hasVersions

	^ false! !

!XpfCtMarkupNode methodsFor: 'testing' stamp: 'mt 5/30/2009 17:22'!
isMarkupNode

	^ true! !

!XpfCtMarkupNode methodsFor: 'accessing' stamp: 'mt 5/30/2009 10:41'!
method

	^ method! !

!XpfCtMarkupNode methodsFor: 'accessing' stamp: 'mt 5/30/2009 10:42'!
method: aMethodReference

	method := aMethodReference.! !

!XpfCtMarkupNode methodsFor: 'public' stamp: 'mt 6/2/2009 18:11'!
name

	| result |
	attribute ifNil: [^ '(no attribute)'].
	result := ('{1}>>{2} (#{3})' format: {
		self method theClassName.
		self method methodSymbol.
		self attribute tag}) asText.
	self attribute wasRead ifTrue: [
		result addAttribute: TextColor gray].
	^ result	! !

!XpfCtMarkupNode methodsFor: 'accessing' stamp: 'mt 6/8/2009 11:00'!
snippet

	^ snippet! !

!XpfCtMarkupNode methodsFor: 'accessing' stamp: 'mt 5/30/2009 11:19'!
snippet: anObject

	snippet := anObject.! !

!XpfCtMarkupNode methodsFor: 'public' stamp: 'mt 6/8/2009 10:29'!
text

	| txt |
	txt := '' asText.
	txt
		append: (self txtHeadFor: 'Creator    ');
		append: (self creatorFor: self attribute creator);
		append: String cr asText;
		append: (self txtHeadFor: 'Timestamp  ');
		append: (self txtValueFor: self attribute timestamp printRelativeTimeStamp, String cr);
		append: (self txtHeadFor: 'Tag        ');
		append: (self txtValueFor: '#', self attribute tag, String cr);
		append: (self txtHeadFor: 'Method     ');
		append: (self txtMethodLinkFor: (self txtValueFor: ('{1}>>{2}' format: {self method theClassName. self method methodSymbol}), String cr));
		append: (self txtHeadFor: 'Comment    ');
		append: (self txtCommentFor: ('"{1}"' format: {self attribute comment}), String cr);
		append: (self txtHeadFor: 'Code       ');
		append: (self txtScopeFor: '"', self snippet, '"', String cr);
		append: (self txtSeparator: 50).

	(self attribute chat sortBy: [:line1 :line2 | (line1 at: #timestamp) > (line2 at: #timestamp)])
		do: [:line |
			txt
				append: String cr asText;
				append: (self chatStampFor: line);
				append: String cr asText;
				append: (self chatMessageFor: line);
				append: String cr asText].
	
	self attribute read.
	^ txt! !

!XpfCtMarkupNode methodsFor: 'formatting' stamp: 'mt 6/6/2009 08:46'!
txtChatMessageFor: aString

	^ XpfCodeTalk highlightAuthorInitialsFor:
		(self txtMethodLinkFor: (Text string: aString attribute: TextColor black))! !

!XpfCtMarkupNode methodsFor: 'formatting' stamp: 'mt 6/6/2009 08:55'!
txtChatStampFor: aString

	^ Text string: aString attributes: {TextColor black. TextEmphasis bold}! !

!XpfCtMarkupNode methodsFor: 'formatting' stamp: 'mt 6/11/2009 11:00'!
txtCommentFor: aString

	^ XpfCtMethodLink addMethodLinksInto:
		(Text
			string: aString
			attributes: {TextColor color: Color green muchDarker})! !

!XpfCtMarkupNode methodsFor: 'formatting' stamp: 'mt 6/6/2009 08:19'!
txtHeadFor: aString

	^ Text string: aString attribute: TextColor gray! !

!XpfCtMarkupNode methodsFor: 'formatting' stamp: 'mt 6/6/2009 08:34'!
txtMethodLinkFor: aTextOrString

	^ XpfCtMethodLink addMethodLinksInto: aTextOrString asText! !

!XpfCtMarkupNode methodsFor: 'formatting' stamp: 'mt 6/8/2009 10:33'!
txtScopeFor: aString

	^ Text string: aString attribute: TextColor black! !

!XpfCtMarkupNode methodsFor: 'formatting' stamp: 'mt 6/6/2009 09:31'!
txtSeparator: width

	^ Text
		string: ((String new: width) atAllPut: Character space), String cr
		attributes: {TextColor gray. TextEmphasis struckOut}! !

!XpfCtMarkupNode methodsFor: 'formatting' stamp: 'mt 6/6/2009 08:20'!
txtValueFor: aString

	^ Text string: aString attributes: {TextColor black. TextEmphasis bold}! !

OBCodeNode subclass: #XpfCtSeparatorNode
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Nodes'!

!XpfCtSeparatorNode class methodsFor: 'instance creation' stamp: 'mt 5/25/2009 14:15'!
text: aString

	^ self new
		text: aString! !

!XpfCtSeparatorNode methodsFor: 'testing' stamp: 'mt 5/25/2009 14:47'!
isSeparatorNode

	^ true! !

!XpfCtSeparatorNode methodsFor: 'public' stamp: 'mt 5/25/2009 14:48'!
name

	^ text asText allBold! !

!XpfCtSeparatorNode methodsFor: 'accessing' stamp: 'mt 5/25/2009 14:15'!
text

	^ text! !

!XpfCtSeparatorNode methodsFor: 'accessing' stamp: 'mt 5/25/2009 14:14'!
text: anObject

	text := anObject.! !

!MCMczWriter methodsFor: '*xpf-codetalk' stamp: 'mt 1/17/2010 21:47'!
writeMarkups: aPackageName

	self addString: (self serializeInBinary: (XpfCtMarkupDatabase local snapshot: aPackageName)) at: 'markups.bin'! !

!MCMczWriter methodsFor: '*xpf-codetalk-override' stamp: 'mt 1/22/2010 13:21:06'!
writeVersion: aVersion
	"Override to write markups."

	SwaSourceTextStyler instance disable.

	self writeFormat.
	self writePackage: aVersion package.
	self writeVersionInfo: aVersion info.
	self writeDefinitions: aVersion.
	self writeMarkups: aVersion package name.
	aVersion dependencies do: [:ea | self writeVersionDependency: ea].
	
	SwaSourceTextStyler instance enable.! !

!TimeStamp methodsFor: '*xpf-codetalk' stamp: 'topa 10/27/2009 16:22'!
printRelativeTimeStamp

	^ (self date printRelativeDate, ', ', self time print24WithoutSeconds)! !

!MCVersion methodsFor: '*xpf-codetalk-override' stamp: 'mt 1/17/2010 22:17'!
load

	MCVersionLoader loadVersion: self.
	
	XpfCtMarkupDatabase local merge: self markups.
	
	(Preferences
		preferenceAt: #browseMarkupsAfterLoadMerge
		ifAbsent: [Preference new rawValue: false])
		preferenceValue ifTrue: [ XpfCtMarkupBrowser
			openOn: (OBMonticelloPackageNode on: self package workingCopy)].! !

!MCVersion methodsFor: '*xpf-codetalk' stamp: 'mt 1/17/2010 22:05'!
markups

	^ markups! !

!MCVersion methodsFor: '*xpf-codetalk' stamp: 'mt 1/17/2010 22:06'!
markups: aMarkupDatabase

	markups := aMarkupDatabase! !

!MCVersion methodsFor: '*xpf-codetalk-override' stamp: 'mt 1/17/2010 22:17'!
merge

	MCVersionMerger mergeVersion: self.
	
	XpfCtMarkupDatabase local merge: self markups.
	
	(Preferences
		preferenceAt: #browseMarkupsAfterLoadMerge
		ifAbsent: [Preference new rawValue: false])
		preferenceValue ifTrue: [ XpfCtMarkupBrowser
			openOn: (OBMonticelloPackageNode on: self package workingCopy)].! !

!OBMorphBuilder methodsFor: '*xpf-codetalk' stamp: 'mt 5/27/2009 10:06'!
insertMorph: aMorph

	current ifNotNil: 
			[current addMorphBack: aMorph.
			self current: aMorph do: []].
	^ aMorph! !

!OBMorphBuilder methodsFor: '*xpf-codetalk' stamp: 'mt 6/5/2009 15:52'!
specialScroller: aColumnPanel with: aBlock 
	| morph |
	morph := (XpfCtPaneScroller withModel: aColumnPanel)
				name: 'scroller';
				vResizing: #spaceFill;
				hResizing: #spaceFill;
				yourself.
	current ifNotNil: [current addMorphBack: morph].
	^self current: morph do: aBlock! !

!DataStream methodsFor: '*xpf-codetalk' stamp: 'mt 3/24/2009 15:43'!
references

    ^ Dictionary new! !

TestCase subclass: #XpfCtComplexAttributeTest
	instanceVariableNames: 'sut sut2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Tests'!

!XpfCtComplexAttributeTest methodsFor: 'running' stamp: 'mt 5/28/2009 19:19'!
setUp

	super setUp.
	sut := XpfComplexAttribute forTag: #bad.
	sut
		addChatLine: 'She sells sea shells at the sea shore.';
		creator: Utilities authorInitials, 'test'.
	sut2 := XpfComplexAttribute forTag: #comment.
	sut2 comment: 'This is just a comment'.! !

!XpfCtComplexAttributeTest methodsFor: 'tests' stamp: 'mt 6/8/2009 11:03'!
testChatLineTrimmed

	sut addChatLine: 'Foobar.'.
	self should: (sut chat last at: #message) = 'Foobar.'.
	sut addChatLine: '  
	Foobar.
	  '.
	self should: (sut chat last at: #message) = 'Foobar.'.! !

!XpfCtComplexAttributeTest methodsFor: 'tests' stamp: 'mt 6/8/2009 10:58'!
testCodeSnippet
	"Try to mark something in Collection>>do:. Then get the code snippet of the markup."
	
	| source ref |
	ref := MethodReference class: Collection selector: #do:.
	source := ref sourceCode.
	source addAttribute: sut from: 1 to: 10.
	self should: (sut codeSnippetFor: source) = 'do: aBlock'.! !

!XpfCtComplexAttributeTest methodsFor: 'tests' stamp: 'mt 6/8/2009 11:03'!
testCodeSnippetTrimmed
	
	| source ref |
	ref := MethodReference class: Collection selector: #do:.
	source := ref sourceCode.
	source addAttribute: sut from: 11 to: 18.
	self should: (sut codeSnippetFor: source) = '"Eval'.! !

!XpfCtComplexAttributeTest methodsFor: 'tests' stamp: 'mt 6/8/2009 10:38'!
testCommentTrimmed
	"Remove all trailing or leading blanks from a comment when it is set."
	
	sut comment: 'foobar'.
	self should: sut comment = 'foobar'.
	sut comment: '  foobar  '.
	self should: sut comment = 'foobar'.! !

!XpfCtComplexAttributeTest methodsFor: 'tests' stamp: 'mt 5/28/2009 12:10'!
testInstanceCreation

	self
		should: sut tag = #bad;
		should: sut creator = (Utilities authorInitials, 'test');
		should: sut chat size = 1;
		should: (sut chat first at: #author) = Utilities authorInitials;
		should: sut timestamp <= (sut chat first at: #timestamp)! !

!XpfCtComplexAttributeTest methodsFor: 'tests' stamp: 'mt 6/2/2009 17:59'!
testReading

	XpfComplexAttribute reset. "Clear read cache."
	self
		shouldnt: (XpfComplexAttribute wasRead: sut);
		shouldnt: (XpfComplexAttribute wasRead: sut2).
	XpfComplexAttribute read: sut.
	self
		should: (XpfComplexAttribute wasRead: sut);
		shouldnt: (XpfComplexAttribute wasRead: sut2).
	self
		shouldnt: [XpfComplexAttribute
			read: sut;
			read: sut] raise: Error.! !

!XpfCtComplexAttributeTest methodsFor: 'tests' stamp: 'mt 6/11/2009 23:32'!
testRegex
	
	self should: ('([A-Z]\w*)(\sclass)?>>#?(\w[\w:]*)' asRegex isKindOf: RxMatcher).! !

!XpfCtComplexAttributeTest methodsFor: 'tests' stamp: 'mt 5/2/2009 15:35'!
testScanning

	| stream attr |
	stream := (String new: 500) writeStream.
	sut writeScanOn: stream.
	attr := XpfComplexAttribute scanFrom:
		(stream contents readStream position: 1). "Skip first 'h' to identify complex attribute. See RunArray class>>scanFrom:"
	
	self
		should: sut tag = attr tag;
		should: sut timestamp = attr timestamp;
		should: sut creator = attr creator;
		should: sut chat size = attr chat size;
		should: (sut chat first at: #author) = (attr chat first at: #author);
		should: (sut chat first at: #timestamp) = (attr chat first at: #timestamp);
		should: (sut chat first at: #message) = (attr chat first at: #message)! !

!XpfCtComplexAttributeTest methodsFor: 'tests' stamp: 'mt 5/28/2009 19:22'!
testScanningComments

	| stream attr |
	stream := (String new: 500) writeStream.
	sut2 writeScanOn: stream.
	attr := XpfComplexAttribute scanFrom:
		(stream contents readStream position: 1). "Skip first 'h' to identify complex attribute. See RunArray class>>scanFrom:"
	
	self
		should: sut2 tag = attr tag;
		should: sut2 comment = attr comment.! !

!XpfCtComplexAttributeTest methodsFor: 'tests' stamp: 'mt 5/18/2009 10:31'!
testTagAcccessing

	self should: sut tag = #bad.
	sut tag: #'0'.
	self should: sut tag isNil.
	sut tag: #talk.
	self should: sut tag = #talk.
	sut tag: #shouldNotBeAllowed.
	self should: sut tag isNil.! !

TestCase subclass: #XpfCtDatabaseTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Tests'!

!XpfCtDatabaseTest methodsFor: 'as yet unclassified' stamp: 'mt 1/16/2010 15:11'!
setUp

	super setUp.
	sut := XpfCtMarkupDatabase new.! !

!XpfCtDatabaseTest methodsFor: 'as yet unclassified' stamp: 'mt 1/16/2010 15:28'!
testClassRecord

	| class record |
	class := XpfCtClassRecord.
	record := XpfCtClassRecord newFrom: class.
	
	self
		should: record theClassName = #XpfCtClassRecord;
		should: record theClass = class;
		should: record methodRecords isEmpty;
		shouldnt: (record includes: #theClassName);
		should: record methodRecords isEmpty;
		should: ((record at: #theClassName) isKindOf: XpfCtMethodRecord);
		should: (record includes: #theClassName);
		shouldnt: record methodRecords isEmpty.
! !

!XpfCtDatabaseTest methodsFor: 'as yet unclassified' stamp: 'mt 1/16/2010 15:32'!
testInitialState

	self
		should: sut classRecords isEmpty;
		should: sut packageRecords isEmpty! !

!XpfCtDatabaseTest methodsFor: 'as yet unclassified' stamp: 'mt 1/16/2010 15:23'!
testMethodRecord

	| method record |
	method := XpfCtMethodRecord>>#atSeconds:.
	record := XpfCtMethodRecord newFrom: method.
	record addVersion: method.
	
	self
		should: record selector = #atSeconds:;
		should: ((record at: method) isKindOf: Collection);
		should: (record at: method) isEmpty.
	! !

!XpfCtDatabaseTest methodsFor: 'as yet unclassified' stamp: 'mt 1/16/2010 15:57'!
testMethodRecordVersion

	| method record |
	method := XpfCtMethodRecord>>#atSeconds:.
	record := XpfCtMethodRecord newFrom: method.
	
	record addVersion: 0. "use dummy timestamp"
	(record markups at: 0) add: XpfCtMarkup new.
		
	self should: (record at: method) = (record markups at: 0).

	record copyLastVersion.
	
	self
		shouldnt: (record at: method) = (record markups at: 0);
		should: (record at: method) size = 1.! !

TestCase subclass: #XpfCtMarkupTest
	instanceVariableNames: 'sut sut2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Tests'!

!XpfCtMarkupTest methodsFor: 'running' stamp: 'mt 1/16/2010 16:27'!
setUp

	super setUp.
	sut := XpfCtMarkup forTag: #bad.
	sut
		addChatLine: 'She sells sea shells at the sea shore.';
		creator: Utilities authorInitials, 'test'.
	sut2 := XpfCtMarkup forTag: #comment.
	sut2 comment: 'This is just a comment'.! !

!XpfCtMarkupTest methodsFor: 'tests' stamp: 'mt 1/16/2010 16:27'!
testChatLineTrimmed

	sut addChatLine: 'Foobar.'.
	self should: (sut chat last at: #message) = 'Foobar.'.
	sut addChatLine: '  
	Foobar.
	  '.
	self should: (sut chat last at: #message) = 'Foobar.'.! !

!XpfCtMarkupTest methodsFor: 'tests' stamp: 'mt 1/16/2010 16:28'!
testCommentTrimmed
	"Remove all trailing or leading blanks from a comment when it is set."
	
	sut comment: 'foobar'.
	self should: sut comment = 'foobar'.
	sut comment: '  foobar  '.
	self should: sut comment = 'foobar'.! !

!XpfCtMarkupTest methodsFor: 'tests' stamp: 'mt 1/16/2010 16:28'!
testInstanceCreation

	self
		should: sut tag = #bad;
		should: sut creator = (Utilities authorInitials, 'test');
		should: sut chat size = 1;
		should: (sut chat first at: #author) = Utilities authorInitials;
		should: sut timestamp <= (sut chat first at: #timestamp)! !

!XpfCtMarkupTest methodsFor: 'tests' stamp: 'mt 1/16/2010 16:28'!
testReading

	XpfCtMarkup reset. "Clear read cache."
	self
		shouldnt: (XpfCtMarkup wasRead: sut);
		shouldnt: (XpfCtMarkup wasRead: sut2).
	XpfCtMarkup read: sut.
	self
		should: (XpfCtMarkup wasRead: sut);
		shouldnt: (XpfCtMarkup wasRead: sut2).
	self
		shouldnt: [XpfCtMarkup
			read: sut;
			read: sut] raise: Error.! !

!XpfCtMarkupTest methodsFor: 'tests' stamp: 'mt 1/16/2010 16:28'!
testRegex
	
	self should: ('([A-Z]\w*)(\sclass)?>>#?(\w[\w:]*)' asRegex isKindOf: RxMatcher).! !

!XpfCtMarkupTest methodsFor: 'tests' stamp: 'mt 1/16/2010 16:28'!
testTagAcccessing

	self should: sut tag = #bad.
	sut tag: #'0'.
	self should: sut tag isNil.
	sut tag: #talk.
	self should: sut tag = #talk.
	sut tag: #shouldNotBeAllowed.
	self should: sut tag isNil.! !

TestCase subclass: #XpfCtMonticelloTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Tests'!

!XpfCtMonticelloTest class methodsFor: 'marking' stamp: 'cs 5/4/2009 02:05'!
markCollection: anAttribute

	| source ref |
	ref := MethodReference class: Collection selector: #do:.
	source := ref sourceCode.
	(source attributesOfKind: XpfComplexAttribute)
		do: [:att | source removeAttribute: att ].
	source addAttribute: anAttribute from: 1 to: 1.
	Collection compile: source classified: ref category.
	^ ref! !

!XpfCtMonticelloTest class methodsFor: 'marking' stamp: 'mt 5/5/2009 15:05'!
markCollectionDoBad
	^ self markCollection: (XpfComplexAttribute forTag: #bad)! !

!XpfCtMonticelloTest class methodsFor: 'marking' stamp: 'cs 5/2/2009 12:58'!
markCollectionDoNormal

	| source ref |
	ref := MethodReference class: Collection selector: #do:.
	source := ref sourceCode.
	Collection compile: source asString classified: ref category.
	^ ref! !

!XpfCtMonticelloTest methodsFor: 'tests' stamp: 'mt 5/5/2009 15:05'!
testAddCodeMarkup
	| ref source md snapshotBin md2 color |
	ref := self class markCollectionDoBad.
	source := ref sourceCode.
	color := ((source attributesAt: 1) detect: [ :attr | attr isKindOf: XpfComplexAttribute ]) color.
	md := (Collection compiledMethodAt: #do:) methodReference asMethodDefinition.
	snapshotBin := MCMczWriter new serializeInBinary: (MCSnapshot fromDefinitions: {  md  }).
	md2 := (DataStream on: ((RWBinaryOrTextStream with: snapshotBin)
			reset;
			yourself)) next definitions first.
	self
		should: md2 source isString;
		should: md2 sourceText isText;
		should: md source = md2 source;
		should: ((md2 sourceText attributesAt: 1) anySatisfy: [ :attr | (attr isKindOf: XpfComplexAttribute) and: [ attr color = color ] ]).

	"Clean up"
	self class markCollectionDoNormal! !

!XpfCtMonticelloTest methodsFor: 'tests' stamp: 'mt 4/20/2009 16:17'!
testDefinitionFromReference

	| ref cm md |
	ref := MethodReference class: Collection selector: #do:.
	cm := Collection compiledMethodAt: #do:.
	md := ref asMethodDefinition.
	
	self
		should: cm getSource = ref sourceCode;
		should: ref sourceCode isText;
		should: ref source isString;
		should: md source isString;
		should: md sourceText isText.! !

TestCase subclass: #XpfCtTextTest
	instanceVariableNames: 'sut att1 att2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Tests'!

!XpfCtTextTest methodsFor: 'running' stamp: 'mt 5/5/2009 15:06'!
setUp
	
	super setUp.
	
	sut := 'The quick brown fox jumps over the lazy dog.' asText.
	att1 := XpfComplexAttribute forTag: #talk.
	att2 := XpfComplexAttribute forTag: #bad.! !

!XpfCtTextTest methodsFor: 'tests' stamp: 'mt 5/2/2009 10:19'!
testAttributesOfKind

	| atts |
	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	
	atts := sut attributesOfKind: att1 class.
	
	self
		should: atts size = 2;
		should: atts first == att1;
		should: atts second == att2.! !

!XpfCtTextTest methodsFor: 'tests' stamp: 'mt 5/18/2009 11:14'!
testAttributesOfKindFromTo

	| atts1 atts2 atts3 atts4 atts5 |
	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	
	atts1 := sut attributesOfKind: att1 class from: 1 to: 5.
	atts2 := sut attributesOfKind: att2 class from: 6 to: 10.
	atts3 := sut attributesOfKind: att1 class from: 1 to: 10.
	atts4 := sut attributesOfKind: att1 class from: 5 to: 5.
	atts5 := sut attributesOfKind: att1 class from: 5 to: 4.
	
	self
		should: atts1 size = 1;
		should: atts2 size = 1;
		should: atts3 size = 2;
		should: atts4 size = 1;
		should: atts5 size = 1;
		should: atts1 first == att1;
		should: atts2 first == att2;
		should: atts3 first == att1;
		should: atts3 second == att2;
		should: atts4 first == att1;
		should: atts5 first == att1.! !

!XpfCtTextTest methodsFor: 'tests' stamp: 'mt 5/2/2009 10:24'!
testIncludesAttributesOfKind

	sut addAttribute: att1 from: 1 to: 1.
	self should: (sut includesAttributesOfKind: att1 class).! !

!XpfCtTextTest methodsFor: 'tests' stamp: 'mt 5/3/2009 18:35'!
testIncludesAttributesOfKindFromTo

	sut addAttribute: att1 from: 1 to: 2.
	self
		should: (sut includesAttributesOfKind: att1 class from: 1 to: 2);
		shouldnt: (sut includesAttributesOfKind: att1 class from: 3 to: 4).! !

!XpfCtTextTest methodsFor: 'tests' stamp: 'mt 5/2/2009 10:27'!
testRemoveAttribute

	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	sut removeAttribute: att1.
		
	self
		should: (sut includesAttributesOfKind: att1 class);
		shouldnt: ((sut attributesOfKind: att1 class) includes: att1);
		should: ((sut attributesOfKind: att1 class) includes: att2).! !

!XpfCtTextTest methodsFor: 'tests' stamp: 'mt 5/2/2009 10:28'!
testRemoveAttributeAround

	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	sut removeAttribute: att1 around: 5.
	sut removeAttribute: att2 around: 5.
		
	self
		should: (sut includesAttributesOfKind: att1 class);
		shouldnt: ((sut attributesOfKind: att1 class) includes: att1);
		should: ((sut attributesOfKind: att1 class) includes: att2).! !

!XpfCtTextTest methodsFor: 'tests' stamp: 'mt 5/2/2009 10:30'!
testRemoveAttributeAroundAnd

	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	sut removeAttribute: att1 around: 4 and: 6.
		
	self
		should: (sut includesAttributesOfKind: att1 class);
		shouldnt: ((sut attributesOfKind: att1 class) includes: att1);
		should: ((sut attributesOfKind: att1 class) includes: att2).! !

!XpfCtTextTest methodsFor: 'tests' stamp: 'mt 5/2/2009 10:32'!
testRemoveAttributeFromTo

	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	sut removeAttribute: att1 from: 1 to: 5.
	sut removeAttribute: att2 from: 6 to: 9.
		
	self
		should: (sut includesAttributesOfKind: att1 class);
		shouldnt: ((sut attributesOfKind: att1 class) includes: att1);
		should: ((sut attributesOfKind: att1 class) includes: att2).! !

OBPanel subclass: #XpfCtProgressPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Panels'!

!XpfCtProgressPanel methodsFor: 'as yet unclassified' stamp: 'mt 6/3/2009 10:27'!
buildOn: aBuilder

	| bar button row |
	bar := (XpfCtPluggableProgressBarMorph
		newFor: self browser root metaNode filters first inspector
		value: #currentStep
		max: #maxSteps)
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	button := XpfCtButton
		on: self browser root metaNode filters first inspector
		action: #stop
		icon: #xpfCtCrossIcon
		label: 'Stop'.
	row := PanelMorph new
		changeTableLayout;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		listDirection: #leftToRight;
		addMorphBack: bar;
		addMorphBack: button.
		
	^ aBuilder insertMorph: row.! !

!XpfCtProgressPanel methodsFor: 'as yet unclassified' stamp: 'mt 5/30/2009 18:34'!
vResizing

	^ #rigid! !

OBPanel subclass: #XpfCtToolbar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Panels'!

!XpfCtToolbar methodsFor: 'actions' stamp: 'mt 6/11/2009 17:47'!
addChat
	
	self textMorph editor addCodeChat.! !

!XpfCtToolbar methodsFor: 'actions' stamp: 'mt 5/30/2009 19:43'!
addChatLabel
	
	^ self
		labelMorphWithIcon: MenuIcons xpfCtSmallMarkCommentIcon
		text: 'add code chat'! !

!XpfCtToolbar methodsFor: 'actions' stamp: 'mt 6/11/2009 17:47'!
addComment
	
	self textMorph editor addComment.! !

!XpfCtToolbar methodsFor: 'actions' stamp: 'mt 5/30/2009 19:43'!
addCommentLabel
	
	^ self
		labelMorphWithIcon: MenuIcons xpfCtSmallAddCommentIcon
		text: 'add comment'! !

!XpfCtToolbar methodsFor: 'building' stamp: 'mt 1/22/2010 13:22:57'!
buildOn: aMorphBuilder

	| row head |
	head := 'CodeTalk' asText.
	head addAttribute: (TextColor color: Color gray).
	head addAttribute: (TextFontReference toFont: (XpfFontProvider sansFontAt: 8)).
	row := PanelMorph new
		changeTableLayout;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		listDirection: #leftToRight;
		borderWidth: 1;
		borderRaised;
		cellInset: 5;
		fillStyle: (Color r: 0.8 g: 0.8 b: 0.8 alpha: 0.5);
		addMorphBack: (PanelMorph new vResizing: #rigid; hResizing: #rigid; fillStyle: Color transparent; extent: 3@3);
		addMorphBack: head asMorph;
		addMorphBack: self dot;
		addMorphBack: (self newButton: #addComment);
		addMorphBack: (self newButton: #addChat);
		addMorphBack: (self newButton: #markBad);
		addMorphBack: self dot;
		addMorphBack: (self newButton: #convertInlineComment).
"		addMorphBack: self dot;
		addMorphBack: (self newButton: #markForRefactoring).
"	
	aMorphBuilder insertMorph: row.! !

!XpfCtToolbar methodsFor: 'actions' stamp: 'mt 6/11/2009 17:48'!
convertInlineComment
	
	self textMorph editor convertInlineComment.! !

!XpfCtToolbar methodsFor: 'actions' stamp: 'mt 6/6/2009 13:35'!
convertInlineCommentLabel
	
	^ self
		labelMorphWithIcon: MenuIcons xpfCtCommentGoIcon
		text: 'convert inline comment'! !

!XpfCtToolbar methodsFor: 'building' stamp: 'mt 5/30/2009 19:38'!
dot

	^ PanelMorph new
		hResizing: #rigid;
		vResizing: #rigid;
		fillStyle: Color gray;
		extent: 2@2! !

!XpfCtToolbar methodsFor: 'building' stamp: 'topa 1/4/2010 10:34'!
labelMorphWithIcon: anIcon text: aString

	| lm lbl |

	lm := PanelMorph new
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 4.
	
	lbl := aString asText.
	lbl
		"addAttribute: (TextColor color: Color gray muchDarker);"
		addAttribute: (TextFontReference toFont: (XpfFontProvider sansFontAt: 8)).
		
	lm
		addMorphBack: anIcon asMorph;
		addMorphBack: lbl asMorph lock.

	^ lm! !

!XpfCtToolbar methodsFor: 'actions' stamp: 'mt 6/11/2009 17:48'!
markBad
	
	self textMorph editor markAsBad.! !

!XpfCtToolbar methodsFor: 'actions' stamp: 'mt 5/30/2009 19:43'!
markBadLabel

	^ self
		labelMorphWithIcon: MenuIcons xpfCtSmallMarkBadIcon
		text: 'mark bad'! !

!XpfCtToolbar methodsFor: 'actions' stamp: 'bs 12/15/2009 13:12'!
markForRefactoring
	
	self textMorph editor markForRefactoring.! !

!XpfCtToolbar methodsFor: 'actions' stamp: 'bs 12/15/2009 13:12'!
markForRefactoringLabel

	^ self
		labelMorphWithIcon: MenuIcons xpfCtSmallMarkBadIcon
		text: 'mark for refactoring'! !

!XpfCtToolbar methodsFor: 'building' stamp: 'mt 5/30/2009 19:49'!
newButton: aSymbol

	^ (PluggableButtonMorphPlus
		on: self
		getState: nil
		action: aSymbol
		label: (aSymbol, #Label) asSymbol)
		borderWidth: 0;
		height: 16;
		onColor: Color white offColor: Color gray muchLighter.! !

!XpfCtToolbar methodsFor: 'private' stamp: 'mt 6/23/2009 09:57'!
textMorph
	"Definition panel should be an OBEnhancementDefinitionPanel."
	
	^ self browser definitionPanel contentMorph textMorph! !

!XpfCtToolbar methodsFor: 'private' stamp: 'mt 5/30/2009 18:38'!
vResizing

	^ #rigid! !

PanelMorph subclass: #XpfCtMessageMorph
	instanceVariableNames: 'timestamp author message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtMessageMorph class methodsFor: 'instance creation' stamp: 'mt 5/3/2009 10:53'!
timestamp: aTimeStamp author: aString message: messageString

	^ self new
		author: aString;
		timestampContent: aTimeStamp;
		messageContent: messageString! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 4/30/2009 09:03'!
author

	author ifNil: [author := ''].
	^ author! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 4/30/2009 09:04'!
author: aString

	author := aString! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 5/3/2009 14:28'!
highlightIf: aString
	"Change backgroundcolor if the string is in the message."
	
	(self message contents asString asLowercase includesSubString: aString asLowercase)
		ifTrue: [self color: Color yellow].! !

!XpfCtMessageMorph methodsFor: 'initialization' stamp: 'mt 5/2/2009 18:04'!
initialize

	super initialize.
	self
		changeTableLayout;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		listDirection: #topToBottom;
		borderWidth: 0;
		layoutInset: 2;
		cellInset: 0;
		fillStyle: Color white;
		width: XpfCtCodeChatMorph defaultExtent x;
		initializeUserInterface.! !

!XpfCtMessageMorph methodsFor: 'initialization' stamp: 'mt 4/30/2009 09:04'!
initializeUserInterface

	self
		addMorphBack: self timestamp;
		addMorphBack: self message.! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 6/4/2009 16:36'!
message

	message ifNil: [message := TextMorph new
		hResizing: #spaceFill;
		vResizing: #rigid].
	^ message! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'topa 1/4/2010 10:34'!
messageContent: aString

	self message contentsWrapped: aString asText.
	self message font: (XpfFontProvider sansFontAt: 10).
	XpfCtMethodLink addMethodLinksInto: self message contents.
	XpfCodeTalk highlightAuthorInitialsFor: self message contents.! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 6/5/2009 14:27'!
parseAuthorInitials

	| rx s strm links |
	rx := ('\\<{1}\\>' format: {Utilities authorInitials}) asRegex.
	s := self message contents asString.
	strm := s readStream.
	links := OrderedCollection new.
	
	[rx searchStream: strm]
		whileTrue: [
			links add: {
				rx subBeginning: 1.
				rx subEnd: 1}].

	links do: [:link |
		self message contents
			addAttribute: TextColor red
			from: link first + 1
			to: link second].! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 4/30/2009 09:24'!
timestamp

	timestamp ifNil: [timestamp := TextMorph new
		hResizing: #spaceFill;
		vResizing: #rigid;
		lock].
	^ timestamp! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'topa 1/4/2010 10:34'!
timestampContent: aTimeStamp
	"Add the given timestamp and the authors initials to the text entry."
	
	| text |
	text := '{1} - {2}:' format: {aTimeStamp printRelativeTimeStamp. self author}.
	self timestamp contents: text.
	self timestamp font: ((XpfFontProvider sansFontAt: 8) emphasized: (TextEmphasis bold emphasisCode)).
	! !

PanelMorph subclass: #XpfCtRowMorph
	instanceVariableNames: 'lastPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfCtRowMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/1/2009 17:18'!
for: someMorphs

	| instance |
	instance := self new.
	someMorphs do: [:m | instance addMorphBack: m].
	^ instance! !

!XpfCtRowMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 14:12'!
initialize

	super initialize.
	self
		changeTableLayout;
		listDirection: #leftToRight;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		layoutInset: 3;
		useRoundedCorners;
		cellInset: 3;
		color: (Color r: 4 g: 133 b: 157 alpha: 0.9).! !

!XpfCtRowMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 14:12'!
position: aPoint

	aPoint = lastPosition ifTrue: [^ self].
	lastPosition := aPoint.
	super position: aPoint.! !

OBTextMorphEditorWithShout subclass: #XpfEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfEditor class methodsFor: 'initialization' stamp: 'mt 6/23/2009 09:41'!
initializeCmdKeyShortcuts

	super initializeCmdKeyShortcuts.
	CmdActions
		at: ($t asInteger + 1) put: #sAddCodeChat:;
		at: ($r asInteger + 1) put: #sMarkAsBad:.! !

!XpfEditor methodsFor: 'editing' stamp: 'mt 1/21/2010 16:25'!
accept

	| result txt |
	txt := self text.
	result := super accept.

	self
		storeMarkupsForCompiledMethod: self compiledMethod
		source: txt;
		forceRestyleFor: self compiledMethod.
	
	^ result! !

!XpfEditor methodsFor: 'actions' stamp: 'mt 1/17/2010 15:14'!
addCodeChat

	self tagSelectionWith: #talk.! !

!XpfEditor methodsFor: 'actions' stamp: 'mt 1/17/2010 15:48'!
addComment

	self tagSelectionWith: #comment.! !

!XpfEditor methodsFor: 'private' stamp: 'mt 1/17/2010 16:28'!
addMarkup: aMarkup

	XpfCtSourceTextStyler new
		styleSource: self text
		markup: aMarkup
		inClass: self theClass
		selector: self selector.
	
	"Set dependent for new reference attribute to let iconic buttons work."
	((self text attributesOfKind: XpfCtReferenceAttribute)
		detect: [:attr | attr markup = aMarkup]) addDependent: morph.
		
	morph changed. "force redraw"! !

!XpfEditor methodsFor: 'actions' stamp: 'mt 1/17/2010 16:59'!
changeMarkupTag

	| result |
	result := UITheme current
		chooseDropListIn: self morph
		text: 'Select a new tag:'
		title: 'Change Markup Tag' list: XpfCtMarkup tags.
		
	result ifNil: [^ self].
	
	self changeTagInSelectionTo: result.! !

!XpfEditor methodsFor: 'initialize-release' stamp: 'mt 1/22/2010 13:06:17'!
changeParagraph: aParagraph
	"Add a back reference to the textmorph to the paragraph."

	super changeParagraph: aParagraph.
	(aParagraph isKindOf: XpfParagraph) & (morph isKindOf: XpfTextMorph)
		ifTrue: [
			aParagraph textMorph: morph.
			morph removeAllMorphs.
			(aParagraph text attributesOfKind: XpfCtReferenceAttribute)
				do: [:attr | attr addDependent: morph]].! !

!XpfEditor methodsFor: 'editing' stamp: 'mt 1/17/2010 17:22'!
changeTagInSelectionTo: aSymbol
	"Used to change the tag (#bad, #talk) )of an attribute in the text."

	| attrs |
	attrs := self text
		attributesOfKind: XpfCtReferenceAttribute
		from: self startIndex
		to: self stopIndex - 1.
		
	attrs	do: [:ref |
		ref markup tag: aSymbol.
		(ref friends
			detect: [:friend | friend isKindOf: XpfCtTextBackgroundColor])
			color: ref markup color.
		(ref friends
			detect: [:friend | friend isKindOf: XpfCtIconBarAttribute])
			mode: ref markup tag].
	morph changed.
! !

!XpfEditor methodsFor: 'accessing' stamp: 'mt 1/17/2010 20:21'!
compiledMethod

	self theClass ifNil: [^ nil].
	self selector ifNil: [^ nil].
	^ self theClass >> self selector! !

!XpfEditor methodsFor: 'actions' stamp: 'mt 6/11/2009 17:32'!
convertInlineComment
	"Convenient method that creates a custom text selection."

	self convertInlineComment:
		(OBTextSelection on: self selectionInterval inText: self text).! !

!XpfEditor methodsFor: 'actions' stamp: 'mt 1/17/2010 16:54'!
convertInlineComment: aTextSelection

	(self doConvertInlineComment: aTextSelection)
		ifTrue: [self userHasEdited].! !

!XpfEditor methodsFor: 'private' stamp: 'mt 1/17/2010 18:06'!
copyLastVersion: aMethodRecord
	"Enable copy-on-write in the database and refresh present references."

	aMethodRecord copyLastVersion "copy-on-write"
		ifNotEmptyDo: [:mapping |
			(self text attributesOfKind: XpfCtReferenceAttribute) do: [:ref |
				ref markup: (mapping at: ref markup)]].! !

!XpfEditor methodsFor: 'private' stamp: 'mt 1/18/2010 09:26'!
detachAllMarkups
	"Follow all references to the markups, clone them and be prepared for non-live-edit-mode."

	(self text attributesOfKind: XpfCtReferenceAttribute)
		do: [:ref | ref markup: ref markup clone].! !

!XpfEditor methodsFor: 'editing' stamp: 'mt 1/17/2010 16:57'!
doConvertInlineComment: aTextSelection
	"Scan comments in text selection and put them into a complex attribute."

	| ranges result commentData markup |
	(aTextSelection fullText
		includesAttributesOfKind: XpfCtReferenceAttribute
		from: aTextSelection start
		to: aTextSelection stop)
		ifTrue: [^ false]. "Must not overwrite other attributes!!"
	
	ranges := SHParserST80 new parseSource: aTextSelection fullText.
	result := aTextSelection text asString.
	commentData := ''.
	
	ranges 
		select: [:range | range isComment] 
		thenDo: [:range |
			(range start >= aTextSelection start and: [range end <= aTextSelection stop])
				ifTrue: [ | comment | 
					comment := aTextSelection fullText asString copyFrom: range start to: range end.
					result := result copyReplaceAll: comment with: '' asTokens: false. 
					commentData := commentData, comment withoutQuoting, String cr, String cr]].
	
	commentData isEmpty | result isEmpty
		ifTrue: [^ false].
	
	markup := XpfCtMarkup forTag: #comment.
	markup
		comment: commentData;
		range: (aTextSelection start to: aTextSelection start + result size - 1).
	
	self
		replaceSelectionWith: result asText;
		addMarkup: markup.

	^ true! !

!XpfEditor methodsFor: 'private' stamp: 'mt 1/21/2010 16:25'!
forceRestyleFor: aCompiledMethod
	"Remove all CodeTalk text attributes from text and reset them."
	
	(morph text attributesOfKind: XpfCtTextAttribute)
		do: [:attr | morph text removeAttribute: attr].
		
	XpfCtSourceTextStyler new
		styleSource: morph text
		of: aCompiledMethod.

	(morph text attributesOfKind: XpfCtReferenceAttribute)
		do: [:attr | attr addDependent: morph]. "to make the icons work"
		
	morph changed.! !

!XpfEditor methodsFor: 'testing' stamp: 'mt 1/17/2010 14:53'!
isInLiveEditMode
	"Live edit mode enables the developer to add, edit or delete markups without the need to save the method and create a new version. Once the developer changed something in the method's source, live-edit-mode will be disabled. A save operation will then trigger a new markup version for the method."
	
	^ morph hasUnacceptedEdits not! !

!XpfEditor methodsFor: 'actions' stamp: 'mt 1/17/2010 15:48'!
markAsBad

	self tagSelectionWith: #bad.! !

!XpfEditor methodsFor: 'actions' stamp: 'bs 12/15/2009 14:15'!
markForRefactoring
	| definition |
	self startIndex = self stopIndex ifTrue: [^ false].
	self model isDefinition ifTrue: [
		definition := self model getDefinition.
		Transcript cr; show: definition asString.
		(definition isKindOf: OBMethodDefinition) ifTrue: [
			Transcript cr; show: definition compileSelector asString] ]
	"(self tagSelectionWith: #bad)
		ifTrue: [self userHasEdited]."! !

!XpfEditor methodsFor: 'private' stamp: 'mt 1/17/2010 16:28'!
removeAttribute: aReferenceAttribute

	aReferenceAttribute friends do: [:attr |
		self text removeAttribute: attr].
	self text removeAttribute: aReferenceAttribute.
	
	morph changed. "force redraw"! !

!XpfEditor methodsFor: 'actions' stamp: 'mt 1/17/2010 15:05'!
removeMarkup

	self untagSelection.! !

!XpfEditor methodsFor: 'actions' stamp: 'mt 1/17/2010 18:08'!
removeMarkup: aReferenceAttribute

	self isInLiveEditMode
		ifTrue: [ | record |
			record := (XpfCtMarkupDatabase local at: aReferenceAttribute theClass)
				at: aReferenceAttribute selector.
			self copyLastVersion: record. "copy-on-write"
			record lastVersion remove: aReferenceAttribute markup].

	self removeAttribute: aReferenceAttribute.! !

!XpfEditor methodsFor: 'actions' stamp: 'mt 1/17/2010 16:26'!
resizeMarkup

	self resizeTagInSelection.! !

!XpfEditor methodsFor: 'editing' stamp: 'mt 1/17/2010 17:23'!
resizeTagInSelection
	"Used to grow or shrink the extent of an attribute in the text."

	| attrs markup |
	self startIndex = self stopIndex ifTrue: [^ false].
	attrs := self text
		attributesOfKind: XpfCtReferenceAttribute
		from: self startIndex
		to: self stopIndex - 1.
	
	attrs size > 1
		ifTrue: [^ self. "Can only modify one attribute here."].
	
	markup := attrs first markup.
	markup range: (self startIndex to: self stopIndex - 1).
	self
		removeAttribute: attrs first;
		addMarkup: markup.! !

!XpfEditor methodsFor: 'actions-shortcuts' stamp: 'mt 6/23/2009 09:42'!
sAddCodeChat: aCharacterStream
	"This method is intended to be used only via the shortcut mechanism. The stream will not be used."
	
	self addCodeChat.
	^ true! !

!XpfEditor methodsFor: 'actions-shortcuts' stamp: 'mt 6/23/2009 09:42'!
sAddComment: aCharacterStream
	"This method is intended to be used only via the shortcut mechanism. The stream will not be used."
	
	self addComment.
	^ true! !

!XpfEditor methodsFor: 'actions-shortcuts' stamp: 'mt 6/23/2009 09:42'!
sMarkAsBad: aCharacterStream
	"This method is intended to be used only via the shortcut mechanism. The stream will not be used."
	
	self markAsBad.
	^ true! !

!XpfEditor methodsFor: 'accessing' stamp: 'mt 1/17/2010 15:40'!
selector

	self model isDefinition ifTrue: [
		| def |
		def := self model getDefinition.
		(def isKindOf: OBMethodDefinition) ifTrue: [
			^ def selector]].
	^ nil! !

!XpfEditor methodsFor: 'private' stamp: 'mt 1/21/2010 15:26'!
storeMarkupsForCompiledMethod: aCompiledMethod source: aText

	| markupsChanged markups record someReferences |
	someReferences := aText attributesOfKind: XpfCtReferenceAttribute.
	
	someReferences ifEmpty: [
		"Avoid empty garbage in the database."
		(XpfCtMarkupDatabase local includes: self theClass)
			ifTrue: [| classRecord |
				classRecord := XpfCtMarkupDatabase local at: self theClass.
				(classRecord includes: self selector)
					ifTrue: [| methodRecord |
						methodRecord := classRecord at: self selector.
						(methodRecord markups notEmpty and: [(methodRecord at: aCompiledMethod) notEmpty])
							ifTrue: [methodRecord clearLastVersion]]].
		^ self].
	
	markupsChanged := false.
	record := (XpfCtMarkupDatabase local
		at: self theClass)
			at: self selector.
	markups := record at: aCompiledMethod.
	
	(markups allSatisfy: [:markup |
		someReferences anySatisfy: [:ref | 
			(XpfCtMarkup uniqueArrayFor: ref markup) = (XpfCtMarkup uniqueArrayFor: markup)
				and: [markup range = (aText find: ref)]]])
		ifTrue: [^ self "nothing changed"].
		
	record clearLastVersion. "implies-copy-on-write"
	record lastVersion addAll: (someReferences collect: [:ref |
		| m |
		m := ref markup.
		m range: (aText find: ref).
		m]).
! !

!XpfEditor methodsFor: 'editing' stamp: 'mt 1/17/2010 18:18'!
tagSelectionWith: aSymbol
	"Tag the selected code or text with the symbol."

	| markup |
	self startIndex = self stopIndex ifTrue: [^ self].
	markup := XpfCtMarkup forTag: aSymbol.
	markup range: (self startIndex to: self stopIndex - 1).

	self isInLiveEditMode
		ifTrue: [ | record |
			record := (XpfCtMarkupDatabase local at: self theClass)
				at: self selector.
			self copyLastVersion: record. "copy-on-write"
			(record at: self theClass >> self selector) add: markup].
	
	self addMarkup: markup.! !

!XpfEditor methodsFor: 'accessing' stamp: 'mt 1/17/2010 15:40'!
theClass

	self model isDefinition ifTrue: [
		| def |
		def := self model getDefinition.
		(def isKindOf: OBMethodDefinition) ifTrue: [
			^ def theClass]].
	^ nil! !

!XpfEditor methodsFor: 'editing' stamp: 'mt 1/17/2010 15:06'!
untagSelection

	(self text
		attributesOfKind: XpfCtReferenceAttribute
		from: self startIndex
		to: self stopIndex - 1) do: [:attr |
			self removeMarkup: attr].! !

!XpfEditor methodsFor: 'backspace handling' stamp: 'mt 1/17/2010 21:03'!
userHasEdited

	morph hasUnacceptedEdits
		ifFalse: [self detachAllMarkups "only do it once"].
	^ super userHasEdited
	! !

!OBMethodVersion methodsFor: '*xpf-codetalk-override' stamp: 'mt 5/3/2009 09:39'!
source

	| file |
	file := sources at: (sources fileIndexFromSourcePointer: pointer).
	file position: (sources filePositionFromSourcePointer: pointer).
	^ file nextChunkText makeSelectorBold! !

!OBTextSelection methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 18:39'!
start

	^ selection first! !

!OBTextSelection methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 18:39'!
stop

	^ selection last! !

SHTextStylerST80 subclass: #XpfTextStyler
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfTextStyler methodsFor: 'private' stamp: 'mt 1/17/2010 12:08'!
privateStyle: aText

	XpfCtTextAttribute shoutShouldPreserve: true.
	super privateStyle: aText.
! !

!XpfTextStyler methodsFor: 'private' stamp: 'mt 1/17/2010 13:30'!
setAttributesIn: aText fromRanges: ranges
	"CodeTalk: Reimplemented due to strange interpretation of #shoutShouldPreserve."

	| charAttr defaultAttr attr newRuns newValues lastAttr oldRuns lastCount | 		
		
	oldRuns := aText runs.
	defaultAttr := self attributesFor: #default.
	charAttr := Array new: aText size.
	1 to: charAttr size do: [:i | charAttr at: i put: defaultAttr].
	ranges do: [:range |
		(attr := self attributesFor: range type) == nil
			ifFalse:[	range start to: range end do: [:i | charAttr at: i put: attr]]].
	newRuns := OrderedCollection new: charAttr size // 10.
	newValues := OrderedCollection new: charAttr size // 10.
	1 to: charAttr size do: [:i |
		attr := charAttr at: i.
		i = 1 
			ifTrue: [
				newRuns add: 1.
				lastCount := 1.
				lastAttr := newValues add: attr]
			ifFalse:[
				attr == lastAttr
					ifTrue: [
						lastCount := lastCount + 1.
						newRuns at: newRuns size put: lastCount]
					ifFalse: [
						newRuns add: 1.
						lastCount := 1.
						lastAttr := newValues add: attr]]].	
	aText runs: (RunArray runs: newRuns values: newValues).
	oldRuns withStartStopAndValueDo:[:start :stop :attribs|
		attribs do: [:eachAttrib | eachAttrib shoutShouldPreserve
			ifTrue: [aText addAttribute: eachAttrib from: start to: stop]]].
	! !

!XpfTextStyler methodsFor: 'converting' stamp: 'mt 1/22/2010 12:59:32'!
unstyledTextFrom: aText
	"Avoid to write custom attributes into the changes file."

	XpfCtTextAttribute shoutShouldPreserve: false.	
	(text attributesOfKind: XpfCtMorphAttribute) do: [:attr | attr cleanUp].
		
	^ super unstyledTextFrom: aText.
! !

!OBClassNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 13:55'!
hasMarkups

	^ true! !

!OBClassNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 14:22'!
markupSourceName

	^ '{1} "{2}"' format: {
		self theClass isMeta
			ifTrue: ['meta-class']
			ifFalse: ['class'].
		self theClassName}! !

!OBClassNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 14:13'!
methodReferences

	^ (self theClass selectors collect: [ :each | 
		MethodReference class: self theClass selector: each])! !

!OBClassNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 13:54'!
referencesForMarkups

	^ self methodReferences! !

OBFilter subclass: #XpfCtReloadFilter
	instanceVariableNames: 'inspector cache announcer node isReloading browser updateProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Filters'!

!XpfCtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/25/2009 11:09'!
announcer

	^ announcer! !

!XpfCtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/25/2009 12:45'!
announcer: anObject

	announcer := anObject.! !

!XpfCtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/25/2009 11:48'!
browser

	^ browser! !

!XpfCtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/25/2009 11:48'!
browser: anObject

	browser := anObject.! !

!XpfCtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/25/2009 11:22'!
cache

	cache ifNil: [
		self cache: OrderedCollection new].
	^ cache! !

!XpfCtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/19/2009 16:45'!
cache: anObject

	cache := anObject.! !

!XpfCtReloadFilter methodsFor: 'updating' stamp: 'mt 6/3/2009 09:51'!
doNodeRefreshing

	| sel |
	self browser navigationPanel currentColumn ifNotNilDo: [:col |
		sel := col selection].

	self announcer announce: OBRefreshRequired new.

	sel ifNotNilDo: [:s |
		self browser navigationPanel currentColumn selection: s].! !

!XpfCtReloadFilter methodsFor: 'initalizing' stamp: 'rkrk 9/19/2009 22:58'!
initializeForNode: aMethodNode

	| reference definition |
	reference := aMethodNode reference.
	definition := aMethodNode definition.
	self inspector: (XpfCtMczInspector newForPackageNamed: 
		(PackageOrganizer default packageOfMethod: reference) packageName).
		
	node := aMethodNode.
		
	self inspector
		addDependent: self;
		startInspectVersionsFor: definition selector
		in: definition theClass.! !

!XpfCtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/19/2009 16:47'!
inspector

	^ inspector! !

!XpfCtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/19/2009 16:45'!
inspector: anObject

	inspector := anObject.! !

!XpfCtReloadFilter methodsFor: 'updating' stamp: 'mt 6/3/2009 09:51'!
refreshNodes

	updateProcess
		ifNil: [updateProcess := [
			self doNodeRefreshing.
			(Delay forMilliseconds: (
				self cache size < 3
					ifTrue: [1000]
					ifFalse: [3000])) wait.
			updateProcess := nil] fork].! !

!XpfCtReloadFilter methodsFor: 'updating' stamp: 'mt 6/3/2009 09:51'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #done ifTrue: [self refreshNodes].! !

!XpfCtReloadFilter methodsFor: 'updating' stamp: 'rkrk 9/19/2009 19:33'!
update: aSymbol with: anObject

	super update: aSymbol with: anObject.
	
	aSymbol = #matchingVersionFound ifTrue: [
		self cache add: (XpfCtRemoteMethodVersion
			repository: (anObject at: #repository)
			info: (anObject at: #info)
			definition: (anObject at: #definition)).
		self refreshNodes].! !

!OBCodeBrowser methodsFor: '*xpf-codetalk-commands' stamp: 'mt 5/30/2009 15:07'!
cmdCodeTalk
	^ XpfCtEditCommand allSubclasses! !

!OBCodeBrowser methodsFor: '*xpf-codetalk-commands' stamp: 'mt 5/30/2009 09:34'!
cmdMarkups

	^ XpfCtCmdBrowseMarkups! !

!OBCodeBrowser methodsFor: '*xpf-codetalk-commands' stamp: 'mt 5/19/2009 15:19'!
cmdRemoteVersions
	^ XpfCtCmdBrowseRemoteMethodVersions! !

OBCodeBrowser subclass: #XpfCtMarkupBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Browsers'!

!XpfCtMarkupBrowser class methodsFor: 'as yet unclassified' stamp: 'mt 6/5/2009 15:12'!
maxPanes

	^ 2! !

!XpfCtMarkupBrowser class methodsFor: 'as yet unclassified' stamp: 'mt 6/5/2009 15:12'!
minPanes

	^ 2! !

!XpfCtMarkupBrowser class methodsFor: 'as yet unclassified' stamp: 'mt 6/5/2009 15:50'!
navigationPanel

	^ XpfCtMarkupColumnPanel minPanes: self minPanes maxPanes: self maxPanes! !

!XpfCtMarkupBrowser class methodsFor: 'as yet unclassified' stamp: 'mt 6/23/2009 14:56'!
openOn: aCodeNode

	| rootNode filterNode markupNode |
	rootNode := OBMetaNode named: 'environment'.
	filterNode := OBMetaNode named: 'filter'.
	filterNode ancestrySelector: #isDescendantOfMarkup:.
	
	markupNode := OBMetaNode named: 'markup'.
	
	rootNode
		childAt: #markupFilters
		put: filterNode.
	
	filterNode
		childAt: #markupsByLastActivity
		labeled: 'by last activity'
		put: markupNode;
		childAt: #markupsByChatSize
		labeled: 'by chat size'
		put: markupNode;
		childAt: #markupsByCreationTime
		labeled: 'by creation time'
		put: markupNode;
		childAt: #markupsByTag
		labeled: 'by tag'
		put: markupNode;
		addFilter: OBModalFilter new.
	
	^ (self metaNode: rootNode root: aCodeNode selection: aCodeNode markupFilters first) open! !

!XpfCtMarkupBrowser class methodsFor: 'as yet unclassified' stamp: 'mt 5/30/2009 17:25'!
panels
	^ {self navigationPanel. self definitionPanel} reject: [:ea | ea isNil]! !

!XpfCtMarkupBrowser methodsFor: 'building' stamp: 'mt 5/30/2009 09:24'!
defaultBackgroundColor

	^ Color red muchLighter! !

!XpfCtMarkupBrowser methodsFor: 'accessing' stamp: 'mt 5/30/2009 14:34'!
defaultLabel

	^ 'Markups for {1}' format: {self root markupSourceName}! !

OBCodeBrowser subclass: #XpfCtRemoteVersionBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Browsers'!

!XpfCtRemoteVersionBrowser class methodsFor: 'layout' stamp: 'mt 5/19/2009 10:21'!
maxPanes

	^ 1! !

!XpfCtRemoteVersionBrowser class methodsFor: 'layout' stamp: 'mt 5/19/2009 10:21'!
minPanes

	^ 1! !

!XpfCtRemoteVersionBrowser class methodsFor: 'instance creation' stamp: 'mt 5/25/2009 11:48'!
openOn: aMethodNode

	| instance version rootNode filter |
	version := OBMetaNode named: 'RemoteVersion'.	
	rootNode := OBMetaNode named: 'Method'.
	filter := XpfCtReloadFilter new.
	
	version ancestrySelector: #isDescendantOfMethodVersion:.
	
	rootNode
		childAt: #remoteVersions put: version;
		addFilter: filter.

	instance := self metaNode: rootNode root: aMethodNode selection: nil.
	
	filter
		browser: instance;
		announcer: instance announcer;
		initializeForNode: aMethodNode.

	^ instance open! !

!XpfCtRemoteVersionBrowser class methodsFor: 'layout' stamp: 'mt 5/26/2009 19:11'!
optionalButtons

	^ #('browse' 'revert')! !

!XpfCtRemoteVersionBrowser class methodsFor: 'layout' stamp: 'mt 5/26/2009 19:17'!
panels

	^ {self topPanel. self navigationPanel. self progressPanel. self definitionPanel} reject: [:ea | ea isNil]! !

!XpfCtRemoteVersionBrowser class methodsFor: 'layout' stamp: 'mt 5/26/2009 19:18'!
progressPanel

	^ XpfCtProgressPanel new! !

!XpfCtRemoteVersionBrowser class methodsFor: 'layout' stamp: 'mt 5/30/2009 17:15'!
topPanel

	^OBTopNavigationPanel withPanels: ({self mercuryPanel. self optionalButtonPanel} reject: [:ea | ea isNil])! !

!XpfCtRemoteVersionBrowser methodsFor: 'building' stamp: 'mt 5/25/2009 10:13'!
defaultBackgroundColor

	^ Color gray muchLighter! !

!XpfCtRemoteVersionBrowser methodsFor: 'accessing' stamp: 'mt 5/28/2009 10:04'!
defaultLabel

	^ 'Monticello Versions of {1}>>#{2}' format: {self root theClassName. self root selector}! !

!OBClassCategoryNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 14:01'!
hasMarkups

	^ true! !

!OBClassCategoryNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 14:24'!
markupSourceName

	^ 'class category "{1}"' format: {self name}! !

!OBClassCategoryNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 14:19'!
referencesForMarkups

	| result |
	result := OrderedCollection new.
	self classNames
		collect: [:ea | environment at: ea]
		thenDo: [:c |
			c selectors do: [ :each |
				result add: (MethodReference class: c selector: each)].
			c class selectors do: [ :each |
				result add: (MethodReference class: c class selector: each)]].
	^ result! !

TextLink subclass: #XpfCtMethodLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfCtMethodLink class methodsFor: 'services' stamp: 'mt 6/11/2009 11:02'!
addMethodLinksInto: aText
	"Parse the message and add links to the methods mentioned. This method will modify the attributes of the given text object."

	| rx s links strm |
	rx := '([A-Z]\w*)(\sclass)?>>#?(\w[\w:]*)' asRegex.
	s := aText asString.
	strm := s readStream.
	links := OrderedCollection new.
	
	[rx searchStream: strm]
		whileTrue: [
			links add: {
				rx subBeginning: 2.
				rx subEnd: 4.
				'{1}{2} {3}' format: {
					rx subexpression: 2.
					rx subexpression: 3.
					rx subexpression: 4}}].

	links do: [:link |
		aText
			addAttribute: (XpfCtMethodLink new classAndMethod: link third)
			from: link first + 1
			to: link second].
		
	^ aText! !

!XpfCtMethodLink methodsFor: 'action' stamp: 'bs 10/18/2009 16:16'!
actOnClickFor: aTextMorph

	[OBCodeBrowser defaultBrowserClass
		openOnClass: self theClass
		selector: self selector.
		World displayWorldSafely]
		on: Error
		do: [:e | Transcript show: '[CodeTalk] Method browsing not possible.'; cr].
	^ true! !

!XpfCtMethodLink methodsFor: 'scanning' stamp: 'mt 7/2/2009 21:43'!
emphasizeScanner: scanner

	(self theClass notNil and: [self theClass selectors includes: self selector])
		ifTrue: [super emphasizeScanner: scanner]
		ifFalse: [scanner textColor: Color red]! !

!XpfCtMethodLink methodsFor: 'accessing' stamp: 'mt 6/4/2009 16:31'!
selector

	^ (classAndMethod findTokens: Character space) last asSymbol! !

!XpfCtMethodLink methodsFor: 'accessing' stamp: 'mt 6/4/2009 16:32'!
theClass 

	| c |
	c := Smalltalk at: self theClassName asSymbol ifAbsent: [^nil].
	self theClassIsMeta ifTrue: [^c classSide].
	^c! !

!XpfCtMethodLink methodsFor: 'accessing' stamp: 'mt 6/4/2009 16:31'!
theClassIsMeta

	^ (classAndMethod findTokens: Character space) second = 'class'! !

!XpfCtMethodLink methodsFor: 'accessing' stamp: 'mt 6/4/2009 16:26'!
theClassName

	^ (classAndMethod findTokens: Character space) first! !

!OBCmdBrowseMethodVersions methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:51'!
icon

	^ #xpfCtTimeIcon! !

!OBMethodVersionNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 10:02'!
categoryText

	^ self version category! !

!OBMethodVersionNode methodsFor: '*xpf-codetalk-override' stamp: 'mt 1/18/2010 09:23'!
definition
	^ (OBMethodDefinition source: self source inClass: self theClass)
		callback: [:sel | 
					version selector = sel
						ifTrue: [self class on: version latest]
						ifFalse: [OBMethodNode on: sel inClass: self theClass]]! !

!OBMethodVersionNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/27/2009 10:39'!
hasVersions

	^ false! !

!OBMethodVersionNode methodsFor: '*xpf-codetalk' stamp: 'mt 1/18/2010 09:21'!
source

	^ self sourceText! !

!OBMethodVersionNode methodsFor: '*xpf-codetalk' stamp: 'mt 1/18/2010 09:24'!
sourceText
	"Style the method version source."
	
	| source |
	source := self version source.
	
	XpfCtSourceTextStyler new
		styleSource: source
		markups: (XpfCtMarkupDatabase local markupsForClass: self theClass selector: self selector version: self timeStamp)
		inClass: self theClass
		selector: self selector.
	
	^ source! !

!OBMethodVersionNode methodsFor: '*xpf-codetalk' stamp: 'mt 1/17/2010 11:38'!
timeStamp

	^ version stamp! !

OBMethodVersionNode subclass: #XpfCtRemoteMethodVersionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Nodes'!

!XpfCtRemoteMethodVersionNode class methodsFor: 'as yet unclassified' stamp: 'mt 5/19/2009 11:20'!
on: aRemoteMethodVersion

	^ self new setVersion: aRemoteMethodVersion! !

!XpfCtRemoteMethodVersionNode methodsFor: 'as yet unclassified' stamp: 'mt 5/27/2009 16:02'!
name

	| author time ver|
	time := String streamContents: [:strm |
		self version definition fullTimeStamp time print24: true showSeconds: false on: strm].
	author := (self version stamp findTokens: Character space) first.
	ver := self version info name.
	
	^ '{1} {2} [{3}]' format: {time. author. ver}! !

!XpfCtRemoteMethodVersionNode methodsFor: 'accessing' stamp: 'mt 5/19/2009 15:31'!
remoteVersion

	^ version! !

!XpfCtRemoteMethodVersionNode methodsFor: 'accessing' stamp: 'mt 5/19/2009 15:31'!
remoteVersion: anObject

	version := anObject.! !

!XpfCtRemoteMethodVersionNode methodsFor: 'as yet unclassified' stamp: 'mt 5/19/2009 11:28'!
source

	^ self sourceText! !

!XpfCtRemoteMethodVersionNode methodsFor: 'as yet unclassified' stamp: 'mt 5/19/2009 11:26'!
sourceText

	^ self remoteVersion sourceText! !

!XpfCtRemoteMethodVersionNode methodsFor: 'as yet unclassified' stamp: 'mt 5/19/2009 15:35'!
theClass

	^ self version theClass! !

SystemProgressBarMorph subclass: #XpfCtPluggableProgressBarMorph
	instanceVariableNames: 'model maxSelector valueSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtPluggableProgressBarMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/5/2009 20:53'!
newFor: aModel value: valSel max: maxSel

	^ self new
		model: aModel;
		maxSelector: maxSel;
		valueSelector: valSel! !

!XpfCtPluggableProgressBarMorph methodsFor: 'accessing' stamp: 'mt 5/5/2009 20:45'!
maxSelector

	^ maxSelector! !

!XpfCtPluggableProgressBarMorph methodsFor: 'accessing' stamp: 'mt 5/5/2009 20:45'!
maxSelector: aSymbol

	maxSelector := aSymbol! !

!XpfCtPluggableProgressBarMorph methodsFor: 'accessing' stamp: 'mt 5/5/2009 20:42'!
model

	^ model! !

!XpfCtPluggableProgressBarMorph methodsFor: 'accessing' stamp: 'mt 5/5/2009 20:43'!
model: anObject

	self model ifNotNilDo: [:m | m removeDependent: self].
	model := anObject.
	self model ifNotNilDo: [:m | m addDependent: self].! !

!XpfCtPluggableProgressBarMorph methodsFor: 'updating' stamp: 'mt 5/5/2009 21:24'!
update: aSymbol

	super update: aSymbol.
	
	aSymbol = self valueSelector ifTrue: [self updateBar]! !

!XpfCtPluggableProgressBarMorph methodsFor: 'updating' stamp: 'mt 5/5/2009 21:26'!
updateBar

	| value max |
	value := self model perform: self valueSelector.
	max := self model perform: self maxSelector.
	
	self 
		disableTableLayout: ((value = 0) | (value = max));
		visible: ((value = 0) | (value = max)) not.	
	
	self visible ifTrue:
		[self barSize: (value * self width) // max].! !

!XpfCtPluggableProgressBarMorph methodsFor: 'accessing' stamp: 'mt 5/5/2009 20:45'!
valueSelector

	^ valueSelector! !

!XpfCtPluggableProgressBarMorph methodsFor: 'accessing' stamp: 'mt 5/5/2009 20:54'!
valueSelector: aSymbol

	valueSelector := aSymbol.
	self update: aSymbol.! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:08'!
markBadIcon
	^ Icons
			at: #'markBad'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self markBadIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:06'!
markBadIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAACxSURBVDjL7dItC8JQAIXh491H
WbDvD1pEDIIKm1zDxqKi0WIULAZFYc1msF3ErEZlMC9Mhxx/gTAR28KpDxx4QRK/DCXwAbDg
0oLMTShtQF0F5AlwvwHkqy+Zxxs+lwsmvs8DKrIw8DCh8njNLOxRtxrU4yF3MFRhIBFQ2XxG
3W7yXq8xjULGsIsDFwF58zzq0YBpFPDc6XIKp/iFI4S7h5BbWGoFW03gyABVtyzxT8Ab8Xze
i+tkcykAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:08'!
markGoodIcon
	^ Icons
			at: #'markGood'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self markGoodIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:06'!
markGoodIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAC5SURBVDjLY/j//z8DJZhh1ADs
BjjsspIC4gb77ZZX7TdbXLVda9Zgs8xEihQDGmZfm/7/0KOD/3ff3/V/6plJ/y3mGjYQbYD9
NsurBx4e+D/10tT/nWc6/i+5sui/+RS9q0QbYLfB/OrWO1v+d5/p+t96qvn/3Auz/pt0aRNv
gPVyk4appyf+X3xl4f/ZF2b+n3Co579+mSrxXrCcZyhlMV2/wbRP56pRq+ZV3SLlBq1EOanR
lEgjAwAXIuIDq5qm/AAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:08'!
markUnknownIcon
	^ Icons
			at: #'markUnknown'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self markUnknownIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:07'!
markUnknownIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAQAAAC1+jfqAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAABlSURBVCjPY/jPgB8yDC4FilKK
DfJXZa6KNwhKYVfQkPW/63/b/+T/XA1YFchd7fqf/j/2f+N/5qtYFUhe7fif9D/sf91/BuwK
hBoS/jcBpcP/M2C3gluKrYHhKhA2MEgN2pDEDgEb0f5zlvXgVgAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:08'!
removeMarkupIcon
	^ Icons
			at: #'removeMarkup'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self removeMarkupIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:07'!
removeMarkupIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAQAAAC1+jfqAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAABbSURBVCjPzdAxDoAgEERRzsFp
95JbGI2ASA2SCOX3Ahtr8tuXTDIO959bCxRfpOitWS5vA+lMJg9JbKCTTmMQ1QS3ThqVQbBB
lsbgpXLYE8lHCXrqLptf9km7Dzv+FwGTaznIAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/28/2009 19:58'!
xpfCtAddCommentIcon

	^ Icons
			at: #'xpfCtAddComment'
			ifAbsentPut:[ UIThemeWatery new newWindowMaximizeForm ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:52'!
xpfCtCommentAddContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAGkSURBVDjLrZJPKINhHMd3UsrJ
TcpBDi6UC+3ookQ5OOBAaCh2cFQ40GqTzURTihI54DRp8dqBg3BQw5BtNmxe/4flT9re5+v3
vJvF2l6Kp749Pe/7fj7P7/09jwqA6i9R/ZugVr+cSZmlvFOgEIGSl0xgnVt3IRyRoDSWtn1c
4qakxQW0yKBEJMbw+MpwHWIQnxgCDwxnQQbvHYP7RoLnJirvntrkkuKvghytZU1+eUWg+Mjg
J/j0nuEkBh9dSTgQo4KB+R0uqEgquCD4PBiDbxlc11HYSfBuILUg/gu8fB/t6rmVcEzw4aWE
fYIdAS6IyILe6S0uUCdtIpd8Hbwah1+SxQlNTE91jJHPI5tcPoiLrBsL6BxrQOtQFep0pc/l
XYU9P14kkngugy/onxlF30ITlpwWOEQB5tV21JgLUNKRZVSCTeM2J6/kuV5fFrbuD8N6OCJX
Y7S3wGxv44K3VHAuxUvR8HVldxFszolvvVncs3DB7+67Wpv9Nig0Qy80yrB+pVG5gsTQh7pq
Yz5Mgkbemc98rdiDJBIDJcTLjs0G/vwDCw/6dFwBuzsAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:53'!
xpfCtCommentAddIcon
	^ Icons
			at: #'xpfCtCommentAdd'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtCommentAddContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/28/2009 20:12'!
xpfCtCommentContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAEvSURBVDjLY/j//z8DJZiBagZE
tO8QAuKlQPwTiP/jwbuAWAWbARtXHrz1//efv//xgS0n74MMuQ3EbHADgBweIP7z99+//x++
/fv/8tO//88+/vv/5P2//w/f/ft/782//7df/f1/5xXE8OoFx0GGmCEbIJcz9QBY8gVQ47MP
//4/Bmp+8Pbf/7tQzddf/P1/9RnEgM5VZ0EGeGM14ClQ86N3UM2v//2/9RKi+QpQ88UnuA2A
ewHk/PtAW++8/vv/JlDzted//18Gar7wBGTAH7ABtYtOgAywxBqIIEOQAcg1Fx7/BRuMFoic
uKLxDyzK5u64Cjfo/ecfYD5Q/DLWaMSGgQrvPH/3FabxOxDXEp0SgYp7Z267AtL4BYgLSUrK
QA1KQHwPiFPolxcGzAAA94sPIr7iagsAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 6/6/2009 13:27'!
xpfCtCommentGoContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAlFJREFUeNqMU0toE1EUPTMJ2oQaJcZPaVpiKxUTjHEjBe3C
ReyiGwXxsxKKoIggiAsX7U5UEBEVXCl0URFBsitWKo2/GolU22ipbVPbNGlTwYakTpLp/J53
JhqGaFrvcLnvzZtz7pnz3uMYYzDHhd7WvKRIdklT7D2dsSLWCL7yhahIcLt2Q5TlwpH7Htta
BNzFR21M0yR6FEiKgnpnC+93H0R0dhCjqfcaEW58fTkjVCOwKpqEoO80rzINqqZCA8NCLok9
7gMQpCI/PPcq57/KO2NdWu6fBLpkHZxYmoJMKhRNhqzKWF75iUBDGwS5wEdn3mVP3Xhuxg1Q
nn98pT1OBCIUVcE2RyOBVYMsnZuDs3Y7PiaHML44gdDZYfjqAmV0X3Q22Ds48YxIfdaCIrKe
yE2QC2SgzDW7vGhtOowPibcYmY/hzrEwNtR4MbPE6BcZOCLo2O9BZHxx53Q6F7CGzn0zdoLY
Gl2OmkTkewc43oaxha+4ezwM96ZdpAzQCFyqJRUO+zq9bLFWmlKUGMKTL/HkzCTqHDuoK4zO
KsPvcYWJpnHmx7Kofu4SLKlskTrZqCMrg/4QcCgdPEGUDUz5IJGj+l73PX0TJ9k2eDZzaHbx
aNnKo3Y9B1UFKeLgr7foJmJqPhun70c481EmH5xU7lGeoLTo74L7GtDZ7jXWs8IKQkPTGPiU
/ELTo/o2QidYLU9e74+nM3n2sH+M0bhI2W1e5yovkzlI0a1De92XwqOpPE27qePtv+5CNQIC
N1F5QXmNgA+qXqbVFPxP/BJgAHnqT8NmxeLpAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 6/6/2009 13:27'!
xpfCtCommentGoIcon

	^ Icons
			at: #'xpfCtCommentGo'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtCommentGoContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/28/2009 20:12'!
xpfCtCommentIcon

	^ Icons
			at: #'xpfCtComment'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtCommentContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:51'!
xpfCtCommentsContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAG/SURBVDjLjZK9T8JQFMVZTUyc
3IyJg4mDi87+GyYu6qB/gcZdFxkkJM66qJMGSNRBxDzigJMRQ1jQ4EcQ+SgVKB+FtuL13EdJ
xNDq8Ev7Xu85797T51nwhqeAH5w6cAxWwDgReX7jwYfdaCIraroptB7NLlVQrOoiGEsL1G06
GZyxuILicsMUH3VTlOqGKNUMUdTacj+j1Nng0NGAT2WxYosK1bbIVVoiW27J9V8G57WWKVSc
zMV5iK+Tudv1vVh5yXdlLQN+os4AFZss2Ob82CCgQmhYHSnmkzf2b6rIhTAaaT2aXZALIRdC
LgRtkA1WfYG4iKcVYX52JIs7EYvFmJ8wGiEXQi6EXAhdyn2MxQaPcg68zIETTvzyLsPzWnwq
ixVbhFwI3RFykes+A9vkIBKX4jCoIxdCLrI4/0OcUXXK4/1dbbDBS088xGGCCzAJCsiF2lan
T8xdKNhHXvRarLFBqmcwCrbAhL32+kP3lHguETKRsNlbqUFPeY2OoikW62DNM+jf2ibzQNN0
g5ALC75AGiT59oIReQ+cDGyTB+TC4jaYGXiRXMTD3AFogVmnOjeDMRAC025duo7wH74BwZ8J
lHrTPLcAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:54'!
xpfCtCommentsIcon
	^ Icons
			at: #'xpfCtComments'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtCommentsContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:52'!
xpfCtCrossContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAIhSURBVDjLlZPrThNRFIWJicmJ
z6BWiYbIkYDEG0JbBiitDQgm0PuFXqSAtKXtpE2hNuoPTXwSnwtExd6w0pl2OtPlrphKLSXh
x07OZM769qy19wwAGLhM1ddC184+d18QMzoq3lfsD3LZ7Y3XbE5DL6Atzuyilc5Ciyd7IHVf
gNcDYTQ2tvDr5crn6uLSvX+Av2Lk36FFpSVENDe3OxDZu8apO5rROJDLo30+Nlvj5RnTlVNA
Ks1aCVFr7b4BPn6Cls21AWgEQlz2+Dl1h7IdA+i97A/geP65WhbmrnZZ0GIJpr6OqZqYAd5/
gJpKox4Mg7pD2YoC2b0/54rJQuJZdm6Izcgma4TW1WZ0h+y8BfbyJMwBmSxkjw+VObNanp5h
/adwGhaTXF4NWbLj9gEONyCmUZmd10pGgf1/vwcgOT3tUQE0DdicwIod2EmSbwsKE1P8QoDk
cHPJ5YESjgBJkYQpIEZ2KEB51Y6y3ojvY+P8XEDN7uKS0w0ltA7QGCWHCxSWWpwyaCeLy0Bk
A7UXyyg8fIzDoWHeBaDN4tQdSvAVdU1Aok+nsNTipIEVnkywo/FHatVkBoIhnFisOBoZxcGt
Qd4B0GYJNZsDSiAEadUBCkstPtN3Avs2Msa+Dt9XfxoFSNYF/Bh9gP0bOqHLAm2WUF1YQskw
rVFYPWkf3h1iXwbvqGfFPSGW9Eah8HSS9fuZDnS32f71m8KFY7xs/QZyu6TH2+2+FAAAAABJ
RU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:54'!
xpfCtCrossIcon
	^ Icons
			at: #'xpfCtCross'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtCrossContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:52'!
xpfCtDeleteContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAJdSURBVDjLpZP7S1NhGMf9W7Yf
ogSJboSEUVCY8zJ31trcps6zTI9bLGJpjp1hmkGNxVz4Q6ildtXKXzJNbJRaRmrXoeWx8tJO
TWptnrNryre5YCYuI3rh+8vL+/m8PA/PkwIg5X+y5mJWrxfOUBXm91QZM6UluUmthntHqplx
Uml2lciF6wrmdHriI0Wx3xw2hAediLwZRWRkCPzdDswaSvGqkGCfq8VEUsEyPF1O8Qu3O7A0
9RbRvjuIttsRbT6HHzebsDjcB4/JgFFlNv9MnkmsEszodIIY7Oaut2OJcSF68Qx8dgv8tmqE
L1gQaaARtp5A+N4NzB0lMXxon/uxbI8gIYjB9HytGYuusfiPIQcN71kjgnW6VeFOkgh3XcHL
vAwMSDPohOADdYQJdF1FtLMZPmslvhZJk2ahkgRvq4HHUoWHRDqTEDDl2mDkfheiDgt8pw34
0/EocuClCuFvboQzb0cwIZgki4KhzlaE6w0InipbVzBfqoK/qRH94i0rgokSFeO11iBkp8Ed
V8cfJo0yD75aE2ZNRvSJ0lZKcBXLaUYmQrCzDT6tDN5SyRqYlWeDLZAg0H4JQ+Jt6M3atNLE
10VSwQsN4Z6r0CBwqzXesHmV+BeoyAUri8EyMfi2FowXS5dhd7doo2DVII0V5BAjigP89GEV
Atda8b2ehodU4rNaAW+dGfzlFkyo89GTlcrHYCLpKD+V7yeeHNzLjkp24Uu1Ed6G8/F8qjqG
Rzlbl2H2dzjpMg1KdwsHxOlmJ7GTeZC/nesXbeZ6c9OYnuxUc3fmBuFft/Ff8xMd0s65SXIb
/gAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:54'!
xpfCtDeleteIcon
	^ Icons
			at: #'xpfCtDelete'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtDeleteContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 16:04'!
xpfCtEyeContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAKASURBVDjLxVNLTxNRFP7udDp9
TCEtFSzloUBwY4FUF0ZjVDYsTDSw0/gjXBii/gk2GjZudO1G4wONK40CGkQSRKTybqGAfVHa
6dy5M/d6WwMhccnCk3yLk3u+L9+55xwihMBRQsERQz2crK+vX3Txyn1SyfXDMnyE24AjwR0Q
4qLQw1M82H4vGo1+3OeQ/RZSqdQTV2XnhkKzmqaoYJaJQj4P27LgcQGNdTocRmFzyWiJv2zq
il0/EJDkt67C0oAGhtTmJpLpHEwSAPNEwBwCy+bQ7W1EsYlYWxiKdMSjvbPhniu96tra2ohm
bAxovILZxCq0E5dh6M1g0jllAqYEZRw7lhRp1ZDdewW9tILAykRPingfk9Ti7BbJJ47viiC6
45cwNm2gYPAaefhWH4TgGB79JoU4vG6Cu0MNyMx/Bv8+hkzJtlWWW27yRfrQ0dhS+4sq0aAO
qHQgOK8JGJbMKZf9/h1asPssyv56sBejqupuinEtEHI5jgNFURCuA5JZB6a0fPvBF1BLClbs
moPT7X5wKVqrbWhFqDMmFFHcKLLiNmzbBmMM7WEFAY2jbDCUJbFsMpQkjgUI4ifVWk21lqaX
oBQ2mMJ94adi6wes5AxoMYOw7uBcl4JTEQFVULhhId5GcO2MJtuUEykXQRc+gb1/hLTl/Vob
Y2JmctyfnTvvUwlEqCMPvdGEHrKgevj+wlTrxO8VL1+ebLaSc1gwA2kj9bPlYJGmPrx7bm0l
rkbIrhrwewFPPbjbj+pzdSPtUh7YXsRqpiT2gp1T9NfEhcGR1zY5fEzjo3c8ud3SIKV0SJrp
1wgCLjiS7/CKaU5LPCOcj918+Gb+n1X+b9f4B22tbKhgZZpBAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 16:05'!
xpfCtEyeIcon

	^ Icons
		at: #'xpfCtEye'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtEyeContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 14:11'!
xpfCtMagnifierContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAH5SURBVDjLpZK/a5NhEMe/748k
RqypmqQQgz/oUPUPECpCoEVwyNStIA6COFR33boIjg6mg4uL0k0EO1RFISKImkHQxlbQRAsx
0dgKJm/e53nunnOwViR5leJnuZs+973jHBHB/+D/ah7X2LXWloilyMw5YgtD3CDiBWN4Zno8
bQcJHBFBucauZfsolZDCru0OfFcAAUISrLZDfPzSKxuiibOT+T6JCwDMtrQzYQvZHQ5Cw2h3
GK0OI9AWBzJJZFOxgtJUGpTABQAiLu5OOviuGIEWkBUwC7pasNZj7N2ThNJUjBQY4pznAoEW
sBWwxU+JFXSVRTzmQWvKRR5RG4KVGMgKrAVYflexAAugDCEygdbUCI2F7zobk7FZY76DIDQg
rT9HCwwt1FsBhhIu4p4D3kiS8B0MJz28ftfGSPfl8MPLxbGBAqVpptbslJc+fEPMA7JDPrIp
H3FX8LzaROdrE5O51jalgid3Lh4b6/sDALh6971riErGcFET58gwDPGndG9JT6ReHcwfPorG
ygu8rdxvGxMeP3XtzcofgigWZ0/EtQ7n0/sOTe0/Mo7V5WeoVu61z1yvZzZX+BsnZx9opYLp
evXp7eXKIrL5UWit0n0r/Isb50bjRGreiyWmgs76lfM31y5tSQAAc6czHjONXLi13thygih+
AEq4N6GqMsuhAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 14:11'!
xpfCtMagnifierIcon
	^ Icons
			at: #'xpfCtMagnifier'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtMagnifierContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/5/2009 14:42'!
xpfCtMarkBadIcon

	^ Icons
			at: #'xpfCtMarkBad'
			ifAbsentPut:[ UIThemeWatery new newWindowCloseForm ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/5/2009 14:41'!
xpfCtMarkCommentIcon

	^ Icons
			at: #'xpfCtMarkComment'
			ifAbsentPut:[ UIThemeWatery new newWindowMinimizeForm ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 19:16'!
xpfCtPaintcanContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAJVSURBVDjLlZPbS5NhHMd3tbvy
ov6HIJRuhKAFgRci5GXYVQkG0c6HJGvD1FVMjdxC22wlQ9iG7uBh0rtDmxtb77vFoh2c7KgM
tiGbU9xdgezb3hf0Ii3cxZfngef5fn6H5/ewALD+Vv8Upeh7HfzdM+pb4QwT7PPunOg8M7tl
Ph63JtE/4UM3f7WnLUDL3NE7vgmFKYbeF050Di3dbQvQSrvjzogTIm0Yt0WrePp25VNbAHcg
rLopXMOgyo/uR8v4bAnAbrdLLwSIRCLK1HYaHKEdnQ9MuHZ/Edv5MpYcHljc1K9Fgvo+uxqa
nLYEr5wBhMNhZTqdRr1ex6jOBz8VxzONC+VyGQcHB5g3rcFGZWH+lscrc9ArWdjseqzzXWLM
FEWdmnO5HEwbEYzpvmKZ+IFKpYJSqQS/3w/l+4XmlCXYnHGmMfTBOzyg9lxmkSQ5RpsbjQYK
hQKy2Syz7u/vM0Z6T5+73W44nU7IlOrmS9tPPJn3VfsmXVdZLfKbra0tVKtV7O7uYmdnh8mE
BtCwVCqFRCIBgiCg0Wggk8ko7sdNCMwJ3JogRpgSHA6HOhqN4ujoCIeHh6jVashkMkgmk4jH
4wgEApibm4NUKqVEIhH74awXrfSPbyi+dJ020Wg0vguFQtjb20M+n2eixmIxBqDX6+nIpFAo
ZMb63owHHCXhOvOMWq1W7fF4UCwWQZdFN9RqtdKRSYFAcPonrj/fGPznIKlUKvX6+jrTfZvN
BolEQvL5fPaFJ5GWXC5XGwwGiMViksfjtfcbT9Rq1gCXy/2vmdYfaGviUGKvapgAAAAASUVO
RK5CYII='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 19:16'!
xpfCtPaintcanIcon
	^ Icons
			at: #'xpfCtPaintcan'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtPaintcanContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 1/17/2010 17:32'!
xpfCtPencilExContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAkhJREFUeNqkk8trE1EUxr+ZTGaaMY9iHpMm1ibFaCqUSgM+
KqiIdWFFBFF0paAbN+6K+icYXWipSKWrCkoNVikG3yAUYqBmwGq0j4ipJCXWvGqTpmkyM06m
KIZoCXjgbO49v+87h3sPIUkS/ieoegvjL7ZpClnHbOYbYRQFkWR1s1EtQ3fVLZBPO5ckwYb2
I6dBkCQmRi86svHMTaKeEWR3qdF2CZRuowwzypm4vIAJf59I1gObPP2g9ATioXsoJaeUrASp
olbW7OA3zGRRjPshLjH4zM9Dp7chORfB9guPCLIuOPEAkhAB09ICC0ehHAsqcKXurx3UwCsx
5EkzkjMBSPM0li0R4ldtTQevb7hrYLXlIFKRt2ju7EWRiw7Jng0V30pWCTz3bpE8J25VwbT1
EGJvnoBe5wDbyMHA7WsTRHSXBaCSisDAOaejArv3e/FxbLgK/h7gkU1/gtl9YOHUmfswNe3e
LArEUaEMSs5VgRIrftl1cghNG5xIfQiBf/UOiXQbwiMvEZ0aB9VsDUJYNPh8PhRyCQPNOrfK
7ntL5T9GYEgVfoxdh8euhcTHwA8OIz79FQVuesBgbXfNZcbhf9yLZHES6vVWV7mM46USVp8x
EM5h5lkfNK5uUDvOQ9rkAWuxgHSHuxjW1AFV3EiTSfQcvgqWWoRWWzSqG7QdsshOZRckkYD3
7lPsCQVh1TGgzYaRnivvj43eJgc5u75VQyYAtYh86jJyqYdKx1a7oXUylTu75k+8c43oF0V0
/ute3in+pwADAMMdEiSznbNwAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 1/17/2010 17:32'!
xpfCtPencilExIcon

	^ Icons
			at: #'xpfCtPencilEx'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtPencilExContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/5/2009 14:41'!
xpfCtSmallMarkBadIcon

	^ Icons
			at: #'xpfCtSmallMarkBad'
			ifAbsentPut:[ UIThemeWatery new newWindowCloseForm scaledToSize: 8@8 ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/5/2009 14:42'!
xpfCtSmallMarkCommentIcon

	^ Icons
			at: #'xpfCtSmallMarkComment'
			ifAbsentPut:[ UIThemeWatery new newWindowMinimizeForm scaledToSize: 8@8 ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:51'!
xpfCtTimeContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAKrSURBVDjLpdPbT9IBAMXx/qR6
qNbWUy89WS5rmVtutbZalwcNgyRLLMyuoomaZpRQCt5yNRELL0TkBSXUTBT5hZSXQPwBAvor
/fZGazlb6+G8nIfP0znbgG3/kz+Knsbb+xxNV63DLxVLHzqV0vCrfMluzFmw1OW8ePEwf8+W
gM1UXDnapVgLePr5Nj9DJBJGFEN8+TzKqL2RzkenV4yl5ws2BXob1WVeZxXhoB+PP0xzt0Bl
y0fKTePozV5GphYQPA46as+gU5/K+w2w6Ev2Ol/KpNCigM01R2uPgDcQIRSJEYys4JmNoO/y
0tbnY9JlxnA9M15bfHZHCnjzVN4x7TLz6fMSJqsPgLAoMvV1niSQBGIbUP3Ki93t57XhItVX
julTQHf9hfk5/xgGyzQTgQjx7xvE4nG0j3UsiiLR1VVaLN3YpkTuNLgZGzRSq8wQUoD16flk
OPSF28/cLCYkwqvrrAGXC1UYWtuRX1PR5RhgTJTI1Q4wKwzwWHk4kQI6a04nQ99mUOlczMYk
FhPrBMQoN+7eQ35Nhc01SvA7OEMSFzTv8c/0UXc54xfQcj/bNzNmRmNy0zctMpeEQFSio/cd
vqUICz9AiEPb+DLK2gE+2MrR5qXPpoAn6mxdr1GBwz1FiclDcAPCEkTXIboByz8guA75eg8W
xxDtFZloZIdNKaDu5rnt9UVHE5POep6Zh7llmsQlLBNLSMTiEm5hGXXDJ6qb3zJiLaIiJy1Z
pjy587ch1ahOKJ6XHGGiv5KeQSfFun4ulb/josZOYY0di/0tw9YCquX7KZVnFW46Ze2V4wU1
ivRYe1UWI1Y1vgkDvo9PGLIoabp7kIrctJXSS8eKtjyTtuDErrK8jIYHuQf8VbK0RJUsLfEg
94BfIztkLMvP3v3XN/5rfgIYvAvmgKE6GAAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:17'!
xpfCtWorldContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAMtSURBVDjLVZNLa1xlAIafc5sz
k8xkMkkm5MKY2EpT2qa2MTVCmoLS2gq6EKooimAW7iQb/0I2bgTRIog0oFW7KQpCS7VqrSmm
JGlSQtswqWlLLmbGmcmcZM6cy/edz00r6bt8eXh4N6+mlGJnxiZHR4APgSNAFjCBKjClInXm
05Gzl3by2mPB2OSoCUwAp1/LHbcziSyO24gbgJAegg2urF8UUsifhZBvfvXK99v/C8YmRy3g
t8G2/cMv517E8Wx8ApYcjZiyKbkRSgQkcFn3rzG9Nn1LhOLYt2/8UNUfLZkYaN0zfLRrkLIM
CHUNIXTqIoZLjLJvU/ASrFQtnko+z2BH38HAD78DMConHh4FPn5nz6vGgqyxTp16JNj2kpR9
C8eD/OoW1VoNO1NCS+d5oW0vV27f2PX11MS8MTR6+JOTXUMHNCPBui5AtdMpk8xsGNQ9ndur
20TxCnbPIn5TnmJUwaxIDrTm9Jn7d1tM4EiuqZs5d41iXGefsZsIwYNCgOfVSXconJbLLEWb
4CuahU2+6HO8d4DQF/0m0NpgNvLAXaPgu6QadrEZpKhUItJZj/aMS1EewvHnsdUWW/+WKG82
kEykCAPRbCqlNE1B4DsocpiW5OJfIVoiyfqSQFdNdGXrpLZGcFZDPKYJg2VQCiGEZkoRlZ3A
6W41mknFn2WlaOKFFrG4Tbw9wb2/S3g3miHySLdbNDd2kzYKVGpVpIiqugjF7P3yQ55pyLFW
mCSyVokZPqHnEoYmsWQGuyWOGdexNIkRFOnqbGN5bRngjh4G4rMLd6+KnmQW012lWrpOJuNj
Ch9LU9i6gRkEZHIrpNv/QK8vcijXz5lfLijgS+PmuYV75+fPDXr1Wt9znfsouy5x+2miuolt
W1iawBJV0o0/wT8lBvbv5WZ+gaWNlasz43MfmQChH777e37uT78eHDx5+BiLBROjqhDaFmGk
Q1KS6+mlr7+XX2evc+nWVB54+4kznfr8pZQIxXkRyhPvDb9vIjtQqgFN12hLO2yUZ/ni8o8S
uAa8NTM+t/GE4HGGx4del0J+IGXUH8ko86iuAneAszPjc9/s5P8DuO6ZcsXuRqAAAAAASUVO
RK5CYII='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:18'!
xpfCtWorldIcon

	^ Icons
			at: #'xpfCtWorld'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtWorldContents readStream)].! !

!ByteArray class methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 21:24'!
fromHex: hexString 
	"Returns a byteArray from a hex string. The hex string can have
	leading zeros that will not be truncated, preserving the size of the
	byteArray for things like cyrptograpy"
	| anInteger hexSize stringSize aStringOfHex |
	aStringOfHex := (hexString copyWithoutAll: (Array with: $  with: Character cr with: Character tab)).
	stringSize := aStringOfHex size.
	(stringSize > 3
			and: [(aStringOfHex copyFrom: 1 to: 3) = '16r'])
		ifTrue: [anInteger := Number readFrom: (aStringOfHex asUppercase at: 3 put: $r;
							 yourself).
			hexSize := aStringOfHex size - 3 / 2]
		ifFalse: [anInteger := Number readFrom: aStringOfHex asUppercase base: 16.
			hexSize := aStringOfHex size / 2].
	^ anInteger asByteArrayOfSize2: hexSize asInteger! !

OBColumnPanel subclass: #XpfCtMarkupColumnPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Panels'!

!XpfCtMarkupColumnPanel commentStamp: 'mt 6/5/2009 15:53' prior: 0!
Just like the normal OBColumnPanel but uses another building method to get another scroller for special layouting.!

!XpfCtMarkupColumnPanel methodsFor: 'building' stamp: 'mt 6/5/2009 15:53'!
buildOn: aBuilder 
	^aBuilder specialScroller: self with: [columns do: [:ea | ea buildOn: aBuilder]]! !

OBTextMorphWithShout subclass: #XpfTextMorph
	instanceVariableNames: 'liveModeMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfTextMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 5/1/2009 14:13'!
addMorph: aMorph

	(self submorphs includes: aMorph)
		ifFalse: [^ super addMorph: aMorph].
	^ aMorph! !

!XpfTextMorph methodsFor: 'private' stamp: 'topa 2/13/2009 14:09'!
editorClass
	"Answer the class used to create the receiver's editor"
	
	^XpfEditor! !

!XpfTextMorph methodsFor: 'testing' stamp: 'mt 1/17/2010 16:54'!
hasUnacceptedEdits

	^ self editView hasUnacceptedEdits! !

!XpfTextMorph methodsFor: 'initialization' stamp: 'mt 4/30/2009 10:36'!
initialize

	super initialize.
	
	(Preferences preferenceAt: #showLineNumbers ifAbsent: [Preference new rawValue: false]) preferenceValue
		ifTrue: [self leftMargin: ((Preferences standardCodeFont widthOfString: '99') * 1.7) rounded].! !

!XpfTextMorph methodsFor: 'accessing' stamp: 'mt 1/17/2010 17:48'!
leftMargin: aNumber

	self margins: (aNumber@0 corner: 0@0).! !

!XpfTextMorph methodsFor: 'accessing' stamp: 'mt 1/17/2010 17:46'!
liveModeMorph

	^ liveModeMorph ifNil: [
		liveModeMorph := MenuIcons xpfCtPencilExIcon asMorph.
		liveModeMorph assureExtension balloonText: 'Live Edit Mode disabled.'.
		liveModeMorph]! !

!XpfTextMorph methodsFor: 'private' stamp: 'mt 4/22/2009 20:24'!
paragraphClass
	
	^ XpfParagraph! !

!XpfTextMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 1/17/2010 17:44'!
removeAllMorphsBut: someMorphs

	self hasUnacceptedEdits
		ifTrue: [
			self addMorph: self liveModeMorph.
			self liveModeMorph setToAdhereToEdge: #topRight.
			someMorphs add: self liveModeMorph].

	self submorphs copy do: [:m | (someMorphs includes: m)
		ifFalse: [m delete]]! !

!XpfTextMorph methodsFor: 'private' stamp: 'mt 1/17/2010 14:19'!
update: aSymbol

	super update: aSymbol.
	"(aSymbol = #chatLineAdded or: [aSymbol = #commentChanged])
		ifTrue: [self hasUnacceptedEdits: true]."
	aSymbol = #resizeRequested
		ifTrue: [self editor resizeMarkup].! !

!XpfTextMorph methodsFor: 'private' stamp: 'mt 1/17/2010 14:21'!
update: aSymbol with: anAttribute

	aSymbol = #deleteRequested ifTrue: [
		self editor removeMarkup: anAttribute].
	
	super update: aSymbol with: anAttribute.! !

!OBMethodCategoryNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 13:07'!
hasMarkups

	^ true! !

!OBMethodCategoryNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 14:29'!
markupSourceName


	^ 'protocol [{1}] in {2} "{3}"' format: {
		self name.
		self theClass isMeta
			ifTrue: ['meta-class']
			ifFalse: ['class'].
		self theClassName}.! !

!OBMethodCategoryNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 13:47'!
referencesForMarkups

	^ self methodReferences! !

!Duration methodsFor: '*xpf-codetalk' stamp: 'mt 6/8/2009 20:52'!
rawSeconds

	^ seconds! !

StandardWindow subclass: #XpfCtTagAnalysisMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtTagAnalysisMorph class methodsFor: 'defaults' stamp: 'mt 5/9/2009 17:20'!
defaultControlWidth

	^ 150! !

!XpfCtTagAnalysisMorph class methodsFor: 'defaults' stamp: 'mt 5/9/2009 17:47'!
defaultExtent

	^ 500@280! !

!XpfCtTagAnalysisMorph class methodsFor: 'opening' stamp: 'mt 5/9/2009 17:20'!
open

	^ self new openInWorld extent: self defaultExtent! !

!XpfCtTagAnalysisMorph class methodsFor: 'opening' stamp: 'mt 5/9/2009 17:20'!
prototypicalToolWindow
	"Used in flaps."
	
	^ self new extent: self defaultExtent! !

!XpfCtTagAnalysisMorph class methodsFor: 'accessing' stamp: 'mt 5/9/2009 17:20'!
title

	^ 'Markup analysis'! !

!XpfCtTagAnalysisMorph methodsFor: 'controls' stamp: 'mt 5/9/2009 17:26'!
analysisButton

	^ (self
		newButtonFor: self model
		getState: nil
		action: #startStop
		arguments: nil
		getEnabled: #canAnalyze
		getLabel: #label
		help: 'Click here to start analysis.')
		hResizing: #spaceFill! !

!XpfCtTagAnalysisMorph methodsFor: 'controls' stamp: 'mt 5/9/2009 17:46'!
diagram

	^ XpfCtDiagramMorph new
		dimensions: (0@5 corner: 100@0);
		addGrid: 10@1;
		addGraph: (XpfCtGraphMorph
			newFor: (XpfCtTestGraphModel newForInspector: self model inspector)
			color: Color red)! !

!XpfCtTagAnalysisMorph methodsFor: 'controls' stamp: 'mt 5/9/2009 17:54'!
filterEntry

	^ (self
		newTextEntryFor: self model
		getText: #filter
		setText: #filter:
		getEnabled: #isNotAnalyzing
		help: nil)
		hResizing: #rigid;
		vResizing: #rigid;
		extent: self class defaultControlWidth@(self theme textFont height + 8);
		autoAccept: true.! !

!XpfCtTagAnalysisMorph methodsFor: 'initialize-release' stamp: 'mt 5/9/2009 17:10'!
initialize

	super initialize.
	self
		addMorph: (self newDialogPanel listDirection: #leftToRight) frame: (0@0 corner: 1@1);
		model: XpfCtTagAnalysisModel new;
		initializeUserInterface.! !

!XpfCtTagAnalysisMorph methodsFor: 'initialize-release' stamp: 'mt 5/9/2009 17:48'!
initializeUserInterface

	self paneMorphs first
		cellInset: 20;
		addMorphBack: ((self newColumn: {
			self newRow: {(self newLabel: 'Repository') hResizing: #spaceFill. self repositoryEntry}.
			self newRow: {(self newLabel: 'Username') hResizing: #spaceFill. self usernameEntry}.
			self newRow: {(self newLabel: 'Password') hResizing: #spaceFill. self passwordEntry}.
			self newRow: {(self newLabel: 'Filter') hResizing: #spaceFill. self filterEntry}.
			self newToolSpacer vResizing: #spaceFill.
			self newSeparator.
			self analysisButton})
			hResizing: #shrinkWrap);
		addMorphBack: self diagram.! !

!XpfCtTagAnalysisMorph methodsFor: 'controls' stamp: 'mt 5/9/2009 17:54'!
passwordEntry

	^ (self
		newTextEntryFor: self model
		getText: #password
		setText: #password:
		getEnabled: #isNotAnalyzing
		help: nil)
		hResizing: #rigid;
		vResizing: #rigid;
		extent: self class defaultControlWidth@(self theme textFont height + 8);
		autoAccept: true.! !

!XpfCtTagAnalysisMorph methodsFor: 'controls' stamp: 'mt 5/9/2009 17:53'!
repositoryEntry

	^ (self
		newTextEntryFor: self model
		getText: #repositoryName
		setText: #repositoryName:
		getEnabled: #isNotAnalyzing
		help: 'Type name of repository in SqueakSource @ HPI.')
		hResizing: #rigid;
		vResizing: #rigid;
		extent: self class defaultControlWidth@(self theme textFont height + 8);
		autoAccept: true.! !

!XpfCtTagAnalysisMorph methodsFor: 'appearance' stamp: 'mt 5/9/2009 17:22'!
title

	^ self class title! !

!XpfCtTagAnalysisMorph methodsFor: 'controls' stamp: 'mt 5/9/2009 17:54'!
usernameEntry

	^ (self
		newTextEntryFor: self model
		getText: #username
		setText: #username:
		getEnabled: #isNotAnalyzing
		help: nil)
		hResizing: #rigid;
		vResizing: #rigid;
		extent: self class defaultControlWidth@(self theme textFont height + 8);
		autoAccept: true.! !

StandardWindow subclass: #XpfCtTagSearchMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtTagSearchMorph class methodsFor: 'defaults' stamp: 'mt 5/5/2009 19:34'!
defaultControlWidth

	^ 150! !

!XpfCtTagSearchMorph class methodsFor: 'defaults' stamp: 'mt 5/5/2009 18:53'!
defaultExtent

	^ 600@350! !

!XpfCtTagSearchMorph class methodsFor: 'opening' stamp: 'mt 5/5/2009 18:53'!
open

	^ self new openInWorld extent: self defaultExtent! !

!XpfCtTagSearchMorph class methodsFor: 'opening' stamp: 'mt 5/5/2009 18:59'!
prototypicalToolWindow
	"Used in flaps."
	
	^ self new extent: self defaultExtent! !

!XpfCtTagSearchMorph class methodsFor: 'accessing' stamp: 'cs 5/4/2009 11:55'!
title

	^ 'Markup finder'! !

!XpfCtTagSearchMorph methodsFor: 'controls' stamp: 'mt 5/5/2009 19:26'!
categoryEditor

	| pt |
	pt := PluggableTextEditorMorph new
		on: self model
		text: #category
		accept: #category:
		readSelection: #categoryLength
		menu: nil;
		font: self theme textFont;
		cornerStyle: self preferredCornerStyle;
		hResizing: #rigid;
		getEnabledSelector: #categoryEnabled;
		borderStyle: (BorderStyle inset width: 1);
		color: Color white;
		alwaysAccept: true;
		vResizing: #rigid;
		hideScrollBarsIndefinitely;
		extent: self class defaultControlWidth@(self theme textFont height + 8);
		setBalloonText: 'Enter category here';
		autoAccept: true.
	pt textMorph
		autoFit: true;
		wrapFlag: true;
		margins: (2@1 corner: 2@1).
	^ pt! !

!XpfCtTagSearchMorph methodsFor: 'layout' stamp: 'cs 5/3/2009 13:25'!
categoryRow

	^ self newRow: {
		(self newLabel: 'Category') hResizing: #spaceFill.
		self categoryEditor}! !

!XpfCtTagSearchMorph methodsFor: 'controls' stamp: 'mt 5/5/2009 19:26'!
classEditor

	| pt |
	pt := (PluggableTextEditorMorph new
		on: self model
		text: #theClass
		accept: #theClass:
		readSelection: #theClassLength
		menu: nil;
		getEnabledSelector: #theClassEnabled;
		font: self theme textFont;
		cornerStyle: self preferredCornerStyle;
		hResizing: #rigid;
		borderStyle: (BorderStyle inset width: 1);
		color: Color white)
		alwaysAccept: true;
		vResizing: #rigid;
		hideScrollBarsIndefinitely;
		extent: self class defaultControlWidth@(self theme textFont height + 8);
		setBalloonText: 'Enter class name here';
		autoAccept: true.
	pt textMorph
		autoFit: true;
		wrapFlag: true;
		margins: (2@1 corner: 2@1).
	^ pt! !

!XpfCtTagSearchMorph methodsFor: 'layout' stamp: 'cs 5/3/2009 12:37'!
classRow

	^ self newRow: {
		(self newLabel: 'Class') hResizing: #spaceFill.
		self classEditor}! !

!XpfCtTagSearchMorph methodsFor: 'layout' stamp: 'mt 5/5/2009 19:25'!
creatorRow

	^ self newRow: {
		(self newLabel: 'Creator') hResizing: #spaceFill.
		(self
			newTextEntryFor: self model
			getText: #creator
			setText: #creator:
			help: 'Enter the initials of the tag''s creator')
			autoAccept: true;
			width: self class defaultControlWidth;
			hResizing: #rigid}! !

!XpfCtTagSearchMorph methodsFor: 'initialization' stamp: 'cs 5/4/2009 11:07'!
initialize

	super initialize.
	self
		addMorph: (self newDialogPanel listDirection: #leftToRight) frame: (0@0 corner: 1@1);
		model: XpfCtTagSearchModel new;
		initializeUserInterface.! !

!XpfCtTagSearchMorph methodsFor: 'initialization' stamp: 'mt 5/6/2009 10:22'!
initializeUserInterface

	self paneMorphs first
		addMorphBack: ((self newColumn: {
			self categoryRow.
			self classRow.
			self tagRow.
			self creatorRow.
			self timeRow.
			self keywordRow.
			self newToolSpacer vResizing: #spaceFill.
			self newSeparator.
			self progressLabel.
			self progressBar.
			self searchButton})
			hResizing: #shrinkWrap);
		addMorphBack: self resultsList.! !

!XpfCtTagSearchMorph methodsFor: 'layout' stamp: 'mt 5/5/2009 19:25'!
keywordRow

	^ self newRow: {
		(self newLabel: 'Keyword') hResizing: #spaceFill.
		(self
			newTextEntryFor: self model
			getText: #keyword
			setText: #keyword:
			help: 'Enter a keyword to search in tag discussions')
			autoAccept: true;
			width: self class defaultControlWidth;
			hResizing: #rigid}! !

!XpfCtTagSearchMorph methodsFor: 'controls' stamp: 'mt 5/5/2009 20:57'!
progressBar

	^ (XpfCtPluggableProgressBarMorph 
		newFor: self model
		value: #progressValue
		max: #progressValueMax)
		hResizing: #spaceFill;
		vResizing: #rigid;
		height: 16! !

!XpfCtTagSearchMorph methodsFor: 'controls' stamp: 'mt 5/6/2009 10:22'!
progressLabel

	^ XpfCtPluggableLabelMorph new
		model: self model;
		labelSelector: #progressString;
		hResizing: #spaceFill! !

!XpfCtTagSearchMorph methodsFor: 'controls' stamp: 'mt 5/5/2009 20:36'!
resultsList

	^ (XpfPluggableListMorph new
			selectionColor: self theme selectionColor;
			font: self theme listFont;
			on: self model
			list: #results
			selected: nil
			changeSelected: #selectResult:
			menu: nil
			keystroke: nil)
			autoDeselect: false;
			cornerStyle: self preferredCornerStyle;
			color: Color white;
			borderStyle: (BorderStyle inset width: 1);
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			setBalloonText: 'Displays search results';
			minWidth: 200! !

!XpfCtTagSearchMorph methodsFor: 'controls' stamp: 'mt 5/5/2009 21:36'!
searchButton

	^ (self
		newButtonFor: self model
		getState: nil
		action: #searchOrStop
		arguments: nil
		getEnabled: #canSearch
		getLabel: #searchButtonLabel
		help: 'Click here to search')
		hResizing: #spaceFill! !

!XpfCtTagSearchMorph methodsFor: 'layout' stamp: 'mt 5/5/2009 19:25'!
tagRow

	| chkCol |
	chkCol := (self newColumn: {})
		width: self class defaultControlWidth;
		hResizing: #rigid.
	
	XpfComplexAttribute tags do: [:tag |
		chkCol addMorphBack:  (self
			newCheckboxFor: self model
			getSelected: ('find{1}' format: {tag capitalized}) asSymbol
			setSelected: ('find{1}:' format: {tag capitalized}) asSymbol
			label: tag asString
			help: ('Find code tagged as {1}' format: {tag}))].
	
	^ self newRow: {
		(self newLabel: 'Tag') hResizing: #spaceFill; vResizing: #spaceFill.
		chkCol}! !

!XpfCtTagSearchMorph methodsFor: 'layout' stamp: 'mt 5/5/2009 19:25'!
timeRow

	^ self newRow: {
		(self newLabel: 'Created Time') hResizing: #spaceFill.
		(self
			newDropListFor: self model
			list: #possibleTimes
			getSelected: #selectedTimeIndex
			setSelected: #selectedTimeIndex:
			help: 'Search for tags created at the specific time')
			hResizing: #rigid;
			vResizing: #rigid;
			extent: self class defaultControlWidth @ 24}! !

!XpfCtTagSearchMorph methodsFor: 'appearance' stamp: 'cs 5/4/2009 11:55'!
title

	^ self class title! !

TextAttribute subclass: #XpfCtTextAttribute
	instanceVariableNames: ''
	classVariableNames: 'ShoutShouldPreserve'
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfCtTextAttribute commentStamp: 'mt 1/16/2010 16:47' prior: 0!
I am a text attribute that is capable of displaying itself in some bounds.!

XpfCtTextAttribute subclass: #XpfCtMorphAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfCtMorphAttribute commentStamp: 'mt 1/16/2010 16:59' prior: 0!
I am a CodeTalk text attribute that contains a morph which will be displayed inline.!

XpfCtMorphAttribute subclass: #XpfComplexAttribute
	instanceVariableNames: 'tag chat chatMorph deleteMorph resizeMorph morph creator timestamp comment commentMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

XpfComplexAttribute class
	instanceVariableNames: 'colorTable readCache'!

XpfComplexAttribute class
	instanceVariableNames: 'colorTable readCache'!

!XpfComplexAttribute class methodsFor: 'color mapping' stamp: 'mt 5/28/2009 19:15'!
colorForTag: aSymbol

	colorTable ifNil: [colorTable := Dictionary newFrom: {
		#bad -> (Color red alpha: 0.4).
		#talk -> (Color yellow alpha: 0.4).
		#comment -> (Color green alpha: 0.4)}].
	
	^ colorTable at: aSymbol ifAbsent: [Color transparent]! !

!XpfComplexAttribute class methodsFor: 'instance creation' stamp: 'mt 5/2/2009 16:11'!
forTag: aSymbol

	^ self new
		tag: aSymbol;
		timestamp: TimeStamp now;
		creator: Utilities authorInitials! !

!XpfComplexAttribute class methodsFor: 'caching' stamp: 'mt 6/23/2009 17:22'!
read: aComplexAttribute
	"Tell the local cache that the given attribute was read by the developer."
	
	(Preferences
		preferenceAt: #rememberMarkupReads
		ifAbsent: [Preference new rawValue: false])
		preferenceValue
			ifFalse: [^ self].
	
	(readCache ifNil: [readCache := Set new])
		add: (self uniqueArrayFor: aComplexAttribute).! !

!XpfComplexAttribute class methodsFor: 'caching' stamp: 'mt 6/2/2009 17:59'!
reset
	"Free all cached values."
	
	colorTable := nil.
	readCache := nil.! !

!XpfComplexAttribute class methodsFor: 'private' stamp: 'mt 5/3/2009 21:19'!
scanChatFrom: strm for: attribute

	| chatCopy |
	chatCopy := Json readFrom: (ByteArray fromHex: (strm upTo: $-)) asString readStream.
	chatCopy do: [:line |
		line at: #timestamp put: (TimeStamp fromString: (line at: #timestamp))].
	attribute chat: chatCopy asOrderedCollection.! !

!XpfComplexAttribute class methodsFor: 'private' stamp: 'mt 5/28/2009 19:10'!
scanCommentFrom: strm for: attribute

	attribute comment: (ByteArray fromHex: (strm upTo: $-)) asString.! !

!XpfComplexAttribute class methodsFor: 'private' stamp: 'mt 5/3/2009 21:19'!
scanCreatorFrom: strm for: attribute

	attribute creator: (ByteArray fromHex: (strm upTo: $-)) asString.! !

!XpfComplexAttribute class methodsFor: 'instance creation' stamp: 'mt 10/16/2009 18:50'!
scanFrom: strm

	| count instance substream content |
	instance := self new.
	content := strm upTo: $#.
	count := (content findTokens: $-) size.

	(count < 4 or: [count > 5])
		ifTrue: [Transcript show: '[CodeTalk] Parsing failed.'; cr. ^ instance].
		
	substream := content readStream.
	self
		scanTimestampFrom: substream for: instance;
		scanCreatorFrom: substream for: instance;
		scanTagFrom: substream for: instance;
		scanChatFrom: substream for: instance.
	
	count = 5 ifTrue: [self scanCommentFrom: substream for: instance].
	instance creator.
	^ instance! !

!XpfComplexAttribute class methodsFor: 'private' stamp: 'mt 5/1/2009 14:37'!
scanTagFrom: strm for: attribute

	attribute tag: (strm upTo: $-) asSymbol.! !

!XpfComplexAttribute class methodsFor: 'private' stamp: 'mt 5/3/2009 21:19'!
scanTimestampFrom: strm for: attribute

	attribute timestamp: (TimeStamp fromString:
		(ByteArray fromHex: (strm upTo: $-)) asString).! !

!XpfComplexAttribute class methodsFor: 'caching' stamp: 'mt 5/28/2009 19:14'!
tags
	"Return a list of all available tags."

	^ #(bad talk comment)! !

!XpfComplexAttribute class methodsFor: 'caching' stamp: 'mt 6/23/2009 17:22'!
uniqueArrayFor: aComplexAttribute
	
	^ {	aComplexAttribute creator.
		aComplexAttribute timestamp printString.
		aComplexAttribute chat isEmpty
			ifTrue: ['']
			ifFalse: [aComplexAttribute chat last at: #author].
		aComplexAttribute chat isEmpty
			ifTrue: ['']
			ifFalse: [(aComplexAttribute chat last at: #timestamp) printString].
		aComplexAttribute tag.
		aComplexAttribute comment}.! !

!XpfComplexAttribute class methodsFor: 'caching' stamp: 'mt 6/23/2009 17:22'!
wasRead: aComplexAttribute
	"Did the developer already read the given attribute?"
	
	(Preferences
		preferenceAt: #rememberMarkupReads
		ifAbsent: [Preference new rawValue: false])
		preferenceValue
			ifFalse: [readCache := nil. ^ false].
	
	^ (readCache ifNil: [readCache := Set new])
		includes: (self uniqueArrayFor: aComplexAttribute)! !

!XpfComplexAttribute methodsFor: 'chat' stamp: 'mt 7/2/2009 22:41'!
addChatLine: aString

	self chat add: (Dictionary newFrom: {
		#author -> Utilities authorInitials.
		#timestamp -> TimeStamp now.
		#message -> aString withBlanksTrimmed}).
	self changed: #chatLineAdded.! !

!XpfComplexAttribute methodsFor: 'chat' stamp: 'mt 4/30/2009 17:08'!
addDependent: anObject

	(self dependents includes: anObject)
		ifTrue: [^ self].
		
	^ super addDependent: anObject.! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 4/29/2009 21:51'!
chat

	chat ifNil: [chat := OrderedCollection new].
	^ chat! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 4/30/2009 11:15'!
chat: aCollection

	chat := aCollection.! !

!XpfComplexAttribute methodsFor: 'accessing read-only' stamp: 'mt 5/1/2009 17:11'!
chatMorph

	chatMorph ifNil: [chatMorph := XpfCtChatIconMorph new attribute: self].
	^ chatMorph! !

!XpfComplexAttribute methodsFor: 'reading' stamp: 'mt 6/8/2009 11:01'!
codeSnippetFor: aText
	"Return the code snippet that is marked by this attribute."
	
	(aText find: self)
		ifNotNilDo: [:interval |
			^ (aText copyFrom: interval first to: interval last) asString withBlanksTrimmed].
	^ ''! !

!XpfComplexAttribute methodsFor: 'accessing read-only' stamp: 'mt 5/1/2009 14:31'!
color

	^ self class colorForTag: self tag! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:09'!
comment

	comment ifNil: [comment := ''].
	^ comment! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 6/8/2009 10:36'!
comment: aString

	comment := aString asString withBlanksTrimmed.
	self changed: #commentChanged.! !

!XpfComplexAttribute methodsFor: 'accessing read-only' stamp: 'mt 5/28/2009 19:07'!
commentMorph

	commentMorph ifNil: [commentMorph := XpfCtCommentIconMorph new attribute: self].
	^ commentMorph! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 10/16/2009 18:54'!
creator

	creator ifNil: [creator := 'n/a'. Transcript show: '[CodeTalk] Attribute without author detected!!'; cr].
	^ creator! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 10/16/2009 18:47'!
creator: authorInitials

	creator := authorInitials.! !

!XpfComplexAttribute methodsFor: 'accessing read-only' stamp: 'mt 5/1/2009 17:24'!
deleteMorph

	deleteMorph ifNil: [deleteMorph := XpfCtDeleteIconMorph new attribute: self].
	^ deleteMorph! !

!XpfComplexAttribute methodsFor: 'displaying' stamp: 'mt 5/1/2009 15:37'!
displayOn: aCanvas in: drawBounds
	"Show some stuff on the canvas for this attribute."
	
	aCanvas
		fillRectangle: drawBounds
		color: self color.! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'cs 5/4/2009 02:27'!
includesChatLine: aString

	self chat do: [:dict |
		((dict at: #message) includesSubString: aString)
			ifTrue: [^ true]].
	^ false! !

!XpfComplexAttribute methodsFor: 'chat' stamp: 'mt 6/12/2009 15:48'!
isAuthorMentioned
	"Look into the chat messages to find out if this image's author is mentioned in a message."
	
	| rx |
	rx := ('\\<{1}\\>' format: {Utilities authorInitials}) asRegex.
	^ self chat anySatisfy: [:line | rx search: (line at: #message)]! !

!XpfComplexAttribute methodsFor: 'testing' stamp: 'mt 6/5/2009 14:41'!
isMine

	^ self creator = Utilities authorInitials! !

!XpfComplexAttribute methodsFor: 'accessing read-only' stamp: 'mt 5/28/2009 19:18'!
morph

	morph ifNil: [morph := XpfCtRowMorph for: {
		self tag = #comment
			ifTrue: [self commentMorph]
			ifFalse: [self chatMorph].
		self resizeMorph.
		self deleteMorph}].
	^ morph! !

!XpfComplexAttribute methodsFor: 'reading' stamp: 'mt 6/2/2009 18:04'!
read

	self class read: self.! !

!XpfComplexAttribute methodsFor: 'event handling' stamp: 'mt 5/1/2009 17:33'!
requestDeletion

	self changed: #deleteRequested with: self.! !

!XpfComplexAttribute methodsFor: 'event handling' stamp: 'mt 5/3/2009 19:47'!
requestResizing
	"No need to give us away because the pure selection in a paragraph will handle this."

	self changed: #resizeRequested.! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 5/18/2009 10:40'!
resetMorphs

	morph := nil.
	chatMorph := nil.
	resizeMorph := nil.
	deleteMorph := nil.! !

!XpfComplexAttribute methodsFor: 'accessing read-only' stamp: 'mt 5/3/2009 19:20'!
resizeMorph

	resizeMorph ifNil: [resizeMorph := XpfCtResizeIconMorph new attribute: self].
	^ resizeMorph! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 5/1/2009 14:31'!
tag

	^ tag! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 5/18/2009 10:42'!
tag: aSymbol
	"Tag this attribute. Different tags allows to display this attribute in different ways."

	tag := (self class tags includes: aSymbol) ifTrue: [aSymbol] ifFalse: [].
	self resetMorphs.! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 5/2/2009 15:47'!
timestamp

	timestamp ifNil: [timestamp := TimeStamp now].
	^ timestamp! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 5/2/2009 15:45'!
timestamp: aTimeStamp

	timestamp := aTimeStamp.! !

!XpfComplexAttribute methodsFor: 'displaying' stamp: 'mt 1/16/2010 17:11'!
updateMorphs: someAttributes start: startIndex stop: stopIndex

	((someAttributes size = 1) and: [startIndex ~= stopIndex])
		ifTrue: [self resizeMorph visible: true]
		ifFalse: [self resizeMorph visible: false]! !

!XpfComplexAttribute methodsFor: 'reading' stamp: 'mt 6/2/2009 18:04'!
wasRead

	^ self class wasRead: self! !

!XpfComplexAttribute methodsFor: 'scanning' stamp: 'mt 5/2/2009 15:51'!
writeChatOn: strm

	| chatCopy |
	chatCopy := self chat collect: [:line |
		Dictionary newFrom: {
			#timestamp -> (line at: #timestamp) printString.
			#author -> (line at: #author).
			#message -> (line at: #message)}].
	strm nextPutAll: (Json render: chatCopy) toHex.
	strm nextPut: $-.! !

!XpfComplexAttribute methodsFor: 'scanning' stamp: 'mt 5/28/2009 20:08'!
writeCommentOn: strm

	strm nextPutAll: self comment toHex.
	strm nextPut: $-.! !

!XpfComplexAttribute methodsFor: 'scanning' stamp: 'mt 5/2/2009 15:52'!
writeCreatorOn: strm

	strm nextPutAll: self creator toHex.
	strm nextPut: $-.! !

!XpfComplexAttribute methodsFor: 'scanning' stamp: 'mt 6/24/2009 09:27'!
writeScanOn: strm

	strm nextPut: $h.
	self
		writeTimestampOn: strm;
		writeCreatorOn: strm;
		writeTagOn: strm;
		writeChatOn: strm;
		writeCommentOn: strm.
	strm nextPut: $#. "mark end of attribute stream"! !

!XpfComplexAttribute methodsFor: 'scanning' stamp: 'mt 5/1/2009 14:34'!
writeTagOn: strm

	strm nextPutAll: (self tag ifNil: [$0]).
	strm nextPut: $-.! !

!XpfComplexAttribute methodsFor: 'scanning' stamp: 'mt 5/2/2009 16:08'!
writeTimestampOn: strm

	strm nextPutAll: self timestamp printString toHex.
	strm nextPut: $-.! !

XpfCtMorphAttribute subclass: #XpfCtIconBarAttribute
	instanceVariableNames: 'chatMorph deleteMorph resizeMorph morph commentMorph mode reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfCtIconBarAttribute class methodsFor: 'as yet unclassified' stamp: 'mt 1/16/2010 19:08'!
forReference: aReferenceAttribute

	^ self new
		reference: aReferenceAttribute! !

!XpfCtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 19:14'!
chatMorph

	^ chatMorph ifNil: [chatMorph := XpfCtChatIconMorph new attribute: self reference]! !

!XpfCtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 19:14'!
commentMorph

	^ commentMorph ifNil: [commentMorph := XpfCtCommentIconMorph new attribute: self reference]! !

!XpfCtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 19:09'!
deleteMorph

	^ deleteMorph ifNil: [deleteMorph := XpfCtDeleteIconMorph new attribute: self reference]! !

!XpfCtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/22/2010 11:07:51'!
iconMorphs

	^ {self chatMorph. self commentMorph. self deleteMorph. self resizeMorph}! !

!XpfCtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 18:00'!
mode

	^ mode! !

!XpfCtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/17/2010 17:05'!
mode: anObject

	mode := anObject.
	morph := nil.! !

!XpfCtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 18:01'!
morph

	morph ifNil: [morph := XpfCtRowMorph for: {
		self mode = #comment
			ifTrue: [self commentMorph]
			ifFalse: [self chatMorph].
		self resizeMorph.
		self deleteMorph}].
	^ morph! !

!XpfCtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 19:07'!
reference

	^ reference! !

!XpfCtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/17/2010 16:16'!
reference: aReferenceAttribute

	reference := aReferenceAttribute.
	
	aReferenceAttribute addFriend: self.
	self mode: aReferenceAttribute markup tag.! !

!XpfCtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 19:09'!
resizeMorph

	^ resizeMorph ifNil: [resizeMorph := XpfCtResizeIconMorph new attribute: self reference]! !

!XpfCtIconBarAttribute methodsFor: 'displaying' stamp: 'mt 1/16/2010 18:01'!
updateMorphs: someAttributes start: startIndex stop: stopIndex

	((someAttributes size = 1) and: [startIndex ~= stopIndex])
		ifTrue: [self resizeMorph visible: true]
		ifFalse: [self resizeMorph visible: false]! !

!XpfCtMorphAttribute methodsFor: 'cleanup' stamp: 'mt 1/22/2010 11:17:34'!
cleanUp

	self iconMorphs do: [:m | m cleanUp]! !

!XpfCtMorphAttribute methodsFor: 'accessing' stamp: 'mt 1/22/2010 11:06:13'!
iconMorphs
	"Return all XpfCtAttributeIcon instances."
	
	^ #()! !

!XpfCtMorphAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:57'!
morph

	^ self subclassResponsibility.! !

!XpfCtMorphAttribute methodsFor: 'displaying' stamp: 'mt 1/16/2010 17:12'!
updateMorphs: someMorphAttributes start: startIndex stop: stopIndex
	"Use the chance to change your own appearance (e.g., visibility) according to the current selection."! !

XpfCtTextAttribute subclass: #XpfCtReferenceAttribute
	instanceVariableNames: 'markup friends theClass selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfCtReferenceAttribute commentStamp: 'mt 1/16/2010 19:10' prior: 0!
I am a reference for a markup to be used in a text.!

!XpfCtReferenceAttribute class methodsFor: 'instance creation' stamp: 'mt 1/16/2010 19:12'!
forMarkup: aMarkup

	^ self new
		markup: aMarkup! !

!XpfCtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 1/16/2010 19:18'!
addChatLine: aMessage

	self markup addChatLine: aMessage! !

!XpfCtReferenceAttribute methodsFor: 'friends' stamp: 'mt 1/17/2010 14:28'!
addFriend: aTextAttribute

	self friends add: aTextAttribute.! !

!XpfCtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 1/17/2010 13:02'!
chat

	^ self markup chat! !

!XpfCtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 1/17/2010 13:03'!
color

	^ self markup color! !

!XpfCtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 1/17/2010 16:16'!
comment

	^ self markup comment! !

!XpfCtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 1/17/2010 16:17'!
comment: aString

	self markup comment: aString! !

!XpfCtReferenceAttribute methodsFor: 'accessing' stamp: 'mt 1/17/2010 14:43'!
compiledMethod

	self theClass ifNil: [^ nil].
	self selector ifNil: [^ nil].
	^ self theClass >> self selector! !

!XpfCtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 1/17/2010 13:03'!
creator

	^ self markup creator! !

!XpfCtReferenceAttribute methodsFor: 'friends' stamp: 'mt 1/17/2010 14:27'!
friends
	"Friends are other text attributes that belong to this reference attribute and so should have the same range as defined in the markup."

	^ friends ifNil: [friends := OrderedCollection new]! !

!XpfCtReferenceAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 19:11'!
markup

	^ markup! !

!XpfCtReferenceAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 19:11'!
markup: anObject

	markup := anObject.! !

!XpfCtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 1/16/2010 19:15'!
read

	self markup read! !

!XpfCtReferenceAttribute methodsFor: 'signals' stamp: 'mt 1/16/2010 19:16'!
requestDeletion

	self changed: #deleteRequested with: self.! !

!XpfCtReferenceAttribute methodsFor: 'signals' stamp: 'mt 1/16/2010 19:16'!
requestResizing
	"No need to give us away because the pure selection in a paragraph will handle this."

	self changed: #resizeRequested.! !

!XpfCtReferenceAttribute methodsFor: 'accessing' stamp: 'mt 1/17/2010 14:34'!
selector

	^ selector! !

!XpfCtReferenceAttribute methodsFor: 'accessing' stamp: 'mt 1/17/2010 14:34'!
selector: anObject

	selector := anObject.! !

!XpfCtReferenceAttribute methodsFor: 'accessing' stamp: 'mt 1/17/2010 14:33'!
theClass

	^ theClass! !

!XpfCtReferenceAttribute methodsFor: 'accessing' stamp: 'mt 1/17/2010 14:33'!
theClass: anObject

	theClass := anObject.! !

!XpfCtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 1/17/2010 13:02'!
timestamp

	^ self markup timestamp! !

!XpfCtTextAttribute class methodsFor: 'text styling' stamp: 'mt 1/17/2010 12:05'!
shoutShouldPreserve

	^ ShoutShouldPreserve ifNil: [ShoutShouldPreserve := true]! !

!XpfCtTextAttribute class methodsFor: 'text styling' stamp: 'mt 1/17/2010 12:05'!
shoutShouldPreserve: aBoolean

	ShoutShouldPreserve := aBoolean.! !

!XpfCtTextAttribute methodsFor: 'testing' stamp: 'mt 1/16/2010 16:49'!
= other

	^ self == other! !

!XpfCtTextAttribute methodsFor: 'dependents access' stamp: 'mt 1/16/2010 19:06'!
addDependent: anObject

	(self dependents includes: anObject)
		ifTrue: [^ self].
		
	^ super addDependent: anObject.! !

!XpfCtTextAttribute methodsFor: 'html' stamp: 'mt 1/16/2010 16:48'!
closeHtmlOn: aStream 
	"put on the given stream the tag to close the html  
	representation of the receiver"
	aStream nextPutAll: '</span>'! !

!XpfCtTextAttribute methodsFor: 'displaying' stamp: 'mt 1/16/2010 16:50'!
displayOn: aCanvas in: drawBounds
	"Invisible."! !

!XpfCtTextAttribute methodsFor: 'html' stamp: 'mt 1/16/2010 16:48'!
openHtmlOn: aStream 
	"put on the given stream the tag to open the html  
	representation of the receiver"
	aStream nextPutAll: '<span>'! !

!XpfCtTextAttribute methodsFor: 'styling' stamp: 'mt 1/17/2010 12:06'!
shoutShouldPreserve
	
	^ self class shoutShouldPreserve! !

XpfCtTextAttribute subclass: #XpfCtTextBackgroundColor
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfCtTextBackgroundColor class methodsFor: 'instance creation' stamp: 'mt 1/16/2010 17:17'!
color: aColor

	^ self new
		color: aColor! !

!XpfCtTextBackgroundColor class methodsFor: 'constants' stamp: 'mt 1/16/2010 17:18'!
green

	^ self color: (Color green alpha: 0.4)! !

!XpfCtTextBackgroundColor class methodsFor: 'constants' stamp: 'mt 1/16/2010 17:18'!
red

	^ self color: (Color red alpha: 0.4)! !

!XpfCtTextBackgroundColor class methodsFor: 'constants' stamp: 'mt 1/16/2010 17:19'!
yellow

	^ self color: (Color yellow alpha: 0.4)! !

!XpfCtTextBackgroundColor methodsFor: 'accessing' stamp: 'mt 1/16/2010 17:19'!
color

	^ color ifNil: [color := Color transparent]! !

!XpfCtTextBackgroundColor methodsFor: 'accessing' stamp: 'mt 1/16/2010 17:16'!
color: anObject

	color := anObject.! !

!XpfCtTextBackgroundColor methodsFor: 'displaying' stamp: 'mt 1/17/2010 13:37'!
displayOn: aCanvas in: drawBounds
	"Show some stuff on the canvas for this attribute."
	
	aCanvas
		fillRectangle: drawBounds
		color: self color.! !

!OBCmdMultiView methodsFor: '*xpf-codetalk-override' stamp: 'mt 6/11/2009 18:25'!
execute
	"CodeTalk: Add a new menu item for CodeTalk styling. Recover original styler for shout first."
	
	|viewType|
	viewType := OBChoiceRequest labels: #(Source Bytecode Decompile PrettyPrint CodeTalk).
	self styler: SHTextStylerST80 new.
	viewType ifNotNil: [self perform: (#toggle, viewType) asSymbol]! !

!OBCmdMultiView methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 16:05'!
icon

	^ #xpfCtEyeIcon! !

!OBCmdMultiView methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 16:05'!
iconOnly

	^ true! !

!OBCmdMultiView methodsFor: '*xpf-codetalk' stamp: 'mt 6/11/2009 18:22'!
styler: styler
	"Proxy: Look for the current pluggable text morph in the definition panel and set the styler."
	
	| panel morph |
	panel := requestor browser definitionPanel. 
	morph := OBPluggableTextMorph allSubInstances
		detect: [:each | each model == panel]
		ifNone: [^ self].
	morph styler: (styler view: morph).! !

!OBCmdMultiView methodsFor: '*xpf-codetalk' stamp: 'mt 6/11/2009 18:25'!
toggleCodeTalk

	self
		styler: XpfTextStyler new;
		setTextInDefinitionPanel: target source.! !

!OBEnhancementDefinitionPanel methodsFor: '*xpf-codetalk' stamp: 'mt 6/23/2009 09:51'!
contentMorph
	"Enable easier navigation from definition panel to edit view in a command."

	^ contentMorph! !

!String methodsFor: '*xpf-codetalk' stamp: 'mt 5/2/2009 15:52'!
toHex

	^ self
		inject: ''
		into: [:result :char | result, char hex]! !

OBPaneScroller subclass: #XpfCtPaneScroller
	instanceVariableNames: 'firstColumnWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtPaneScroller commentStamp: 'mt 6/5/2009 15:51' prior: 0!
Just like OBPaneScroller but gives the first column a fixed space.!

!XpfCtPaneScroller methodsFor: 'accessing' stamp: 'mt 6/5/2009 16:01'!
firstColumnWidth

	firstColumnWidth ifNil: [firstColumnWidth := (Preferences standardListFont widthOf: $x) * 15].
	^ firstColumnWidth! !

!XpfCtPaneScroller methodsFor: 'accessing' stamp: 'mt 6/5/2009 15:55'!
firstColumnWidth: anObject

	firstColumnWidth := anObject.! !

!XpfCtPaneScroller methodsFor: 'layout' stamp: 'mt 6/5/2009 15:59'!
paneWidthsToFit: limit
	| padded newLimit |
	padded := Array new: self paneCount.
	newLimit := limit - self firstColumnWidth.
	padded atAllPut: (newLimit / (self sizing - 1)) floor.
	padded at: 1 put: self firstColumnWidth.
	(1 to: limit - padded sum) do: [:i | padded at: i put: (padded at: i) + 1].
	^ padded! !

OBLazyListMorph subclass: #XpfLazyListMorph
	instanceVariableNames: 'showCategories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfLazyListMorph methodsFor: 'displaying' stamp: 'bs 12/15/2009 12:40'!
display: item  atRow: row on: canvas
	"display the given item at row row"
	| drawBounds top icon node fontToUse |
	drawBounds := self drawBoundsForRow: row.
	drawBounds := drawBounds intersect: self bounds.
	node := listSource model children at: row.
	
	(listSource backgroundColorAt: row) ifNotNilDo: [:aColor | canvas fillRectangle: drawBounds color: aColor].

	"(node isKindOf: OBClassNode)
		ifTrue: [
			self indicateMarkupForClass: node on: canvas in: drawBounds.
			drawBounds := drawBounds left: drawBounds left + 2 + 6]."
	
	(listSource iconAt: row) ifNotNilDo: 
		[:name |
		icon := OBMorphicIcons iconNamed: name.
		top := drawBounds top + (drawBounds height - icon height // 2).
		canvas translucentImage: icon at: drawBounds left @ top.
		drawBounds := drawBounds left: drawBounds left + icon width + 2].
	
	fontToUse := item isText
		ifTrue: [font emphasized: (item emphasisAt: 1)]
		ifFalse: [font].
	
	canvas
		drawString: item
		in: drawBounds
		font: fontToUse
		color: (self colorForRow: row).
	
	drawBounds := drawBounds left: drawBounds left + (fontToUse widthOfString: item asString).

	(node isKindOf: OBMethodNode) "& (row ~= selectedRow)"
		ifTrue: [drawBounds := self
			displayCategoryFor: node
			in: drawBounds
			on: canvas].
		
	(node isKindOf: OBMethodNode)
		ifTrue: [
			drawBounds := self
				indicateMarkupFor: node
				on: canvas
				in: drawBounds].! !

!XpfLazyListMorph methodsFor: 'displaying' stamp: 'mt 5/5/2009 14:59'!
displayCategoryFor: aMethodNode in: drawBounds on: aCanvas

	| txt |
	self updateProperties.
	aMethodNode theClass == nil ifTrue: [^ drawBounds].
	
	txt := ' ({1})' format: {aMethodNode categoryText}.
	showCategories ifTrue: [aCanvas
		drawString: txt
		in: drawBounds
		font: font
		color: ((aMethodNode categoryText = 'as yet unclassified')
			ifTrue: [Color red]
			ifFalse: [Color gray])].
		
	^ drawBounds left: drawBounds left + (font widthOfString: txt asString) + 2! !

!XpfLazyListMorph methodsFor: 'displaying' stamp: 'mt 1/17/2010 11:42'!
indicateMarkupFor: aMethodNode on: aCanvas in: drawBounds

	| icon top newBounds |
	aMethodNode theClass ifNil: [^ drawBounds].
	
	newBounds := drawBounds.
	(XpfCtMarkupDatabase local
		markupsForClass: aMethodNode theClass
		selector: aMethodNode selector
		version: aMethodNode timeStamp)
		do: [ :markup |
			icon := markup tag = #bad
				ifTrue: [MenuIcons xpfCtSmallMarkBadIcon]
				ifFalse: [markup tag = #comment
					ifTrue: [MenuIcons xpfCtSmallAddCommentIcon]
					ifFalse: [MenuIcons xpfCtSmallMarkCommentIcon]].
			top := newBounds top + (newBounds height - icon height // 2) + 1.
			aCanvas translucentImage: icon at: newBounds left @ top.
			newBounds := newBounds left: newBounds left + icon width].
	^ newBounds! !

!XpfLazyListMorph methodsFor: 'displaying' stamp: 'mt 5/5/2009 14:56'!
indicateMarkupForClass: aClassNode on: aCanvas in: drawBounds

	| left top icon |
	(aClassNode methods anySatisfy: [:node | node source asText includesAttributesOfKind: XpfComplexAttribute])
		ifTrue: [
			icon := MenuIcons markGoodIcon.
			top := drawBounds top + (drawBounds height - icon height // 2).
			left := drawBounds left - 5.
			aCanvas
				translucentImage: icon
				at: left @ top].! !

!XpfLazyListMorph methodsFor: 'accessing' stamp: 'mt 5/1/2009 17:03'!
updateProperties

	showCategories ifNil: [showCategories := 
		(Preferences
			preferenceAt: #showProtocolForMessage
			ifAbsent: [Preference new rawValue: false])
			preferenceValue].! !

!MethodReference methodsFor: '*xpf-codetalk' stamp: 'mt 6/2/2009 15:07'!
theClassName

	^ '{1}{2}' format: {
		self classSymbol.
		self classIsMeta
			ifTrue: [' class']
			ifFalse: ['']}! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:00'!
attributesOfKind: anAttrClass
	"Return a collection with all instances of the given attribute class that can be found in this text."
	
	| result |
	result := OrderedCollection new.
	runs values do: [:array |
		array do: [:attr | (attr isKindOf: anAttrClass)
			ifTrue: [result addIfNotPresent: attr]]].
	^ result! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 5/18/2009 11:16'!
attributesOfKind: anAttrClass from: start to: stop
	"Return a collection with all instances of the given attribute class that can be found in the specified range."
	
	| part result |
	start > stop ifTrue: [
		^ (self attributesAt: start) select: [:attr | attr isKindOf: anAttrClass]].
	
	result := OrderedCollection new.
	part := self copyFrom: start to: stop.
	part runs withStartStopAndValueDo: [:i :j :attributes |
		attributes
			select: [:attr | attr isKindOf: anAttrClass]
			thenDo: [:attr | result addIfNotPresent: attr]].
	^ result.! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 14:01'!
includesAttributesOfKind: anAttrClass
	"Check whether this text has at least one run that includes an attribute of the given class."
	
	runs values do: [:array |
		array do: [:attr | (attr isKindOf: anAttrClass) ifTrue: [^ true]]].
	^ false! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 18:37'!
includesAttributesOfKind: anAttrClass from: start to: stop
	"Check whether this text has at least one run that includes an attribute of the given class in the specified range."
	
	| part |
	part := self copyFrom: start to: stop.
	part runs values do: [:array |
		array do: [:attr | (attr isKindOf: anAttrClass) ifTrue: [^ true]]].
	^ false! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:08'!
removeAttribute: attr
	
	self removeAttribute: attr from: 1 to: self size.! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 13:56'!
removeAttribute: anAttribute around: index
	
	self removeAttribute: anAttribute around: index and: index.! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 15:08'!
removeAttribute: anAttribute around: leftIndex and: rightIndex
	"Remove the given attribute from all indices that are adjacent to the given ones."

	| start stop |
	start := leftIndex.
	[start > 0 and: [(self attributesAt: start) includes: anAttribute]]
		whileTrue: [start := start - 1].
	stop := rightIndex.
	[stop <= self size and: [(self attributesAt: stop) includes: anAttribute]]
		whileTrue: [stop := stop + 1].

	self removeAttribute: anAttribute from: (start max: 0) to: (stop min: runs size).! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:08'!
removeAttribute: attr from: start to: stop
	"Removes an attribute kind over the interval start to stop."
	
	runs := runs
		copyReplaceFrom: start
		to: stop
		with: ((runs copyFrom: start to: stop)	mapValues:
			[:attributes | attributes reject: [:each | each = attr]])! !

Object subclass: #XpfCodeTalk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfCodeTalk class methodsFor: 'services' stamp: 'mt 6/6/2009 09:11'!
highlightAuthorInitialsFor: aText
	"Look for this image's author initials and highlight them. This will modify the attributse of the given text."
	
	| rx s strm links |
	rx := ('\\<{1}\\>' format: {Utilities authorInitials}) asRegex.
	s := aText asString.
	strm := s readStream.
	links := OrderedCollection new.
	
	[rx searchStream: strm]
		whileTrue: [
			links add: {
				rx subBeginning: 1.
				rx subEnd: 1}].

	links do: [:link |
		aText
			addAttribute: TextColor red
			from: link first + 1
			to: link second.
		aText
			addAttribute: TextEmphasis bold
			from: link first + 1
			to: link second].
		
	^ aText! !

!XpfCodeTalk class methodsFor: 'initialization' stamp: 'mt 5/26/2009 13:00'!
initialize
	"Resend this message whenever you checkout a new version of CodeTalk."
	
	super initialize.
	self
		initializeMonticello;
		initializePreferences;
		initializeOtherClasses;
		registerInToolsFlap;
		registerInWorldMenu.! !

!XpfCodeTalk class methodsFor: 'initialization' stamp: 'mt 1/17/2010 22:18'!
initializeMonticello

	(MCMethodDefinition allInstVarNames includes: #sourceText)
		ifFalse:[MCMethodDefinition addInstVarName: #sourceText]. self flag: #deprecated.
		
	(MCVersion allInstVarNames includes: #markups)
		ifFalse:[MCVersion addInstVarName: #markups].
		
	(MCMczReader allInstVarNames includes: #markups)
		ifFalse:[MCMczReader addInstVarName: #markups].! !

!XpfCodeTalk class methodsFor: 'initialization' stamp: 'mt 1/17/2010 12:34'!
initializeOtherClasses
	
	(Smalltalk includesKey: #XpfEditor)
		ifTrue: [XpfEditor initializeCmdKeyShortcuts].
		
	(Smalltalk includesKey: #XpfComplexAttribute)
		ifTrue: [XpfComplexAttribute reset]. self flag: #deprecated.
		
	(Smalltalk includesKey: #XpfCtMarkup)
		ifTrue: [XpfCtMarkup reset].
		
	((Smalltalk includesKey: #SwaSourceTextStyler)
	and: [(Smalltalk includesKey: #XpfCtSourceTextStyler)])
		ifTrue: [SwaSourceTextStyler instance registeredStylers
			detect: [:styler | styler isKindOf: XpfCtSourceTextStyler]
			ifNone: [SwaSourceTextStyler instance registerStyler: (XpfCtSourceTextStyler new)]]! !

!XpfCodeTalk class methodsFor: 'initialization' stamp: 'rkrk 9/24/2009 23:54'!
initializePreferences
		
	(Preferences dictionaryOfPreferences includesKey: #showLineNumbers)
		ifFalse: [Preferences
			addBooleanPreference: #showLineNumbers
			category: #CodeTalk
			default: false
			balloonHelp: 'Enables line numbers in front of each codeline.'].
		
	(Preferences dictionaryOfPreferences includesKey: #showProtocolForMessage)
		ifFalse: [Preferences
			addBooleanPreference: #showProtocolForMessage
			category: #CodeTalk
			default: false
			balloonHelp: 'Displays the protocol name after each message name in the code browser.'].
		
	(Preferences dictionaryOfPreferences includesKey: #browseMarkupsAfterLoadMerge)
		ifFalse: [Preferences
			addBooleanPreference: #browseMarkupsAfterLoadMerge
			category: #CodeTalk
			default: true
			balloonHelp: 'Brings up the markup browser for the current Monticello package after a merge or a load.'].
		
	(Preferences dictionaryOfPreferences includesKey: #showCodeTalkToolbar)
		ifFalse: [Preferences
			addBooleanPreference: #showCodeTalkToolbar
			category: #CodeTalk
			default: true
			balloonHelp: 'Show a convenient toolbar for markups in the package browser.'].
		
	(Preferences dictionaryOfPreferences includesKey: #rememberMarkupReads)
		ifFalse: [Preferences
			addBooleanPreference: #rememberMarkupReads
			category: #CodeTalk
			default: true
			balloonHelp: 'Shows markups differently in markup browser that have been already read.'].

	Preferences setPreference: #confirmFirstUseOfStyle toValue: false.
	Preferences setPreference: #alwaysShowVScrollbar toValue: false.! !

!XpfCodeTalk class methodsFor: 'as yet unclassified' stamp: 'mt 5/9/2009 17:30'!
registerInToolsFlap

	self environment at: #Flaps ifPresent: [ :class |
		class
			registerQuad: {
				#XpfCtTagSearchMorph.
				#prototypicalToolWindow.
				XpfCtTagSearchMorph title.
				'A tool for discovering methods that contains different kind of markup'}
			forFlapNamed: 'Tools';
			replaceToolsFlap.
		class
			registerQuad: {
				#XpfCtTagAnalysisMorph.
				#prototypicalToolWindow.
				XpfCtTagAnalysisMorph title.
				'A tool for analyze markup of methods'}
			forFlapNamed: 'Tools';
			replaceToolsFlap].! !

!XpfCodeTalk class methodsFor: 'as yet unclassified' stamp: 'mt 5/9/2009 17:30'!
registerInWorldMenu

	self environment at: #TheWorldMenu ifPresent: [ :class |
		class registerOpenCommand: {
			XpfCtTagSearchMorph title.
			{XpfCtTagSearchMorph. #open}}.
		class registerOpenCommand: {
			XpfCtTagAnalysisMorph title.
			{XpfCtTagAnalysisMorph. #open}}]! !

!XpfCodeTalk class methodsFor: 'as yet unclassified' stamp: 'mt 5/30/2009 10:39'!
todoClass

	"Dummy."! !

!XpfCodeTalk methodsFor: 'testing' stamp: 'mt 1/16/2010 19:58'!
foobar! !

!XpfCodeTalk methodsFor: 'testing' stamp: 'cs 6/8/2009 11:43'!
todoTakeTwo

	"Featulre cchamt:h herhe."! !

Object subclass: #XpfCtClassRecord
	instanceVariableNames: 'theClassName methodRecords'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Database'!

!XpfCtClassRecord commentStamp: 'mt 1/16/2010 11:43' prior: 0!
I am a container for class markups and method records.!

!XpfCtClassRecord class methodsFor: 'instance creation' stamp: 'mt 1/16/2010 15:07'!
newFrom: aClassOrMetaClass

	^ self new
		theClassName: aClassOrMetaClass name! !

!XpfCtClassRecord methodsFor: 'query - records' stamp: 'mt 1/16/2010 12:19'!
at: aSelector

	^ self methodRecords
		at: aSelector
		ifAbsent: [(self theClass canUnderstand: aSelector)
			ifTrue: [self methodRecords at: aSelector put:
				(XpfCtMethodRecord newFrom: self theClass >> aSelector)]]
	! !

!XpfCtClassRecord methodsFor: 'query - records' stamp: 'mt 1/16/2010 15:29'!
includes: aSelector

	^ self methodRecords
		includesKey: aSelector
! !

!XpfCtClassRecord methodsFor: 'accessing' stamp: 'mt 1/16/2010 12:03'!
methodRecords
	"Key: Selector (ByteSymbol), Value: Method Record (XpfCtMethodRecord)"

	^ methodRecords ifNil: [methodRecords := Dictionary new]! !

!XpfCtClassRecord methodsFor: 'query - environment' stamp: 'mt 1/16/2010 12:06'!
theClass

	^ self theClassName
		ifNotNilDo: [:name | Smalltalk classNamed: name]! !

!XpfCtClassRecord methodsFor: 'accessing' stamp: 'mt 1/16/2010 11:58'!
theClassName

	^ theClassName! !

!XpfCtClassRecord methodsFor: 'accessing' stamp: 'mt 1/16/2010 11:58'!
theClassName: anObject

	theClassName := anObject.! !

Object subclass: #XpfCtCodeChatModel
	instanceVariableNames: 'attribute searchString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtCodeChatModel methodsFor: 'adding' stamp: 'mt 5/3/2009 14:14'!
addMessage: aMessage

	aMessage ifEmpty: [^ self].
	self attribute ifNil: [^ self].
	self attribute addChatLine: aMessage.
	self
		changed: #messages;
		changed: #newMessage;
		changed: #lastIndex;
		changed: #hasMessages.! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 4/29/2009 22:22'!
attribute

	^ attribute! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 4/29/2009 22:22'!
attribute: anXpfComplexAttribute

	attribute := anXpfComplexAttribute.
	self changed: #messages.! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 5/3/2009 14:14'!
hasMessages

	^ self attribute notNil and: [self attribute chat isEmpty not].! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 5/1/2009 18:39'!
lastIndex
	"Used to show the latest message"
	
	self attribute ifNil: [^ 0].
	^ self attribute chat size! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 5/3/2009 14:05'!
messages

	self attribute ifNil: [^ #()].
	
	^ self attribute chat collect: [:line | | msgMorph |
		msgMorph := XpfCtMessageMorph
		timestamp: (line at: #timestamp)
		author: (line at: #author)
		message: (line at: #message).
		self searchString ifNotEmpty: [msgMorph highlightIf: self searchString].
		msgMorph]! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 5/1/2009 18:07'!
newMessage

	^ ''! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 5/3/2009 13:58'!
searchString

	searchString ifNil: [searchString := ''].
	^ searchString! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 5/3/2009 14:21'!
searchString: aString

	searchString := aString.
	self changed: #messages.! !

Object subclass: #XpfCtCommentEditorModel
	instanceVariableNames: 'attribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtCommentEditorModel methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:36'!
attribute

	^ attribute! !

!XpfCtCommentEditorModel methodsFor: 'accessing' stamp: 'mt 5/28/2009 20:07'!
attribute: anObject

	attribute := anObject.
	self changed: #comment.! !

!XpfCtCommentEditorModel methodsFor: 'accessing' stamp: 'mt 6/5/2009 13:43'!
comment

	self attribute ifNil: [^ ''].
	^ XpfCtMethodLink addMethodLinksInto: self attribute comment asText! !

!XpfCtCommentEditorModel methodsFor: 'accessing' stamp: 'mt 5/28/2009 20:03'!
comment: aString

	self attribute comment: aString.! !

Object subclass: #XpfCtGraphModel
	instanceVariableNames: 'inspector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtGraphModel class methodsFor: 'instance creation' stamp: 'mt 5/9/2009 14:18'!
newForInspector: anMczInspector

	^ self new
		inspector: anMczInspector! !

!XpfCtGraphModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 14:19'!
inspector

	^ inspector! !

!XpfCtGraphModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 14:02'!
inspector: anObject

	self inspector ifNotNilDo: [:i | i removeDependent: self].
	inspector := anObject.
	self inspector ifNotNilDo: [:i | i addDependent: self].! !

!XpfCtGraphModel methodsFor: 'processing' stamp: 'mt 5/9/2009 15:56'!
processFinish

	self subclassResponsiblity.! !

!XpfCtGraphModel methodsFor: 'processing' stamp: 'mt 5/9/2009 14:07'!
processResult: aDictionary

	self subclassResponsiblity.! !

!XpfCtGraphModel methodsFor: 'processing' stamp: 'mt 5/9/2009 14:55'!
reset

	self changed: #reset.! !

!XpfCtGraphModel methodsFor: 'updating' stamp: 'mt 5/9/2009 15:56'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #isRunning ifTrue: [
		self inspector isRunning ifTrue: [self reset]].
	aSymbol = #done ifTrue: [self processFinish].	! !

!XpfCtGraphModel methodsFor: 'updating' stamp: 'mt 5/9/2009 14:07'!
update: aSymbol with: aDictionary

	super update: aSymbol with: aDictionary.
	aSymbol = #resultFound ifTrue: [self processResult: aDictionary].! !

XpfCtGraphModel subclass: #XpfCtTestGraphModel
	instanceVariableNames: 'versionCount attributeCount currentVersionName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtTestGraphModel methodsFor: 'initialize-release' stamp: 'mt 5/9/2009 15:57'!
initialize

	super initialize.
	self resetCache.! !

!XpfCtTestGraphModel methodsFor: 'processing' stamp: 'mt 5/15/2009 14:46'!
pointFound

	versionCount > 0
		ifTrue: [self changed: #newPoint with: versionCount@attributeCount].! !

!XpfCtTestGraphModel methodsFor: 'processing' stamp: 'mt 5/15/2009 14:39'!
processFinish

	self pointFound.! !

!XpfCtTestGraphModel methodsFor: 'processing' stamp: 'mt 5/15/2009 14:39'!
processResult: aDictionary

	currentVersionName ifEmpty: [
		currentVersionName := (aDictionary at: #info) name.
		attributeCount := (aDictionary at: #attributes) size.
		versionCount := ((aDictionary at: #info) name findTokens: $.) last asNumber.
		^ self].

	currentVersionName = (aDictionary at: #info) name
		ifTrue: [
			attributeCount := attributeCount + (aDictionary at: #attributes) size]
		ifFalse: [
			self pointFound.
			versionCount := ((aDictionary at: #info) name findTokens: $.) last asNumber.
			currentVersionName := (aDictionary at: #info) name.
			attributeCount := (aDictionary at: #attributes) size].! !

!XpfCtTestGraphModel methodsFor: 'processing' stamp: 'mt 5/9/2009 15:57'!
reset

	super reset.
	self resetCache.! !

!XpfCtTestGraphModel methodsFor: 'processing' stamp: 'mt 5/9/2009 15:57'!
resetCache

	versionCount := 0.
	attributeCount := 0.
	currentVersionName := ''.! !

Object subclass: #XpfCtMarkup
	instanceVariableNames: 'tag chat creator timestamp comment range'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Database'!

XpfCtMarkup class
	instanceVariableNames: 'colorTable readCache'!

XpfCtMarkup class
	instanceVariableNames: 'colorTable readCache'!

!XpfCtMarkup class methodsFor: 'color mapping' stamp: 'mt 1/16/2010 16:17'!
colorForTag: aSymbol

	colorTable ifNil: [colorTable := Dictionary newFrom: {
		#bad -> (Color red alpha: 0.4).
		#talk -> (Color yellow alpha: 0.4).
		#comment -> (Color green alpha: 0.4)}].
	
	^ colorTable at: aSymbol ifAbsent: [Color transparent]! !

!XpfCtMarkup class methodsFor: 'instance creation' stamp: 'mt 1/16/2010 16:17'!
forTag: aSymbol

	^ self new
		tag: aSymbol;
		timestamp: TimeStamp now;
		creator: Utilities authorInitials! !

!XpfCtMarkup class methodsFor: 'instance creation' stamp: 'mt 1/16/2010 16:25'!
newFromComplexAttribute: aComplexAttribute

	^ (self forTag: aComplexAttribute tag)
		chat: aComplexAttribute chat;
		creator: aComplexAttribute creator;
		timestamp: aComplexAttribute timestamp;
		comment: aComplexAttribute comment! !

!XpfCtMarkup class methodsFor: 'caching' stamp: 'mt 1/16/2010 16:14'!
read: aComplexAttribute
	"Tell the local cache that the given attribute was read by the developer."
	
	(Preferences
		preferenceAt: #rememberMarkupReads
		ifAbsent: [Preference new rawValue: false])
		preferenceValue
			ifFalse: [^ self].
	
	(readCache ifNil: [readCache := Set new])
		add: (self uniqueArrayFor: aComplexAttribute).! !

!XpfCtMarkup class methodsFor: 'caching' stamp: 'mt 1/16/2010 16:14'!
reset
	"Free all cached values."
	
	colorTable := nil.
	readCache := nil.! !

!XpfCtMarkup class methodsFor: 'caching' stamp: 'mt 1/16/2010 16:14'!
tags
	"Return a list of all available tags."

	^ #(bad talk comment)! !

!XpfCtMarkup class methodsFor: 'caching' stamp: 'mt 1/17/2010 19:42'!
uniqueArrayFor: aMarkup
	
	^ {	aMarkup creator.
		aMarkup timestamp printString.
		aMarkup chat isEmpty
			ifTrue: ['']
			ifFalse: [aMarkup chat last at: #author].
		aMarkup chat isEmpty
			ifTrue: ['']
			ifFalse: [(aMarkup chat last at: #timestamp) printString].
		aMarkup tag.
		aMarkup comment.
		aMarkup range asString}.! !

!XpfCtMarkup class methodsFor: 'caching' stamp: 'mt 1/16/2010 16:15'!
wasRead: aMarkup
	"Did the developer already read the given attribute?"
	
	(Preferences
		preferenceAt: #rememberMarkupReads
		ifAbsent: [Preference new rawValue: false])
		preferenceValue
			ifFalse: [readCache := nil. ^ false].
	
	^ (readCache ifNil: [readCache := Set new])
		includes: (self uniqueArrayFor: aMarkup)! !

!XpfCtMarkup methodsFor: 'chat' stamp: 'mt 1/16/2010 16:11'!
addChatLine: aString

	self chat add: (Dictionary newFrom: {
		#author -> Utilities authorInitials.
		#timestamp -> TimeStamp now.
		#message -> aString withBlanksTrimmed}).! !

!XpfCtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:03'!
chat

	^ chat ifNil: [chat := OrderedCollection new]! !

!XpfCtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:04'!
chat: aCollection

	chat := aCollection.! !

!XpfCtMarkup methodsFor: 'as yet unclassified' stamp: 'test 1/16/2010 16:36'!
clone
	
	^ self deepCopy "Does this work as expected?"! !

!XpfCtMarkup methodsFor: 'reading' stamp: 'mt 1/17/2010 11:09'!
codeSnippetFor: aString
	"Return the code snippet that is marked by this markup."
	
	^ (aString asString copyFrom: self range first to: self range last) withBlanksTrimmed! !

!XpfCtMarkup methodsFor: 'accessing read-only' stamp: 'mt 1/16/2010 16:11'!
color

	^ self class colorForTag: self tag! !

!XpfCtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:04'!
comment

	^ comment ifNil: [comment := '']! !

!XpfCtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:08'!
comment: aString

	comment := aString asString withBlanksTrimmed.! !

!XpfCtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:08'!
creator

	creator ifNil: [creator := 'n/a'. Transcript show: '[CodeTalk] Attribute without author detected!!'; cr].
	^ creator! !

!XpfCtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:08'!
creator: authorInitials

	creator := authorInitials.! !

!XpfCtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:08'!
includesChatLine: aString

	self chat do: [:dict |
		((dict at: #message) includesSubString: aString)
			ifTrue: [^ true]].
	^ false! !

!XpfCtMarkup methodsFor: 'chat' stamp: 'mt 1/16/2010 16:12'!
isAuthorMentioned
	"Look into the chat messages to find out if this image's author is mentioned in a message."
	
	| rx |
	rx := ('\\<{1}\\>' format: {Utilities authorInitials}) asRegex.
	^ self chat anySatisfy: [:line | rx search: (line at: #message)]! !

!XpfCtMarkup methodsFor: 'testing' stamp: 'mt 1/17/2010 11:07'!
isGlobal
	"Check whether this markup applies only to a range or the whole subject."
	
	^ self range first > self range last! !

!XpfCtMarkup methodsFor: 'testing' stamp: 'mt 1/16/2010 16:13'!
isMine

	^ self creator = Utilities authorInitials! !

!XpfCtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 19:49'!
range

	^ range ifNil: [range := 0 to: -1]! !

!XpfCtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:33'!
range: aPoint

	range := aPoint! !

!XpfCtMarkup methodsFor: 'reading' stamp: 'mt 1/16/2010 16:13'!
read

	self class read: self.! !

!XpfCtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:09'!
tag

	^ tag! !

!XpfCtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:09'!
tag: aSymbol
	"Tag this attribute. Different tags allows to display this attribute in different ways."

	tag := (self class tags includes: aSymbol) ifTrue: [aSymbol] ifFalse: [].! !

!XpfCtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:10'!
timestamp

	timestamp ifNil: [timestamp := TimeStamp now].
	^ timestamp! !

!XpfCtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:10'!
timestamp: aTimeStamp

	timestamp := aTimeStamp.! !

!XpfCtMarkup methodsFor: 'reading' stamp: 'mt 1/16/2010 16:13'!
wasRead

	^ self class wasRead: self! !

Object subclass: #XpfCtMarkupDatabase
	instanceVariableNames: 'classRecords packageRecords'
	classVariableNames: 'Local'
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Database'!

!XpfCtMarkupDatabase commentStamp: 'mt 1/16/2010 11:36' prior: 0!
I store markups for packages, classes and methods. Find markups for methods by navigating through the corresponding class container. Due to the lack of namespaces, markups for packages are separately stored. There is no need to encapsulate classes within packages at this level.!

!XpfCtMarkupDatabase class methodsFor: 'as yet unclassified' stamp: 'mt 1/17/2010 20:52'!
local

	^ Local ifNil: [Local := self new]! !

!XpfCtMarkupDatabase class methodsFor: 'data migration' stamp: 'mt 1/16/2010 20:06'!
migrate
	"Migrate all markups from all methods in the system to the new database format. Could take a while because we need to read each method's source from the changes file."
	
	self resetLocal.
	
	Smalltalk classNames
		do: [:cname | | class |
			class := Smalltalk classNamed: cname.
			self
				migrateClass: class;
				migrateClass: class class.
			]
		displayingProgress: 'Converting classes...'.
		
	self local explore.! !

!XpfCtMarkupDatabase class methodsFor: 'data migration' stamp: 'mt 1/16/2010 20:24'!
migrateClass: aClass
	"See #migrate."
	
	| method source attrs markups |
	aClass selectors
		do: [:selector | 
			World displayWorldSafely.
			
			source := (aClass sourceCodeAt: selector) asText.
			method := aClass >> selector.			
			attrs := source attributesOfKind: XpfComplexAttribute.
			attrs do: [:attr |
				markups := ((XpfCtMarkupDatabase local at: aClass) at: selector) at: method.
				markups add: (XpfCtMarkup newFromComplexAttribute: attr).
				markups last range: (source find: attr)]]
		displayingProgress: 'Converting methods...'.! !

!XpfCtMarkupDatabase class methodsFor: 'as yet unclassified' stamp: 'mt 1/17/2010 20:52'!
resetLocal

	Local := nil.! !

!XpfCtMarkupDatabase methodsFor: 'query - records' stamp: 'mt 1/16/2010 19:42'!
at: aClass

	^ self classRecords
		at: aClass name asSymbol
		ifAbsent: [self classRecords at: aClass name asSymbol put:
				(XpfCtClassRecord newFrom: aClass)]! !

!XpfCtMarkupDatabase methodsFor: 'accessing' stamp: 'mt 1/16/2010 14:58'!
classRecords
	"Key: class name (ByteSymbol)"

	^ classRecords ifNil: [classRecords := Dictionary new]! !

!XpfCtMarkupDatabase methodsFor: 'query - records' stamp: 'mt 1/17/2010 12:56'!
includes: aClass

	^ aClass notNil and: [self classRecords includesKey: aClass name asSymbol]! !

!XpfCtMarkupDatabase methodsFor: 'query - markups' stamp: 'mt 1/17/2010 11:02'!
markupsForClass: aClass selector: aSelector
	"Fetch all markups for the given class and selector in the current version."
	
	^ self
		markupsForClass: aClass
		selector: aSelector
		version: (aClass >> aSelector) timeStamp! !

!XpfCtMarkupDatabase methodsFor: 'query - markups' stamp: 'mt 1/17/2010 10:53'!
markupsForClass: aClass selector: aSelector version: aTimeStamp
	"Query for markups. Use #includes: and #at: together to avoid filling the database with empty records."

	(self includes: aClass) ifTrue: [| classRecord |
		classRecord := self at: aClass.
		(classRecord includes: aSelector) ifTrue: [
			^ (classRecord at: aSelector) atTimeStamp: aTimeStamp]].
	
	^ #()! !

!XpfCtMarkupDatabase methodsFor: 'query - markups' stamp: 'mt 1/17/2010 14:44'!
markupsForCompiledMethod: aCompiledMethod
	
	aCompiledMethod
		ifNil: [^ #()].
	
	aCompiledMethod methodReference
		ifNil: [Transcript show: '[CodeTalk] Warning!! Compiled method has no information about class or selector!!'; cr].
	
	^ self
		markupsForClass: aCompiledMethod methodClass
		selector: aCompiledMethod selector
		version: aCompiledMethod timeStamp! !

!XpfCtMarkupDatabase methodsFor: 'query - markups' stamp: 'mt 1/17/2010 11:14'!
markupsForMethodReference: aMethodReference
	
	^ self
		markupsForClass: aMethodReference actualClass
		selector: aMethodReference methodSymbol! !

!XpfCtMarkupDatabase methodsFor: 'versioning' stamp: 'mt 1/22/2010 13:37:19'!
merge: aSnapshot
	"Reintegrate a versioned snapshot into this database."
	
	aSnapshot ifNil: [^ self].
	
	[
		aSnapshot classRecords do: [:classRecord |
			classRecord methodRecords do: [:methodRecord |
				methodRecord markups keysAndValuesDo: [:seconds :markups |
					((self at: classRecord theClass)
						at: methodRecord selector)
							markups at: seconds put: markups]]]
	] on: Error do: [:fallThrough |].! !

!XpfCtMarkupDatabase methodsFor: 'accessing' stamp: 'mt 1/16/2010 14:57'!
packageRecords
	"Key: package name (ByteSymbol)"

	^ packageRecords ifNil: [packageRecords := Dictionary new]! !

!XpfCtMarkupDatabase methodsFor: 'versioning' stamp: 'mt 1/17/2010 21:23'!
snapshot: aPackageName
	"Return a subset of this database that contains only MC-versioned records and new working copy records. All records related only to local versions are skipped. MC-Package specific."
	
	| info snapshot |
	info := PackageInfo named: aPackageName.
	snapshot := XpfCtMarkupDatabase new.
	info methods
		do: [:methodRef | | markups |
			markups := self markupsForMethodReference: methodRef.
			markups ifNotEmpty: [
				(((snapshot at: methodRef actualClass) at: methodRef methodSymbol)
					at: (methodRef actualClass >> methodRef methodSymbol)) addAll: markups]]
		displayingProgress: 'Snapshotting markups...'.
	^ snapshot! !

Object subclass: #XpfCtMczCache
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 14:28'!
addMczToCache: aStream at: aMczFileName
	"Need to write a clean zip."
	
	^ ZipArchive new
		readFrom: aStream;
		writeToFileNamed: (self cacheDirectory fullNameFor: aMczFileName).! !

!XpfCtMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 14:35'!
cacheAt: aFileName

	^ ZipArchive new
		readFrom: (self cacheDirectory readOnlyFileNamed: aFileName)! !

!XpfCtMczCache class methodsFor: 'caching' stamp: 'mt 5/26/2009 18:48'!
cacheAt: aFileName ifNoneGetFrom: anHttpRepository
	"Return a zip archive for the mcz file."

	^ (self includes: aFileName)
		ifTrue: [self cacheAt: aFileName]
		ifFalse: [
			anHttpRepository
				readStreamForFileNamed: aFileName
				do: [:strm | self addMczToCache: strm at: aFileName]]! !

!XpfCtMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 12:45'!
cacheDirectory

	^ (FileDirectory default directoryNamed: 'codetalk-cache')
		assureExistence;
		yourself! !

!XpfCtMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 13:25'!
includes: aFileName

	^ self cacheDirectory includesKey: aFileName! !

Object subclass: #XpfCtMczInspector
	instanceVariableNames: 'repositories isRunning process reader currentMethodDefinition followAncestors currentAncestors classFilter selectorFilter lastDefinition currentStep maxSteps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

XpfCtMczInspector class
	instanceVariableNames: 'exampleCache'!

XpfCtMczInspector class
	instanceVariableNames: 'exampleCache'!

XpfCtMczInspector subclass: #XpfCtMarkupInspector
	instanceVariableNames: 'location names stream password stream2 currentRepositoryName methodsWithMarkups lastResults thisResults currentVersionNumber markupLifetime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtMarkupInspector class methodsFor: 'instance creation' stamp: 'mt 10/16/2009 10:36'!
inspectLocation: aString with: someRepositoryNames into: aFileName

	^ self new
		location: aString;
		names: someRepositoryNames;
		setFileStream: aFileName;
		setFileStream2: 'd_', aFileName;
		start! !

!XpfCtMarkupInspector class methodsFor: 'swe09' stamp: 'bs 10/21/2009 12:59'!
inspectSwe09CtProjects

	| groups output |
	"groups := {'swe09-team04'. 'swe09-team05'. 'swe09-team08'. 'swe09-team13'}."
	groups := {'swe09-team08'}.
	output := 'swe09_{1}.csv' format: {Date today printFormat: #(1 2 3 $- 1 1 2)}.
	(XpfCtMarkupInspector
		inspectLocation: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/'
		with: groups
		into: output) inspect.! !

!XpfCtMarkupInspector class methodsFor: 'swe09' stamp: 'mt 6/8/2009 22:01'!
inspectSwe09Projects

	| groups output |
	groups := {'swe09-team01'. 'swe09-team02'. 'swe09-team03'. 'swe09-team04'. 'swe09-team05'. 'phidgetLab'. 'swe09-team07'. 'swe09-team08'. 'swe09-team09'. 'swe09-team10'. 'swe09-team11'. 'swe09-team12'. 'swe09-team13'. 'swe09-team14'. 'swe09-team15'. 'swe09-team16'}.
	output := 'swe09_{1}.csv' format: {Date today printFormat: #(1 2 3 $- 1 1 2)}.
	(XpfCtMarkupInspector
		inspectLocation: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/'
		with: groups
		into: output) inspect.! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'mt 10/16/2009 12:43'!
currentRepositoryName

	^ currentRepositoryName! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'mt 10/16/2009 12:43'!
currentRepositoryName: aString

	currentRepositoryName := aString.! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'bs 10/21/2009 12:09'!
currentVersionNumber

	^ currentVersionNumber! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'bs 10/21/2009 12:09'!
currentVersionNumber: anObject

	currentVersionNumber := anObject.! !

!XpfCtMarkupInspector methodsFor: 'inspecting' stamp: 'mt 10/16/2009 10:51'!
excelTime: aTimeStamp

	| time |
	time := ((aTimeStamp - (TimeStamp fromString: '1-1-1900 00:00:00 am')) 
		rawSeconds / (60 * 60 * 24) asFloat) + 2. "Need a two days delta."
	
	^ time integerPart asInteger asString, ',', (time fractionPart * 100000) asInteger asString! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'bs 10/19/2009 21:35'!
lastResults

	^ lastResults ifNil: [lastResults := Set new]! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'bs 10/19/2009 21:35'!
lastResults: anObject

	lastResults := anObject.! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'mt 6/8/2009 18:14'!
location

	^ location! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'mt 6/8/2009 18:14'!
location: anObject

	location := anObject.! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'bs 10/21/2009 12:34'!
markupLifetime

	^ markupLifetime ifNil: [markupLifetime := Dictionary new]! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'bs 10/21/2009 12:34'!
markupLifetime: anObject

	markupLifetime := anObject.! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'mt 10/16/2009 15:04'!
methodsWithMarkups

	^ methodsWithMarkups ifNil: [methodsWithMarkups := Set new]! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'mt 10/16/2009 15:04'!
methodsWithMarkups: anObject

	methodsWithMarkups := anObject.! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'mt 6/8/2009 18:14'!
names

	^ names! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'mt 6/8/2009 18:14'!
names: anObject

	names := anObject.! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'mt 6/8/2009 19:25'!
password

	password ifNil: [self password: ''].
	^ password! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'mt 6/8/2009 19:25'!
password: anObject

	password := anObject.! !

!XpfCtMarkupInspector methodsFor: 'inspecting' stamp: 'bs 10/21/2009 12:46'!
processMarkupLifetime

	| sum |
	self markupLifetime keys isEmpty ifTrue: [^ self].
	
	sum := 0.
	self markupLifetime valuesDo: [:value |
		sum := sum + value].
	
	Transcript show: 'avg lifetime: ', (sum asFloat / self markupLifetime keys size) asString; cr.! !

!XpfCtMarkupInspector methodsFor: 'inspecting' stamp: 'bs 10/21/2009 12:37'!
processMarkups: aMethodDefinition
	
	| attrs entry |
	attrs := aMethodDefinition sourceText asText attributesOfKind: XpfComplexAttribute.
	entry := {aMethodDefinition className. aMethodDefinition selector}.
	
	attrs ifNotEmpty: [ self methodsWithMarkups add: entry ].
	
	((self methodsWithMarkups includes: entry) and: [attrs isEmpty])
			ifTrue: [self writeDefinitionHeaderFor: aMethodDefinition].

	attrs do: [:attr | |hash|
		hash := {
			self currentRepositoryName.
			aMethodDefinition className.
			aMethodDefinition selector.
			attr timestamp asString
		}.
		
		self thisResults add: hash.
		
		(self markupLifetime keys includes: hash)
			ifTrue: [self markupLifetime at: hash put: ((self markupLifetime at: hash) + 1)]
			ifFalse: [self markupLifetime at: hash put: 1].
		
			self stream2
				nextPutAll: self currentRepositoryName;
				nextPut: $;;
				nextPutAll: aMethodDefinition className;
				nextPut: $;;
				nextPutAll: aMethodDefinition selector;
				nextPut: $;;
				nextPutAll: self currentVersionNumber asString;
				nextPut: $;;
				nextPutAll: (self excelTime: aMethodDefinition fullTimeStamp);
				nextPut: $;;
				nextPutAll: (self excelTime: attr timestamp);
				nextPut: $;;
				nextPutAll: attr creator;
				nextPut: $;;
				nextPutAll: (XpfComplexAttribute uniqueArrayFor: attr) hash asString;
				nextPut: $;;
				nextPutAll: attr tag;
				nextPut: $;;
				nextPutAll: (attr codeSnippetFor: aMethodDefinition sourceText asText) size asString;
				nextPut: $;;
				nextPutAll: attr chat size asString;
				nextPut: $;;
				nextPutAll: (attr chat inject: 0 into: [:sum :line | sum + (line at: #message) size]) asString;
				nextPut: $;;
				nextPutAll: attr comment size asString;
				nextPut: $;;
				nextPutAll: ((attr comment copyReplaceAll: ';' with: ',') copyReplaceAll: String cr with: ' ');
				cr.
			
			
			].! !

!XpfCtMarkupInspector methodsFor: 'inspecting' stamp: 'bs 10/21/2009 12:40'!
processNames

	| versions packages |
	self names do: [:repoName | |repo rx|
		self currentRepositoryName: repoName.
		
		Transcript show: '[CodeTalk] Repository: ', repoName; cr.
		
		repo := MCHttpRepository location: self location, repoName user: 'mt' password: self password.
		self password: repo password. "Cache password."

		self stream
			nextPutAll: 'location;num_packages'; cr;
			nextPutAll: repoName;
			nextPut: $;.

		rx := '([\w\-.]*)-(\w*).(\d*).mcz' asRegex.
		
		versions := (repo readableFileNames collect: [:fileName |
			rx search: fileName.
			{rx subexpression: 2. (rx subexpression: 4) asNumber. fileName}])
			sortBy: [:f1 :f2 | f1 second < f2 second].
			
		packages := Dictionary new.
		versions do: [:v |
			(packages includesKey: v first) ifFalse: [packages at: v first put: OrderedCollection new].
			(packages at: v first) add: {v second. v third}].
		
		self stream
			nextPutAll: packages keys size asString;
			cr;
			nextPutAll: 'package_name;num_versions';
			cr.
		
		packages keysAndValuesDo: [:packageName :versionNumbersAndfileNames |
			Transcript show: '[CodeTalk] Package: ', packageName; cr.
			self methodsWithMarkups: nil.
			self markupLifetime: nil.
			
			self stream
				nextPutAll: packageName;
				nextPut: $;;
				nextPutAll: versionNumbersAndfileNames size asString;
				cr;
				nextPutAll: 'number;version_name;timestamp;num_classes;num_methods;num_developers;num_markups;num_new_markups;num_lost_markups';
				cr.
				
			versionNumbersAndfileNames do: [:versionNumberAndFileName |
				self currentVersionNumber: versionNumberAndFileName first.
				self stream
					nextPutAll: self currentVersionNumber asString;
					nextPut: $;.
				
				[
					self lastResults: self thisResults copy.
					self thisResults: Set new.
					
					self reader readFile: versionNumberAndFileName second from: repo.
					self processReader.
					
					
				] on: Error do: [:fallThrough |].
				].
			
			self processMarkupLifetime.
			]].	! !

!XpfCtMarkupInspector methodsFor: 'inspecting' stamp: 'bs 10/19/2009 21:49'!
processReader

	| authors numMarkups |
	Transcript show: '[CodeTalk] Version: ', self reader info name; cr.
		
	self stream
		nextPutAll: self reader info name;
		nextPut: $;;
		nextPutAll: (self excelTime: self reader info timeStamp);
		nextPut: $;;
		nextPutAll: (self reader definitions count: [:def | def isClassDefinition]) asString;
		nextPut: $;;
		nextPutAll: (self reader definitions count: [:def | def isMethodDefinition]) asString;
		nextPut: $;.

	authors := Set new.
	numMarkups := 0.
	self reader definitions do: [:def | 
		def isMethodDefinition ifTrue: [
			self processMarkups: def.
			
			def timeStamp ifNotEmpty:
				[authors add: (def timeStamp findTokens: Character space) first].
			numMarkups := numMarkups + (def sourceText asText attributesOfKind: XpfComplexAttribute) size]].
	
	self stream
		nextPutAll: authors size asString;
		nextPut: $;;
		nextPutAll: numMarkups asString;
		nextPut: $;;
		nextPutAll: (self thisResults size - (self thisResults count: [:a | self lastResults includes: a])) asString;
		nextPut: $;;
		nextPutAll: (self lastResults size - (self lastResults count: [:a | self thisResults includes: a])) asString;
		cr.
! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'mt 10/16/2009 10:24'!
setFileStream2: aFileName

	self stream2: (StandardFileStream forceNewFileNamed: aFileName)! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'mt 6/8/2009 18:15'!
setFileStream: aFileName

	self stream: (StandardFileStream forceNewFileNamed: aFileName)! !

!XpfCtMarkupInspector methodsFor: 'inspecting' stamp: 'mt 10/16/2009 10:57'!
start

	process ifNotNil: [self stop].
	process := [
		self isRunning: true.
		self writeStream2Header.
		self processNames.
		self stream close.
		self stream2 close.
		self isRunning: false] fork priority: 35.! !

!XpfCtMarkupInspector methodsFor: 'inspecting' stamp: 'mt 10/16/2009 10:22'!
stop

	self stream close.
	self stream2 close.
	super stop.! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'mt 6/8/2009 18:14'!
stream

	^ stream! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'mt 10/16/2009 10:11'!
stream2

	^ stream2! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'mt 10/16/2009 10:11'!
stream2: anObject

	stream2 := anObject.! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'mt 6/8/2009 18:14'!
stream: anObject

	stream := anObject.! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'bs 10/19/2009 21:35'!
thisResults

	^ thisResults ifNil: [lastResults := Set new]! !

!XpfCtMarkupInspector methodsFor: 'accessing' stamp: 'bs 10/19/2009 21:35'!
thisResults: anObject

	thisResults := anObject.! !

!XpfCtMarkupInspector methodsFor: 'inspecting' stamp: 'bs 10/20/2009 21:11'!
writeDefinitionHeaderFor: aMethodDefinition
		
	self stream2
		nextPutAll: self currentRepositoryName;
		nextPut: $;;
		nextPutAll: aMethodDefinition className;
		nextPut: $;;
		nextPutAll: aMethodDefinition selector;
		nextPut: $;;
		nextPutAll: self reader info name;
		nextPut: $;;
		nextPutAll: (aMethodDefinition timeStamp ifNotEmpty: [(self excelTime: aMethodDefinition fullTimeStamp)] ifEmpty: ['0']);
		cr.! !

!XpfCtMarkupInspector methodsFor: 'inspecting' stamp: 'bs 10/20/2009 20:47'!
writeStream2Header
		
	self stream2
		nextPutAll: 'repo;class;selector;version;method_timestamp;creation_time;creator;hash;tag;snippet_size;chat_msg_count;chat_msg_length;comment_size;comment';
		cr.! !

!XpfCtMczInspector class methodsFor: 'examples' stamp: 'mt 5/19/2009 13:31'!
exampleVersions

	| instance result repo |
	exampleCache ifNotNilDo: [:c | ^ c].
	
	result := OrderedCollection new.
	instance := self newForPackageNamed: 'Xpf-CodeTalk'.
	repo := instance repositories first key.
	(repo readableFileNames
		select: [:filename | filename startsWith: 'Xpf-CodeTalk'])
		do: [:filename |
			instance zip: (XpfCtMczCache
				cacheAt: filename
				ifNoneGetFrom: repo).
			instance loadVersionInfo.
			
			(instance zip memberNamed: 'snapshot.bin') ifNotNilDo: [:bin |
			[(DataStream on: bin contentStream) next definitions
				select: [:def | def isMethodDefinition and: [def className = 'XpfCodeTalk' and: [def selector = #todo]]]
				thenDo: [:def | result add: (XpfCtRemoteMethodVersion
					repository: repo
					info: instance info
					definition: def)]]
				on: Error
				do: [:fallThrough | "Unknown content in snapshot.bin!!"]]] displayingProgress: 'Preparing...'.
	exampleCache := result.
	^ result! !

!XpfCtMczInspector class methodsFor: 'instance creation' stamp: 'rkrk 9/19/2009 19:41'!
newForPackageNamed: aString

	| instance pkg |
	instance := self new.
	pkg := MCPackage named: aString.
	pkg hasWorkingCopy ifFalse: [^ instance].
	pkg workingCopy repositoryGroup repositories
		select: [:r | r isKindOf: MCHttpRepository]
		thenDo: [:r | instance addRepository: r include: {aString}].
	^ instance! !

!XpfCtMczInspector class methodsFor: 'instance creation' stamp: 'rkrk 9/19/2009 23:51'!
newForPackagesNamed: packageNames inRepo: mcRepository

	| instance |
	instance := self new.
	instance
		addRepository: mcRepository
		include: packageNames.
	^ instance! !

!XpfCtMczInspector methodsFor: 'adding repos' stamp: 'rkrk 9/19/2009 19:04'!
addRepository: anHttpRepository include: somePackageNames
	"Add the given repo and decide which packages
	to use when looking at the contents of the repo later."
	
	self repositories add: (anHttpRepository -> somePackageNames).! !

!XpfCtMczInspector methodsFor: 'accessing' stamp: 'rkrk 9/19/2009 19:03'!
currentAncestors

	^ currentAncestors ifNil: [currentAncestors := Set new].! !

!XpfCtMczInspector methodsFor: 'accessing status' stamp: 'rkrk 9/19/2009 19:04'!
currentStep

	^ currentStep ifNil: [currentStep := 1].! !

!XpfCtMczInspector methodsFor: 'accessing status' stamp: 'mt 5/27/2009 10:03'!
currentStep: anObject

	currentStep := anObject.
	self changed: #currentStep.! !

!XpfCtMczInspector methodsFor: 'inspecting' stamp: 'rkrk 9/19/2009 23:37'!
filterFileNames: someFileNames packages: somePackageNames

	| result fileNamesMatching |
	fileNamesMatching := someFileNames select: [:filename |
		somePackageNames anySatisfy: [:name |
			self packageName: name matchesFileName: filename]].
	result := fileNamesMatching sortBy: [:f1 :f2 |
		(f1 findTokens: $.) second asNumber > (f2 findTokens: $.) second asNumber].
	^ self followAncestors
		ifTrue: [result]
		ifFalse: [result reversed]! !

!XpfCtMczInspector methodsFor: 'accessing' stamp: 'rkrk 9/19/2009 19:02'!
followAncestors

	^ followAncestors ifNil: [followAncestors := false].! !

!XpfCtMczInspector methodsFor: 'accessing' stamp: 'mt 5/13/2009 14:13'!
followAncestors: anObject

	followAncestors := anObject.! !

!XpfCtMczInspector methodsFor: 'inspecting - methods' stamp: 'rkrk 9/19/2009 22:53'!
inspectDefinitions

	| definition updateObject |
	definition := self reader definitions
		detect: [:def | def isMethodDefinition
			and: [classFilter = def actualClass]
			and: [selectorFilter = def selector]]
		ifNone: [^ self].
	lastDefinition = definition ifTrue: [^ self].
	updateObject := Dictionary newFrom: {
		#repository -> self reader repository.
		#definition -> definition.
		#info -> self reader info}.
	self changed: #matchingVersionFound with: updateObject.
	lastDefinition := definition.! !

!XpfCtMczInspector methodsFor: 'inspecting' stamp: 'rkrk 9/19/2009 22:53'!
inspectRepository: anHttpRepository include: somePackageNames

	| filenames shouldInspectDefs |
	filenames := self
		filterFileNames: anHttpRepository readableFileNames
		packages: somePackageNames.
	self maxSteps: filenames size.		
	filenames withIndexDo: [:filename :i |	
		self currentStep: i.
		self reader readFile: filename from: anHttpRepository.
		self inspectVersion.
		shouldInspectDefs := self followAncestors not
			or: [self currentAncestors isEmpty]
			or: [self currentAncestors anySatisfy: [:anc | anc name = self reader info name]].
		shouldInspectDefs ifTrue: [self inspectDefinitions].
		self followAncestors ifTrue: [self updateCurrentAncestry]].! !

!XpfCtMczInspector methodsFor: 'inspecting - methods' stamp: 'rkrk 9/19/2009 19:29'!
inspectSourceText: aText

	| result |
	result := aText attributesOfKind: XpfComplexAttribute.

	self changed: #resultFound with: (Dictionary newFrom: {
		#repository -> self reader repository.
		#definition -> currentMethodDefinition.
		#info -> self reader info.
		#attributes -> result}).! !

!XpfCtMczInspector methodsFor: 'inspecting - versions' stamp: 'rkrk 9/19/2009 19:36'!
inspectVersion

	self changed: #versionFound with: self reader info.! !

!XpfCtMczInspector methodsFor: 'accessing' stamp: 'mt 5/9/2009 12:03'!
isRunning

	isRunning ifNil: [self isRunning: false].
	^ isRunning! !

!XpfCtMczInspector methodsFor: 'accessing' stamp: 'mt 5/9/2009 12:03'!
isRunning: anObject

	isRunning := anObject.
	self changed: #isRunning.! !

!XpfCtMczInspector methodsFor: 'accessing status' stamp: 'rkrk 9/19/2009 19:04'!
maxSteps

	^ maxSteps ifNil: [maxSteps := 1].! !

!XpfCtMczInspector methodsFor: 'accessing status' stamp: 'mt 5/27/2009 10:03'!
maxSteps: anObject

	maxSteps := anObject.
	self changed: #maxSteps.! !

!XpfCtMczInspector methodsFor: 'testing' stamp: 'rkrk 9/19/2009 23:40'!
packageName: packageName matchesFileName: fileName

	"match only those packages which really include packageNames and not only start
	with that name.
	E.g. when somePackageNames = {Xpf-CodeTalk} don't match Xpf-CodeTalkExtension'"
	| packageNameDelimiter versionDelimiter followingChar |
	packageNameDelimiter := $-.
	versionDelimiter := $..
	(fileName beginsWith: packageName) ifFalse: [^ false].
	fileName size = packageName size ifTrue: [true].
	followingChar := fileName at: packageName size + 1.
	^ followingChar = packageNameDelimiter or: [followingChar = versionDelimiter].
! !

!XpfCtMczInspector methodsFor: 'debugging' stamp: 'mt 5/26/2009 13:48'!
print

	Transcript show: ('Next Result: {1}>>{2} ({3}) - {4}' format: {
		currentMethodDefinition className.
		currentMethodDefinition selector.
		currentMethodDefinition category.
		self reader info name}); cr.! !

!XpfCtMczInspector methodsFor: 'accessing' stamp: 'rkrk 9/19/2009 19:03'!
reader

	^ reader ifNil: [reader := XpfCtMczReader new].! !

!XpfCtMczInspector methodsFor: 'accessing' stamp: 'rkrk 9/19/2009 19:04'!
repositories

	^ repositories ifNil: [repositories := OrderedCollection new].! !

!XpfCtMczInspector methodsFor: 'accessing' stamp: 'mt 5/9/2009 12:01'!
repositories: anObject

	repositories := anObject.! !

!XpfCtMczInspector methodsFor: 'controlling' stamp: 'rkrk 9/19/2009 23:16'!
start

	process ifNotNil: [self stop].
	process := [
		[self isRunning: true.
		self repositories do: [:repo |
			self
				inspectRepository: repo key
				include: repo value.
			currentAncestors := nil].
		] ensure: [
			self
				isRunning: false;
				changed: #done]
	] fork priority: 20.! !

!XpfCtMczInspector methodsFor: 'inspecting - versions' stamp: 'rkrk 9/19/2009 23:09'!
startInspectVersions

	self
		followAncestors: true;
		start.! !

!XpfCtMczInspector methodsFor: 'inspecting - versions' stamp: 'rkrk 9/19/2009 23:09'!
startInspectVersionsFor: aSelector in: aClass

	classFilter := aClass.
	selectorFilter := aSelector.
	self startInspectVersions.! !

!XpfCtMczInspector methodsFor: 'controlling' stamp: 'mt 5/9/2009 12:13'!
stop

	process ifNotNilDo: [:p | p terminate].
	process := nil.
	self isRunning: false.! !

!XpfCtMczInspector methodsFor: 'inspecting' stamp: 'mt 6/3/2009 11:05'!
updateCurrentAncestry

	self reader info ancestors ifNotNilDo: [:newAnc |
		self currentAncestors addAll: newAnc].! !

Object subclass: #XpfCtMczReader
	instanceVariableNames: 'zip info definitions repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtMczReader commentStamp: 'mt 5/26/2009 13:09' prior: 0!
This is a simplified version of the McMczReader.!

!XpfCtMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:11'!
associate: tokens

	| result |
	result := Dictionary new.
	tokens pairsDo: [:key :value | 
					value isString ifFalse: [value := value collect: [:ea | self associate: ea]].
					result at: key put: value].
	^ result! !

!XpfCtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
definitions

	^ definitions! !

!XpfCtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
definitions: anObject

	definitions := anObject.! !

!XpfCtMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:11'!
extractInfoFrom: dict

	^ MCVersionInfo
		name: (dict at: #name ifAbsent: [''])
		id: (UUID fromString: (dict at: #id))
		message: (dict at: #message ifAbsent: [''])
		date: ([Date fromString: (dict at: #date) ] on: Error do: [ :ex | ex return: nil ])
		time: ([ Time fromString:(dict at: #time)] on: Error do: [ :ex | ex return: nil ])
		author: (dict at: #author ifAbsent: [''])
		ancestors: ((dict at: #ancestors ifAbsent: [#()]) collect: [:ea | self extractInfoFrom: ea])
		stepChildren: ((dict at: #stepChildren ifAbsent: [#()]) collect: [:ea | self extractInfoFrom: ea])! !

!XpfCtMczReader methodsFor: 'public' stamp: 'mt 5/26/2009 13:58'!
getDefinitionByClass: aClass selector: aSelector

	^ self definitions
		detect: [:def |
			def actualClass = aClass
				and: [def selector = aSelector]]
		ifNone: []! !

!XpfCtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
info

	^ info! !

!XpfCtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
info: anObject

	info := anObject.! !

!XpfCtMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:17'!
loadDefinitions

	(self zip memberNamed: 'snapshot.bin') ifNotNilDo: [:bin |
		[self	definitions:
			(DataStream on: bin contentStream) next definitions]
		on: Error
		do: [:fallThrough |
			self definitions: OrderedCollection new.
			Transcript show: 'Unknown content in snapshot.bin!!'; cr]].! !

!XpfCtMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:11'!
loadVersionInfo

	info := self extractInfoFrom: (self parseMember: 'version')! !

!XpfCtMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:12'!
parseMember: fileName

	| tokens |
	tokens := (MCScanner scanTokens: (zip contentsOf: fileName)) first.
	^ self associate: tokens! !

!XpfCtMczReader methodsFor: 'public' stamp: 'mt 5/26/2009 13:32'!
readFile: aFilename from: aRepository

	self
		repository: aRepository;
		setZip: (XpfCtMczCache cacheAt: aFilename ifNoneGetFrom: aRepository).! !

!XpfCtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:32'!
repository

	^ repository! !

!XpfCtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:32'!
repository: anObject

	repository := anObject.! !

!XpfCtMczReader methodsFor: 'public' stamp: 'mt 5/26/2009 13:17'!
setZip: anMczFile

	self
		zip: anMczFile;
		loadVersionInfo;
		loadDefinitions.! !

!XpfCtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
zip

	^ zip! !

!XpfCtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
zip: anObject

	zip := anObject.! !

Object subclass: #XpfCtMethodRecord
	instanceVariableNames: 'selector markups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Database'!

!XpfCtMethodRecord commentStamp: 'mt 1/16/2010 11:43' prior: 0!
I am a container for versioned method markups. Normally, I am stored inside a class record.!

!XpfCtMethodRecord class methodsFor: 'instance creation' stamp: 'mt 1/16/2010 12:15'!
newFrom: aCompiledMethod

	^ self new
		selector: aCompiledMethod selector! !

!XpfCtMethodRecord methodsFor: 'query - markups' stamp: 'mt 1/18/2010 09:13'!
addVersion: anInteger

	| container |
	container := self markups
		ifEmpty: [OrderedCollection new]
		ifNotEmpty: [| latestVersion |
			latestVersion := self markups keysSortedSafely last.
			latestVersion < anInteger
				ifTrue: [self markups at: latestVersion]
				ifFalse: [OrderedCollection new]].

	^ self markups
		at: anInteger
		put: container.! !

!XpfCtMethodRecord methodsFor: 'query - markups' stamp: 'mt 1/16/2010 15:19'!
at: aCompiledMethod

	^ self atTimeStamp: aCompiledMethod timeStamp! !

!XpfCtMethodRecord methodsFor: 'query - markups' stamp: 'mt 1/16/2010 15:56'!
atSeconds: anInteger

	^ self markups
		at: anInteger
		ifAbsent: [self addVersion: anInteger]! !

!XpfCtMethodRecord methodsFor: 'query - markups' stamp: 'mt 1/16/2010 12:35'!
atTimeStamp: aString
	"Expect the following pattern: 'authorinitials 1/16/2010 12:33'"

	^ self atSeconds: (TimeStamp fromMethodTimeStamp: aString) asSeconds! !

!XpfCtMethodRecord methodsFor: 'query - markups' stamp: 'mt 1/17/2010 19:25'!
clearLastVersion

	self markups
		at: self markups keysSortedSafely last
		put: OrderedCollection new! !

!XpfCtMethodRecord methodsFor: 'query - markups' stamp: 'mt 1/17/2010 18:16'!
copyLastVersion
	"To be used for copy-on-write. Does nothing if the last version is already unique."

	| sourceAndTargetIndices |
	self markups size < 2
		ifTrue: [^ Dictionary new].
	
	sourceAndTargetIndices := self markups keysSortedSafely last: 2.
	(self markups at: sourceAndTargetIndices first) = (self markups at: sourceAndTargetIndices second)
		ifTrue: [|copy|
			copy := Dictionary new.
			(self markups at: sourceAndTargetIndices first) do: [:markup |
				copy at: markup put: markup clone].
			self markups at: sourceAndTargetIndices second put: copy values asOrderedCollection.
			^ copy].
		
	^ Dictionary new! !

!XpfCtMethodRecord methodsFor: 'query - markups' stamp: 'mt 1/17/2010 14:51'!
lastVersion

	self markups ifEmpty: [^ #()].
	^ self markups at: self markups keysSortedSafely last! !

!XpfCtMethodRecord methodsFor: 'accessing' stamp: 'mt 1/16/2010 12:43'!
markups
	"Key: seconds (see TimeStamp class>>fromSeconds:), Value: markups"

	^ markups ifNil: [markups := Dictionary new]! !

!XpfCtMethodRecord methodsFor: 'accessing' stamp: 'mt 1/16/2010 11:59'!
selector

	^ selector! !

!XpfCtMethodRecord methodsFor: 'accessing' stamp: 'mt 1/16/2010 11:59'!
selector: anObject

	selector := anObject.! !

Object subclass: #XpfCtPackageRecord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Database'!

!XpfCtPackageRecord commentStamp: 'mt 1/16/2010 11:45' prior: 0!
I am a container for package markups.!

Object subclass: #XpfCtRemoteMethodVersion
	instanceVariableNames: 'repository definition info'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

XpfCtRemoteMethodVersion class
	instanceVariableNames: 'cache'!

XpfCtRemoteMethodVersion class
	instanceVariableNames: 'cache'!

!XpfCtRemoteMethodVersion class methodsFor: 'caching' stamp: 'mt 5/26/2009 14:06'!
cache

	cache ifNil: [self cache: 
		(LRUCache
			size: 100
			factory: [:key | | repo reader def |
				repo := MCHttpRepository
					location: key location
					user: key user
					password: key password.
				reader := XpfCtMczReader new.
				reader readFile: key filename from: repo.
				def := reader getDefinitionByClass: key theClass selector: key selector.
				def ifNil: [Error signal].
				Transcript show: 'Factory used.'.
				XpfCtRemoteMethodVersion
					repository: repo
					info: reader info
					definition: (reader getDefinitionByClass: key theClass selector: key selector)])].
	^ cache! !

!XpfCtRemoteMethodVersion class methodsFor: 'caching' stamp: 'mt 5/26/2009 09:47'!
cache: anLRUCache

	cache :=  anLRUCache.! !

!XpfCtRemoteMethodVersion class methodsFor: 'instance creation' stamp: 'mt 5/19/2009 11:38'!
repository: aRepository info: aVersionInfo definition: aMethodDefinition

	^ self new
		repository: aRepository;
		info: aVersionInfo;
		definition: aMethodDefinition! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 16:22'!
= other

	^ self species = other species and: [self info timeStamp = other info timeStamp].! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:28'!
category

	^ self definition category! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:18'!
definition
	"This should be a Monticello method definition."

	^ definition! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:17'!
definition: anObject

	definition := anObject.! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 16:07'!
fileIn
	(self theClass) ifNotNilDo: [:class | class
						 				compile: self source 
										classified: self category 
										withStamp: self stamp 
										notifying: nil]! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:18'!
info
	"This should be a Monticello version information object."

	^ info! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:17'!
info: anObject

	info := anObject.! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:17'!
repository

	^ repository! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:17'!
repository: anObject

	repository := anObject.! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:24'!
selector

	^ self definition selector! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 15:36'!
source

	^ self sourceText! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:26'!
sourceText

	^ self definition sourceText! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/25/2009 14:06'!
stamp

	^ self definition timeStamp! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:24'!
theClass

	^ self definition actualClass! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 15:38'!
theClassName

	^ self definition className! !

Object subclass: #XpfCtRemoteVersionKey
	instanceVariableNames: 'theClass selector filename user password location'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtRemoteVersionKey methodsFor: 'comparing' stamp: 'mt 5/26/2009 14:01'!
= other

	^ self species = other species
		and: [self theClass = other theClass
		and: [self selector = other selector
		and: [self filename = other filename
		and: [self user = other user
		and: [self password = other password
		and: [self location = other location]]]]]]! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
filename

	^ filename! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
filename: anObject

	filename := anObject.! !

!XpfCtRemoteVersionKey methodsFor: 'comparing' stamp: 'mt 5/26/2009 14:01'!
hash

	^ self theClass hash
		bitXor: (self selector hash
		bitXor: (self filename hash
		bitXor: (self user hash
		bitXor: (self password hash
		bitXor: (self location hash)))))! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
location

	^ location! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
location: anObject

	location := anObject.! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
password

	^ password! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
password: anObject

	password := anObject.! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
selector

	^ selector! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
selector: anObject

	selector := anObject.! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
theClass

	^ theClass! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
theClass: anObject

	theClass := anObject.! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
user

	^ user! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
user: anObject

	user := anObject.! !

Object subclass: #XpfCtSourceTextStyler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfCtSourceTextStyler commentStamp: 'mt 1/17/2010 12:29' prior: 0!
I can be used by the SwaSourceTextStyler.!

!XpfCtSourceTextStyler methodsFor: 'styling' stamp: 'mt 1/17/2010 16:04'!
styleSource: aText markup: aMarkup inClass: aClass selector: aSelector

	| ref bg |
	ref := XpfCtReferenceAttribute forMarkup: aMarkup.
	ref theClass: aClass; selector: aSelector. "Needed for later database lookup."
		
	aText
		addAttribute: ref
		from: aMarkup range first
		to: aMarkup range last.

	aText
		addAttribute: (XpfCtIconBarAttribute forReference: ref)
		from: aMarkup range first
		to: aMarkup range last.

	bg := XpfCtTextBackgroundColor color: aMarkup color.
	aText
		addAttribute: bg
		from: aMarkup range first
		to: aMarkup range last.
	ref addFriend: bg.! !

!XpfCtSourceTextStyler methodsFor: 'styling' stamp: 'mt 1/17/2010 16:05'!
styleSource: aText markups: someMarkups inClass: aClass selector: aSelector

	someMarkups do: [:markup |
		self
			styleSource: aText
			markup: markup
			inClass: aClass
			selector: aSelector]! !

!XpfCtSourceTextStyler methodsFor: 'styling' stamp: 'mt 1/22/2010 13:21:54'!
styleSource: aText of: aCompiledMethod
	"This approach does only work for the current version of a method."

	aCompiledMethod ifNil: [^ aText].
	
	self
		styleSource: aText
		markups: (XpfCtMarkupDatabase local markupsForCompiledMethod: aCompiledMethod)
		inClass: aCompiledMethod methodClass
		selector: aCompiledMethod selector.
		
	^ aText! !

!XpfCtSourceTextStyler methodsFor: 'styling' stamp: 'mt 1/17/2010 12:32'!
styleSourceForMethodVersion: anOBMethodVersion
	"Return the styled source text of the given method version."! !

Object subclass: #XpfCtTagAnalysisModel
	instanceVariableNames: 'inspector repositoryName username password filter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtTagAnalysisModel methodsFor: 'testing' stamp: 'mt 5/9/2009 17:24'!
canAnalyze

	^ self repositoryName notEmpty! !

!XpfCtTagAnalysisModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 17:36'!
filter

	filter ifNil: [self filter: 'Xpf-CodeTalk'].
	^ filter! !

!XpfCtTagAnalysisModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 17:38'!
filter: anObject

	filter := anObject.
	self changed: #filter.! !

!XpfCtTagAnalysisModel methodsFor: 'accessing' stamp: 'mt 5/13/2009 15:51'!
inspector

	inspector ifNil: [self inspector: XpfCtMczInspector new].
	^ inspector! !

!XpfCtTagAnalysisModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 17:39'!
inspector: anObject

	inspector ifNotNilDo: [:i | i removeDependent: self].
	inspector := anObject.
	inspector ifNotNilDo: [:i | i addDependent: self].
	self changed: #inspector.! !

!XpfCtTagAnalysisModel methodsFor: 'testing' stamp: 'mt 5/9/2009 17:53'!
isNotAnalyzing

	^ self inspector isRunning not! !

!XpfCtTagAnalysisModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 17:27'!
label

	^ self inspector isRunning
		ifTrue: ['Stop Analysis']
		ifFalse: ['Start Analysis'].! !

!XpfCtTagAnalysisModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 17:35'!
password

	password ifNil: [self password: 'gsgs'].
	^ password! !

!XpfCtTagAnalysisModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 17:12'!
password: anObject

	password := anObject.
	self changed: #password.! !

!XpfCtTagAnalysisModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 17:35'!
repositoryName

	repositoryName ifNil: [self repositoryName: 'xpforums'].
	^ repositoryName! !

!XpfCtTagAnalysisModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 17:52'!
repositoryName: anObject

	repositoryName := anObject.
	self
		changed: #repositoryName;
		changed: #canAnalyze.! !

!XpfCtTagAnalysisModel methodsFor: 'analyzing' stamp: 'mt 5/9/2009 17:41'!
startStop

	self inspector isRunning
		ifTrue: [
			self inspector stop.
			self inspector repositories: OrderedCollection new]
		ifFalse: [
			self inspector
				addRepository: (MCHttpRepository
					location: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/', self repositoryName
					user: self username
					password: self password)
				include: {self filter}.
			self inspector start].! !

!XpfCtTagAnalysisModel methodsFor: 'updating' stamp: 'mt 5/9/2009 17:51'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #isRunning ifTrue: [
		self
			changed: #label;
			changed: #isAnalyzing].! !

!XpfCtTagAnalysisModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 17:35'!
username

	username ifNil: [self username: 'gs'].
	^ username! !

!XpfCtTagAnalysisModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 17:12'!
username: anObject

	username := anObject.
	self changed: #username.! !

Object subclass: #XpfCtTagSearchHelper
	instanceVariableNames: 'results classMatchers methodMatchers attributeMatchers typeMatchers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtTagSearchHelper methodsFor: 'matching' stamp: 'cs 5/2/2009 16:43'!
addAttributeMatcher: matcher

	self attributeMatchers add: matcher.! !

!XpfCtTagSearchHelper methodsFor: 'matching' stamp: 'cs 5/2/2009 16:43'!
addMethodMatcher: matcher

	self methodMatchers add: matcher.! !

!XpfCtTagSearchHelper methodsFor: 'searching' stamp: 'mt 5/5/2009 20:09'!
addToResultClass: mrClass symbol: mrSel

	| result |
	result := MethodReference new
		setStandardClass: mrClass
		methodSymbol: mrSel.
	self pvtResults add: result.
	self changed: #resultFound with: result.! !

!XpfCtTagSearchHelper methodsFor: 'matching' stamp: 'cs 5/3/2009 17:15'!
addTypeMatcher: matcher

	self typeMatchers add: matcher.! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/2/2009 15:31'!
attributeMatchers

	^ attributeMatchers! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/2/2009 15:31'!
attributeMatchers: anObject

	attributeMatchers := anObject.! !

!XpfCtTagSearchHelper methodsFor: 'updating' stamp: 'mt 5/7/2009 08:56'!
doWithProgress: aCollection block: aDoBlock message: aString
	"This method is used to signal asynchronous progress from a non-gui thread."
	
	| startTime |
	startTime := TimeStamp now.
	aCollection
		withIndexDo: [:e :i| 
			(TimeStamp now - startTime) seconds >= 1
				ifTrue: [
					self changed: #progressChanged with: {aString. i. aCollection size}. 
					startTime := TimeStamp now].
			aDoBlock value: e].
	self changed: #progressChanged with: {''. aCollection size. aCollection size}.! !

!XpfCtTagSearchHelper methodsFor: 'initialization' stamp: 'cs 5/3/2009 17:16'!
initialize

	self
		methodMatchers: OrderedCollection new;
		typeMatchers: OrderedCollection new;
		attributeMatchers: OrderedCollection new;
		results: Set new;
		addMethodMatcher: [:sel | sel isDoIt not]! !

!XpfCtTagSearchHelper methodsFor: 'matching' stamp: 'cs 5/3/2009 17:16'!
matchAttributeBad

	self addTypeMatcher: [:att | att tag = #bad].! !

!XpfCtTagSearchHelper methodsFor: 'matching' stamp: 'mt 5/28/2009 20:15'!
matchAttributeComment

	self addTypeMatcher: [:att | att tag = #comment].! !

!XpfCtTagSearchHelper methodsFor: 'matching' stamp: 'cs 5/3/2009 17:16'!
matchAttributeTalk

	self addTypeMatcher: [:att | att tag = #talk].! !

!XpfCtTagSearchHelper methodsFor: 'matching' stamp: 'cs 5/4/2009 02:39'!
matchCreator: aString

	self addAttributeMatcher: [:att | att creator = aString].! !

!XpfCtTagSearchHelper methodsFor: 'matching' stamp: 'cs 5/4/2009 02:28'!
matchKeyword: aString

	self addAttributeMatcher: [:att | att includesChatLine: aString].! !

!XpfCtTagSearchHelper methodsFor: 'matching' stamp: 'cs 5/3/2009 14:07'!
matchTime: aSymbol

	self addAttributeMatcher: (self timeMatchers at: aSymbol).! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/2/2009 15:45'!
methodMatchers

	^ methodMatchers! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/2/2009 15:46'!
methodMatchers: anObject

	methodMatchers := anObject.! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/2/2009 13:06'!
pvtResults

	^ results! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/2/2009 13:07'!
results

	^ results asSortedCollection! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/2/2009 12:39'!
results: anObject

	results := anObject.! !

!XpfCtTagSearchHelper methodsFor: 'searching' stamp: 'mt 5/5/2009 20:00'!
searchAttribute: anAttribute
	"Attributes may be a specific timestamp, creator or keyword."
	
	(self searchType: anAttribute) ifFalse: [^ false].
	self attributeMatchers do: [ :matcher |
		(matcher value: anAttribute) ifFalse: [^ false]].
	^ true! !

!XpfCtTagSearchHelper methodsFor: 'searching' stamp: 'mt 5/5/2009 21:31'!
searchCategory: aString

	| result |
	result := OrderedCollection new.
	Smalltalk organization categories
		select: [:c | c startsWith: aString]
		thenDo: [:c | result addAll: (Smalltalk organization listAtCategoryNamed: c)].
	self
		doWithProgress: result
		block: [:name | self searchClass: (Smalltalk at: name)]
		message: 'Searching category ', aString, '...'.! !

!XpfCtTagSearchHelper methodsFor: 'searching' stamp: 'mt 5/5/2009 21:31'!
searchClass: class

	class selectorsDo: [:sel |
		(self searchMethod: sel text: (class sourceCodeAt: sel))
			ifTrue: [self addToResultClass: class symbol: sel]].! !

!XpfCtTagSearchHelper methodsFor: 'searching' stamp: 'mt 5/5/2009 21:31'!
searchGlobal

	self
		doWithProgress: Smalltalk classNames
		block: [:className | self searchClass: (Smalltalk at: className)]
		message: 'Searching all source code...'.! !

!XpfCtTagSearchHelper methodsFor: 'searching' stamp: 'cs 5/2/2009 16:56'!
searchMethod: sel text: text
	
	text isText ifFalse: [^ false].
	self methodMatchers do: [:matcher |
		(matcher value: sel) ifFalse: [^ false]].
	^ self searchText: text! !

!XpfCtTagSearchHelper methodsFor: 'searching' stamp: 'mt 5/5/2009 19:59'!
searchText: aText

	aText runs values do: [:atts |
		atts do: [:att |
			((att isKindOf: XpfComplexAttribute)
			and: [self searchAttribute: att])
				ifTrue: [^ true]]].
	^ false! !

!XpfCtTagSearchHelper methodsFor: 'searching' stamp: 'cs 5/3/2009 17:17'!
searchType: anAttribute
		
	self typeMatchers do: [ :matcher |
		(matcher value: anAttribute) ifTrue: [^ true]].
	^ false! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/4/2009 02:14'!
timeMatchers

	^ Dictionary
		with: #today -> [:att | att timestamp asDate = Date today]
		with: #yesterday -> [:att | att timestamp asDate = Date yesterday]
		with: #thisWeek -> [:att | att timestamp asWeek = Week current]
		with: #lastWeek -> [:att | att timestamp asWeek = (Week current - (Duration weeks: 1))]
		with: #thisMonth -> [:att | att timestamp asMonth = Month current]
		with: #lastMonth -> [:att | att timestamp asMonth = Date current onPreviousMonth asMonth]! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/3/2009 17:15'!
typeMatchers

	^ typeMatchers! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/3/2009 17:15'!
typeMatchers: anObject

	typeMatchers := anObject.! !

Object subclass: #XpfCtTagSearchModel
	instanceVariableNames: 'results category theClass findBad findTalk findComment keyword creator selectedTime controller isSearching progressString progressValue progressValueMax searchProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtTagSearchModel methodsFor: 'testing' stamp: 'mt 5/28/2009 20:17'!
canSearch

	^ self isSearching or: [((self findBad | self findTalk) | self findComment) &
		(self validClass and: [self validCategory])]! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/3/2009 13:26'!
category

	^ category asString asText
		addAttribute: (self validCategory
			ifTrue: [TextColor black]
			ifFalse: [TextColor red]);
		yourself! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'mt 5/6/2009 10:07'!
category: aText
	
	category := aText asString withBlanksTrimmed asSymbol.
	self changed: #category.
	self changed: #canSearch.
	self changed: #theClassEnabled.! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/4/2009 10:45'!
categoryEnabled

	^ theClass isEmpty! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/3/2009 13:32'!
categoryLength

	^ {category size + 1}! !

!XpfCtTagSearchModel methodsFor: 'searching' stamp: 'cs 5/4/2009 00:45'!
children

	^ self results collect: [:ref |
		OBMethodNode on: ref]! !

!XpfCtTagSearchModel methodsFor: 'searching' stamp: 'mt 5/5/2009 21:45'!
clearResults

	results := OrderedCollection new.
	self changed: #results.! !

!XpfCtTagSearchModel methodsFor: 'ecompletion' stamp: 'cs 5/5/2009 17:30'!
completionController

	controller ifNil:[controller := ECController model: self ].
	^ controller! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/4/2009 09:48'!
creator
	^ creator! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/4/2009 09:48'!
creator: anObject
	creator := anObject! !

!XpfCtTagSearchModel methodsFor: 'searching' stamp: 'cs 5/4/2009 10:05'!
enableParams: helper
	
	self keyword ifNotEmpty: [helper matchKeyword: self keyword].
	self creator ifNotEmpty: [helper matchCreator: self creator].
	self selectedTime = #all ifFalse: [helper matchTime: self selectedTime].! !

!XpfCtTagSearchModel methodsFor: 'searching' stamp: 'mt 5/28/2009 20:15'!
enableTags: helper
	
	self findBad ifTrue: [helper matchAttributeBad ].
	self findTalk ifTrue: [helper matchAttributeTalk ].
	self findComment ifTrue: [helper matchAttributeComment ].! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/2/2009 17:15'!
findBad

	^ findBad! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/2/2009 17:56'!
findBad: anObject

	findBad := anObject.
	self changed: #findBad.
	self changed: #canSearch.! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'mt 5/28/2009 20:14'!
findComment

	^ findComment! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'mt 5/28/2009 20:14'!
findComment: anObject

	findComment := anObject.
	self changed: #findComment.
	self changed: #canSearch.! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/2/2009 17:15'!
findTalk

	^ findTalk! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/2/2009 17:56'!
findTalk: anObject

	findTalk := anObject.
	self changed: #findTalk.
	self changed: #canSearch.! !

!XpfCtTagSearchModel methodsFor: 'initialization' stamp: 'mt 5/28/2009 20:16'!
initialize

	super initialize.
	self
		category: '';
		theClass: '';
		keyword: '';
		creator: '';
		findBad: true;
		findTalk: false;
		findComment: false;
		selectedTime: #all.! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'mt 5/5/2009 20:29'!
isSearching

	isSearching ifNil: [isSearching := false].
	^ isSearching! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'mt 5/5/2009 21:38'!
isSearching: aBoolean

	isSearching := aBoolean.
	self
		changed: #canSearch;
		changed: #searchButtonLabel.! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/2/2009 17:15'!
keyword

	^ keyword! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/2/2009 17:15'!
keyword: anObject

	keyword := anObject.! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/4/2009 09:51'!
possibleTimes
	
	^ #(all today yesterday thisWeek lastWeek thisMonth lastMonth).! !

!XpfCtTagSearchModel methodsFor: 'updating' stamp: 'mt 5/5/2009 21:02'!
progressString

	progressString ifNil: [progressString := ''].
	^ progressString! !

!XpfCtTagSearchModel methodsFor: 'updating' stamp: 'mt 5/5/2009 21:03'!
progressValue

	progressValue ifNil: [progressValue := 0].
	^ progressValue! !

!XpfCtTagSearchModel methodsFor: 'updating' stamp: 'mt 5/5/2009 21:04'!
progressValueMax

	progressValueMax ifNil: [progressValueMax := 100].
	^ progressValueMax! !

!XpfCtTagSearchModel methodsFor: 'searching' stamp: 'mt 5/5/2009 20:08'!
results

	results ifNil: [results := OrderedCollection new].
	^ results! !

!XpfCtTagSearchModel methodsFor: 'searching' stamp: 'mt 5/5/2009 21:48'!
search

	| helper |
	self clearResults.
	
	helper := XpfCtTagSearchHelper new.
	helper addDependent: self.
	
	self isSearching: true.
	self enableTags: helper.
	self enableParams: helper.
	searchProcess := [(self theClass notEmpty and: [self validClass])
		ifTrue: [helper searchClass: (Smalltalk at: theClass)]
		ifFalse: [(self category notEmpty and: [self validCategory])
			ifTrue: [helper searchCategory: self category]
			ifFalse: [helper searchGlobal]].
	self isSearching: false] fork priority: 35. "Lower than UI-Thread"! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'mt 5/5/2009 21:37'!
searchButtonLabel

	^ self isSearching
		ifTrue: ['Stop Search']
		ifFalse: ['Start Search']! !

!XpfCtTagSearchModel methodsFor: 'searching' stamp: 'mt 5/5/2009 21:41'!
searchOrStop

	self isSearching
		ifTrue: [self searchStop]
		ifFalse: [self search].! !

!XpfCtTagSearchModel methodsFor: 'searching' stamp: 'mt 5/6/2009 10:25'!
searchStop

	searchProcess ifNil: [^ self].
	searchProcess terminate.
	searchProcess := nil.
	progressValue := 0.
	progressString := ''.
	self
		isSearching: false;
		changed: #progressValue;
		changed: #progressString.! !

!XpfCtTagSearchModel methodsFor: 'searching' stamp: 'cs 5/4/2009 00:51'!
selectResult: result

	(self children at: result) browse! !

!XpfCtTagSearchModel methodsFor: 'ecompletion' stamp: 'cs 5/5/2009 17:38'!
selectedClassOrMetaClass

	^ nil "I don't know any better"! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/4/2009 10:03'!
selectedTime

	^ selectedTime! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/4/2009 10:03'!
selectedTime: anObject

	selectedTime := anObject.! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/4/2009 10:01'!
selectedTimeIndex

	^ self possibleTimes indexOf: self selectedTime! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/4/2009 10:03'!
selectedTimeIndex: aNumber

	^ self selectedTime: (self possibleTimes at: aNumber)! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/3/2009 13:03'!
theClass

	^ theClass asString asText
		addAttribute: (self validClass
			ifTrue: [TextColor black]
			ifFalse: [TextColor red]);
		yourself! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'mt 5/6/2009 10:07'!
theClass: aText
	
	theClass := aText asString withBlanksTrimmed asSymbol.
	self changed: #theClass.
	self changed: #canSearch.! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/3/2009 13:29'!
theClassEnabled

	^ category isEmpty! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/3/2009 13:19'!
theClassLength

	^ {theClass size + 1}! !

!XpfCtTagSearchModel methodsFor: 'updating' stamp: 'mt 5/5/2009 20:31'!
update: aSymbol

	super update: aSymbol.
	
	aSymbol = #searchFinished ifTrue: [
		self isSearching: false].! !

!XpfCtTagSearchModel methodsFor: 'updating' stamp: 'mt 5/5/2009 21:05'!
update: aSymbol with: anObject

	| label value max |
	super update: aSymbol with: anObject.
	
	aSymbol = #resultFound ifTrue: [
		self results add: anObject.
		self changed: #results].
	
	aSymbol = #progressChanged ifTrue: [
		label := anObject first.
		value := anObject second.
		max := anObject third.
		
		progressString := label.
		progressValue := value.
		progressValueMax := max.
		
		self
			changed: #progressString;
			changed: #progressValue].! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/3/2009 13:31'!
validCategory

	^ category isEmpty or:
		[Smalltalk organization categories anySatisfy: [:c | c startsWith: category]]! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/3/2009 13:30'!
validClass

	^ theClass isEmpty or: [Smalltalk includesKey: theClass]! !

BorderedMorph subclass: #XpfCtAttributeEditorMorph
	instanceVariableNames: 'model closeButton title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtAttributeEditorMorph class methodsFor: 'constants' stamp: 'mt 5/28/2009 19:37'!
defaultExtent

	^ 200@150! !

!XpfCtAttributeEditorMorph class methodsFor: 'instance creation' stamp: 'mt 5/28/2009 19:37'!
forAttribute: anXpfAttribute

	^ self new
		attribute: anXpfAttribute! !

!XpfCtAttributeEditorMorph class methodsFor: 'constants' stamp: 'mt 5/28/2009 19:39'!
modelClass

	^ self subclassResponsibility! !

!XpfCtAttributeEditorMorph methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:28'!
attribute: anXpfAttribute

	self model ifNil: [^ self].
	self model attribute: anXpfAttribute.
	self title contents: ('{1} - {2}' format: {
			anXpfAttribute timestamp printRelativeTimeStamp.
			anXpfAttribute creator}).
	self color: (anXpfAttribute color copy lighter lighter alpha: 0.7).! !

!XpfCtAttributeEditorMorph methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:28'!
closeButton

	closeButton ifNil: [closeButton := IconicButton new
			color: (Color white alpha: 0.5);
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfCtCrossIcon;
			actionSelector: #delete;
			useRoundedCorners;
			setBalloonText: 'Close window'].
	^ closeButton! !

!XpfCtAttributeEditorMorph methodsFor: 'initialization' stamp: 'mt 5/28/2009 19:28'!
initialize

	super initialize.
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		listDirection: #topToBottom;
		borderWidth: 1;
		borderColor: Color black;
		changeTableLayout;
		fillStyle: (Color yellow alpha: 0.8);
		layoutInset: 5;
		cellInset: 5;
		useRoundedCorners;
		initializeUserInterface.! !

!XpfCtAttributeEditorMorph methodsFor: 'initialization' stamp: 'mt 5/28/2009 19:29'!
initializeUserInterface

	^ self subclassResponsibility! !

!XpfCtAttributeEditorMorph methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:40'!
model

	model ifNil: [model := self class modelClass new].
	^ model! !

!XpfCtAttributeEditorMorph methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:29'!
title

	title ifNil: [title := UITheme current
			newLabelIn: self label: 'Editor'.
		title hResizing: #spaceFill.
		title assureExtension
			balloonText: 'Creation time and creator'].
	^ title! !

XpfCtAttributeEditorMorph subclass: #XpfCtCodeChatMorph
	instanceVariableNames: 'chatLog textEntry addMessageButton searchEntry searchButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtCodeChatMorph class methodsFor: 'constants' stamp: 'mt 5/28/2009 19:39'!
modelClass

	^ XpfCtCodeChatModel! !

!XpfCtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 17:56'!
addMessageButton

	addMessageButton ifNil: [addMessageButton := IconicButton new
			color: (Color white alpha: 0.5);
			target: self textEntry;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfCtCommentAddIcon;
			actionSelector: #accept;
			useRoundedCorners;
			setBalloonText: 'Add message'].
	^ addMessageButton! !

!XpfCtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/3/2009 10:58'!
chatLog

	chatLog ifNil: [chatLog := (UITheme current
		newMorphListIn: self
		for: self model
		list: #messages
		getSelected: #lastIndex
		setSelected: nil
		getEnabled: nil
		help: nil)
		hResizing: #rigid;
		vResizing: #rigid;
		cellInset: 0;
		layoutInset: 0;
		borderWidth: 0;
		fillStyle: Color transparent;
		extent: self class defaultExtent.
		chatLog listMorph cellInset: 0].
	^ chatLog! !

!XpfCtCodeChatMorph methodsFor: 'initialization' stamp: 'mt 5/3/2009 14:20'!
initializeUserInterface

	self
		addMorphBack: (UITheme current newRowIn: self for: {
			self title.
			self closeButton});
		addMorphBack: (UITheme current newRowIn: self for: {
			self searchEntry.
			self searchButton});
		addMorphBack: self chatLog;
		addMorphBack: (UITheme current newRowIn: self for: {
			self textEntry.
			self addMessageButton}).! !

!XpfCtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/3/2009 14:18'!
searchButton

	searchButton ifNil: [searchButton := IconicButton new
			color: (Color white alpha: 0.5);
			target: self searchEntry;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfCtMagnifierIcon;
			actionSelector: #accept;
			useRoundedCorners;
			setBalloonText: 'Highlight messages with keyword.'].
	^ searchButton! !

!XpfCtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/3/2009 14:19'!
searchEntry

	searchEntry ifNil: [searchEntry := UITheme current
		newTextEntryIn: self
		for: self model
		get: nil
		set: #searchString:
		class: String
		getEnabled: nil
		help: 'Type a keyword to hightlight messages which contain that keyword.'.
		searchEntry
			useRoundedCorners;
			borderWidth: 0;
			fillStyle: (Color white alpha: 0.5);
			setText: 'Look for keyword...'].
	^ searchEntry! !

!XpfCtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/3/2009 10:56'!
textEntry

	textEntry ifNil: [textEntry := UITheme current
		newTextEntryIn: self
		for: self model
		get: #newMessage
		set: #addMessage:
		class: String
		getEnabled: nil
		help: 'Type a message and hit the return key or push the button to the right.'.
		textEntry
			useRoundedCorners;
			borderWidth: 0;
			fillStyle: (Color white alpha: 0.5);
			setText: 'Type message here...'].
	^ textEntry! !

XpfCtAttributeEditorMorph subclass: #XpfCtCommentEditorMorph
	instanceVariableNames: 'commentField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtCommentEditorMorph class methodsFor: 'constants' stamp: 'mt 5/28/2009 19:39'!
modelClass

	^ XpfCtCommentEditorModel! !

!XpfCtCommentEditorMorph methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:45'!
commentField

	commentField ifNil: [commentField := UITheme current
		newTextEditorIn: self
		for: self model
		getText: #comment
		setText: #comment:
		getEnabled: nil.
		commentField
			autoAccept: true;
			useRoundedCorners;
			borderWidth: 0;
			fillStyle: (Color white alpha: 0.5);
			hResizing: #rigid;
			vResizing: #rigid;
			cellInset: 0;
			layoutInset: 0;
			extent: self class defaultExtent].
	^ commentField! !

!XpfCtCommentEditorMorph methodsFor: 'initialization' stamp: 'mt 5/28/2009 19:37'!
initializeUserInterface

	self
		addMorphBack: (UITheme current newRowIn: self for: {
			self title.
			self closeButton});
		addMorphBack: self commentField.! !

BorderedMorph subclass: #XpfCtDiagramMorph
	instanceVariableNames: 'graphs dimensions grid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtDiagramMorph methodsFor: 'add/remove' stamp: 'mt 5/9/2009 15:37'!
addGraph: aGraphMorph

	self addMorph: aGraphMorph.
	aGraphMorph
		position: self position;
		diagram: self.! !

!XpfCtDiagramMorph methodsFor: 'add/remove' stamp: 'mt 5/9/2009 16:48'!
addGrid: aPoint

	self removeGrid.
	
	(self minX to: self maxX by: aPoint x) do: [:t | |newLine|
		newLine := LineMorph
			from: (self scaledPoint: t @ self minY)
			to: (self scaledPoint: t @ self maxY)
			color: Color gray
			width: 1.
		self addMorph: newLine.
		self grid add: newLine].
	
	(self minY to: self maxY by: aPoint y) do: [:t | |newLine|
		newLine := LineMorph
			from: (self scaledPoint: self minX @ t)
			to: (self scaledPoint: self maxX @ t)
			color: Color gray
			width: 1.
		self addMorph: newLine.
		self grid add: newLine].
	
	self
		addGridAxis;
		addLabel: aPoint * (2@1).! !

!XpfCtDiagramMorph methodsFor: 'add/remove' stamp: 'mt 5/9/2009 16:27'!
addGridAxis

	| newLine |
	newLine := LineMorph
		from: (self scaledPoint: self minX @ 0)
		to: (self scaledPoint: self maxX @ 0)
		color: Color gray
		width: 2.

	self addMorph: newLine.
	self grid add: newLine.
	
	newLine := LineMorph
		from: (self scaledPoint: 0 @ self minY)
		to: (self scaledPoint: 0 @ self maxY)
		color: Color gray
		width: 2.

	self addMorph: newLine.
	self grid add: newLine.! !

!XpfCtDiagramMorph methodsFor: 'add/remove' stamp: 'mt 5/9/2009 16:39'!
addLabel: aPoint

	(self minX to: self maxX by: aPoint x) do: [:t | |label|		
		label := (StringMorph contents: t asString)
			position: (self scaledPoint: t@0).
		label position: (label position x - (label width // 2)) @ (label position y + 5).
		self addMorph: label].
	
	(self minY to: self maxY by: aPoint y) do: [:t | |label|
		label := (StringMorph contents: t asString)
			position: (self scaledPoint: 0@t).
		label position: (label position x - label width - 5) @ (label position y - (label height // 2)).
		self addMorph: label].! !

!XpfCtDiagramMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 11:37'!
dimensions

	dimensions ifNil: [self dimensions: (0@100 corner: 100@0)].
	^ dimensions! !

!XpfCtDiagramMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 11:37'!
dimensions: aRectangle

	dimensions := aRectangle.! !

!XpfCtDiagramMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 10:18'!
graphs

	graphs ifNil: [self graphs: Dictionary new].
	^ graphs! !

!XpfCtDiagramMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 10:18'!
graphs: anObject

	graphs anObject.! !

!XpfCtDiagramMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 16:01'!
grid

	grid ifNil: [self grid: OrderedCollection new].
	^ grid! !

!XpfCtDiagramMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 16:10'!
grid: anObject

	grid := OrderedCollection new.! !

!XpfCtDiagramMorph methodsFor: 'initialization' stamp: 'mt 5/9/2009 16:42'!
initialize

	super initialize.
	self
		extent: 200@200;
		color: Color white;
		borderWidth: 0.! !

!XpfCtDiagramMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 11:39'!
maxX

	^ self dimensions right! !

!XpfCtDiagramMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 11:39'!
maxY

	^ self dimensions top! !

!XpfCtDiagramMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 11:38'!
minX

	^ self dimensions left! !

!XpfCtDiagramMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 11:38'!
minY

	^ self dimensions bottom! !

!XpfCtDiagramMorph methodsFor: 'add/remove' stamp: 'mt 5/9/2009 16:11'!
removeGrid

	self grid copy do: [:gridLine | gridLine delete]! !

!XpfCtDiagramMorph methodsFor: 'scaling' stamp: 'mt 5/9/2009 16:03'!
scaledPoint: aPoint
	"Scale the point according to the diagrams dimensions."
	
	| scaledPoint |
	
	scaledPoint :=
		(((aPoint x - self minX) * self width)  // (self maxX abs + self minX abs)) @
		(((aPoint y - self minY) * self height) // (self maxY abs + self minY abs)).
		
	^ scaledPoint * (1@-1) + (0@self height) + self position! !

!Date methodsFor: '*xpf-codetalk' stamp: 'topa 10/27/2009 16:24'!
printRelativeDate
	"Returns 'Today' or 'Yesterday' or 'MM-DD-YYYY' as String for the date."
	
	self = Date today ifTrue: [^'Today'].
	self = Date yesterday ifTrue: [^'Yesterday'].
	
	^(self printFormat: #(1 2 3 $- 1 1 2))! !

!SHParserST80 methodsFor: '*xpf-codetalk' stamp: 'mt 6/6/2009 13:02'!
parseSource: aString
	"Parse the source of a method."

	self
		source: aString;
		parse: true.
	^ ranges! !

!Integer methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 21:24'!
asByteArrayOfSize2: aSize 
	"Answer a ByteArray of aSize with my value, most-significant byte first."
	| answer digitPos |
	aSize < self digitLength ifTrue: [ Error signal: 'number to large for byte array' ].
	answer := ByteArray new: aSize.
	digitPos := 1.
	aSize 
		to: aSize - self digitLength + 1
		by: -1
		do: 
			[ : pos | 
			answer 
				at: pos
				put: (self digitAt: digitPos).
			digitPos := digitPos + 1 ].
	^ answer! !

LabelMorph subclass: #XpfCtPluggableLabelMorph
	instanceVariableNames: 'labelSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtPluggableLabelMorph methodsFor: 'accessing' stamp: 'mt 5/6/2009 10:18'!
labelSelector
	^ labelSelector! !

!XpfCtPluggableLabelMorph methodsFor: 'accessing' stamp: 'mt 5/6/2009 10:22'!
labelSelector: anObject

	labelSelector := anObject.
	self update: anObject! !

!XpfCtPluggableLabelMorph methodsFor: 'updating' stamp: 'mt 5/6/2009 10:24'!
update: aSymbol

	super update: aSymbol.
	
	aSymbol = self labelSelector ifTrue: [self updateLabel].! !

!XpfCtPluggableLabelMorph methodsFor: 'updating' stamp: 'mt 5/6/2009 10:24'!
updateLabel

	| string |
	string := self model perform: self labelSelector.
	
	self 
		disableTableLayout: string isEmpty;
		visible: string isEmpty not.		
	
	self visible ifTrue:
		[self contents: string].! !

!OBMethodNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 10:02'!
categoryText

	^ self category! !

!OBMethodNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 13:50'!
hasMarkups

	^ true! !

!OBMethodNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 14:28'!
markupSourceName

	^ 'protocol [{1}] in {2} "{3}"' format: {
		self category.
		self theClass isMeta
			ifTrue: ['meta-class']
			ifFalse: ['class'].
		self theClassName}! !

!OBMethodNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 13:49'!
referencesForMarkups
	"Use markups for all methods in this method's category."
	
	^ (PackageOrganizer default
		packageOfMethod: self reference
		ifNone: [^ #()]) methods select: [:m | m category = self category]! !

!OBMethodNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/27/2009 15:23'!
remoteVersions

	| result lastDate |
	self metaNode filters ifEmpty: [^ #()].
	
	result := OrderedCollection new.
	
	self metaNode filters first cache do: [:ver | |t|
		t := ver definition fullTimeStamp.
		lastDate = t date ifFalse: [
			result add: (XpfCtSeparatorNode text: t date printRelativeDate)].
		lastDate := t date.
		result add: (XpfCtRemoteMethodVersionNode on: ver)].

	^ result! !

!OBMethodNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 09:55'!
sourceText

	^ self source! !

!OBMethodNode methodsFor: '*xpf-codetalk' stamp: 'mt 1/17/2010 11:40'!
timeStamp

	^ (self theClass >> self selector) timeStamp! !

PluggableButtonMorphPlus subclass: #XpfCtButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtButton class methodsFor: 'instance creation' stamp: 'mt 10/16/2009 14:29'!
on: aModel action: actionSel icon: aSymbol label: aTextOrString

	| lm |
	lm := PanelMorph new
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color transparent;
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 2.
		
	lm
		addMorphBack: (MenuIcons perform: aSymbol) asMorph;
		addMorphBack: aTextOrString asMorph.
		
	^ (self
		on: aModel
		getState: nil
		action: actionSel)
			hResizing: #shrinkWrap;
			vResizing: #spaceFill;
			styleWith: OBMorphBuilder new;
			"setBalloonText: aCommand longDescription;"
			cellInset: 1;	
			label: lm;
			yourself! !

PolygonMorph subclass: #XpfCtGraphMorph
	instanceVariableNames: 'model diagram'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtGraphMorph class methodsFor: 'instance creation' stamp: 'mt 5/9/2009 16:15'!
newFor: aGraphModel color: aColor

	^ (self new
		vertices: {0@0} asOrderedCollection
		color: Color black
		borderWidth: 3
		borderColor: aColor)
		makeOpen;
		model: aGraphModel! !

!XpfCtGraphMorph methodsFor: 'add/remove' stamp: 'mt 5/9/2009 16:04'!
addPoint: aPoint

	"(self diagram dimensions containsPoint: aPoint)
		ifFalse: [^ self]."

	self vertices add: (self diagram scaledPoint: aPoint).
	self computeBounds.! !

!XpfCtGraphMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 15:37'!
diagram

	^ diagram! !

!XpfCtGraphMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 15:37'!
diagram: aDiagramMorph

	diagram := aDiagramMorph.! !

!XpfCtGraphMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 11:36'!
model

	^ model! !

!XpfCtGraphMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 14:52'!
model: anObject

	self model ifNotNilDo: [:m | m removeDependent: self].
	model := anObject.
	self model ifNotNilDo: [:m | m addDependent: self].! !

!XpfCtGraphMorph methodsFor: 'add/remove' stamp: 'mt 5/9/2009 16:04'!
removeAllPoints

	vertices := {self diagram scaledPoint: 0@0} asOrderedCollection.
	self computeBounds.! !

!XpfCtGraphMorph methodsFor: 'updating' stamp: 'mt 5/9/2009 14:55'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #reset ifTrue: [self removeAllPoints].! !

!XpfCtGraphMorph methodsFor: 'updating' stamp: 'mt 5/9/2009 15:03'!
update: aSymbol with: anObject

	super update: aSymbol with: anObject.
	aSymbol = #newPoint ifTrue: [self addPoint: anObject].! !

!OBNode methodsFor: '*xpf-codetalk' stamp: 'topa 10/27/2009 15:53'!
hasMarkups

	^ false! !

!OBNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/25/2009 14:46'!
isSeparatorNode

   ^false! !

!OBPluggableListMorph methodsFor: '*xpf-codetalk-override' stamp: 'mt 4/26/2009 21:32'!
listMorphClass
    ^XpfLazyListMorph! !

PluggableListMorph subclass: #XpfPluggableListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk'!

!XpfPluggableListMorph methodsFor: 'as yet unclassified' stamp: 'cs 5/4/2009 00:49'!
backgroundColorAt: row

	^ Color white! !

!XpfPluggableListMorph methodsFor: 'as yet unclassified' stamp: 'cs 5/4/2009 00:49'!
iconAt: row

	^ nil! !

!XpfPluggableListMorph methodsFor: 'as yet unclassified' stamp: 'cs 5/4/2009 00:37'!
listMorphClass

	^ XpfLazyListMorph! !

!MCMczReader methodsFor: '*xpf-codetalk' stamp: 'mt 1/17/2010 22:08'!
basicVersion

	^ super basicVersion
		markups: self markups! !

!MCMczReader methodsFor: '*xpf-codetalk' stamp: 'mt 1/17/2010 22:13'!
loadMarkups

	(self zip memberNamed: 'markups.bin') ifNotNilDo:
		[:m | [markups := (DataStream on: m contentStream) next]
			on: Error do: [:fallThrough ]].! !

!MCMczReader methodsFor: '*xpf-codetalk' stamp: 'mt 1/17/2010 22:15'!
markups

	markups ifNil: [self loadMarkups].
	^ markups! !

ImageMorph subclass: #XpfCtAttributeIconMorph
	instanceVariableNames: 'attribute lastVisible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfCtAttributeIconMorph methodsFor: 'accessing' stamp: 'mt 6/11/2009 21:27'!
attribute

	^ attribute! !

!XpfCtAttributeIconMorph methodsFor: 'accessing' stamp: 'mt 6/11/2009 21:27'!
attribute: anObject

	attribute := anObject.! !

!XpfCtAttributeIconMorph methodsFor: 'event handling' stamp: 'mt 1/22/2010 11:00:13'!
cleanUp
	"Perform some cleanup operations."! !

!XpfCtAttributeIconMorph methodsFor: 'event handling' stamp: 'mt 7/2/2009 22:33'!
handlesMouseDown: evt

	^ true! !

!XpfCtAttributeIconMorph methodsFor: 'accessing' stamp: 'mt 5/3/2009 19:43'!
visible: aBoolean

	lastVisible = aBoolean ifTrue: [^ self].
	lastVisible := aBoolean.
	self disableTableLayout: aBoolean not.
	^ super visible: aBoolean! !

XpfCtAttributeIconMorph subclass: #XpfCtChatIconMorph
	instanceVariableNames: 'chat'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfCtChatIconMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 15:16'!
balloonText

	^ 'View chat'! !

!XpfCtChatIconMorph methodsFor: 'accessing' stamp: 'mt 4/30/2009 14:49'!
chat

	chat ifNil: [chat := XpfCtCodeChatMorph forAttribute: self attribute].
	^ chat! !

!XpfCtChatIconMorph methodsFor: 'event handling' stamp: 'mt 1/22/2010 11:03:46'!
cleanUp

	super cleanUp.
	chat ifNotNilDo: [:chatMorph | chatMorph delete].! !

!XpfCtChatIconMorph methodsFor: 'initialization' stamp: 'mt 6/2/2009 15:07'!
initialize

	super initialize.
	self image: (MenuIcons xpfCtCommentsIcon).! !

!XpfCtChatIconMorph methodsFor: 'event handling' stamp: 'mt 6/2/2009 18:06'!
mouseDown: evt

	self attribute ifNil: [^ self].
	self attribute read.
	self chat
		initialize;
		position: self positionInWorld;
		attribute: self attribute;
		openInWorld.! !

XpfCtAttributeIconMorph subclass: #XpfCtCommentIconMorph
	instanceVariableNames: 'editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfCtCommentIconMorph methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:45'!
balloonText

	^ 'View comment'! !

!XpfCtCommentIconMorph methodsFor: 'event handling' stamp: 'mt 1/22/2010 11:05:17'!
cleanUp

	super cleanUp.
	editor ifNotNilDo: [:editorMorph | editorMorph delete].! !

!XpfCtCommentIconMorph methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:46'!
editor

	editor ifNil: [editor := XpfCtCommentEditorMorph forAttribute: self attribute].
	^ editor! !

!XpfCtCommentIconMorph methodsFor: 'initialization' stamp: 'mt 5/28/2009 20:12'!
initialize

	super initialize.
	self image: MenuIcons xpfCtCommentIcon.! !

!XpfCtCommentIconMorph methodsFor: 'event handling' stamp: 'mt 6/2/2009 18:07'!
mouseDown: evt

	self attribute ifNil: [^ self].
	self attribute read.
	self editor
		initialize;
		position: self positionInWorld;
		attribute: self attribute;
		openInWorld.! !

XpfCtAttributeIconMorph subclass: #XpfCtDeleteIconMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfCtDeleteIconMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 15:16'!
balloonText

	^ 'Delete markup'! !

!XpfCtDeleteIconMorph methodsFor: 'initialization' stamp: 'mt 5/1/2009 17:55'!
initialize

	super initialize.
	self image: (MenuIcons xpfCtDeleteIcon).! !

!XpfCtDeleteIconMorph methodsFor: 'event handling' stamp: 'mt 5/1/2009 17:55'!
mouseDown: evt

	self attribute ifNil: [^ self].
	self attribute requestDeletion.! !

XpfCtAttributeIconMorph subclass: #XpfCtResizeIconMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfCtResizeIconMorph methodsFor: 'accessing' stamp: 'mt 5/3/2009 19:17'!
balloonText

	^ 'Resize markup'! !

!XpfCtResizeIconMorph methodsFor: 'initialization' stamp: 'mt 5/3/2009 19:18'!
initialize

	super initialize.
	self image: (MenuIcons xpfCtPaintcanIcon).! !

!XpfCtResizeIconMorph methodsFor: 'event handling' stamp: 'mt 5/3/2009 19:19'!
mouseDown: evt

	self attribute ifNil: [^ self].
	self attribute requestResizing.! !

!OBPluggableTextMorphWithShout class methodsFor: '*xpf-codetalk-override' stamp: 'mt 5/1/2009 15:45'!
on: anObject text: getTextSel accept: setTextSel readSelection: getSelectionSel menu: getMenuSel
	"CodeTalk: Use the XpfStyler right now."
	
	|styler answer stylerClass |
	answer := self new.
	stylerClass := answer stylerClass.
	styler := stylerClass
		ifNotNil:[
			stylerClass new
				view: answer;
				yourself].
	^ answer
		styler: styler;
		on: anObject
		text: getTextSel
		accept: setTextSel
		readSelection: getSelectionSel
		menu: getMenuSel! !

!OBPluggableTextMorphWithShout methodsFor: '*xpf-codetalk' stamp: 'topa 2/13/2009 13:48'!
stylerClass
	^XpfTextStyler! !

!OBPluggableTextMorphWithShout methodsFor: '*xpf-codetalk-override' stamp: 'topa 2/13/2009 13:48'!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	^XpfTextMorph! !

!OBPluggableTextMorphWithShout methodsFor: '*xpf-codetalk' stamp: 'mt 1/22/2010 13:11:15'!
update: aSymbol

	aSymbol = getTextSelector ifTrue: [
		textMorph ifNotNilDo: [:tm | (tm contents attributesOfKind: XpfCtMorphAttribute)
			do: [:attr | attr cleanUp]]].

	super update: aSymbol.! !

!RunArray class methodsFor: '*xpf-codetalk-override' stamp: 'mt 4/30/2009 11:37'!
scanFrom: strm
	"Read the style section of a fileOut or sources file.  nextChunk has already been done.  We need to return a RunArray of TextAttributes of various kinds.  These are written by the implementors of writeScanOn:"
	| rr vv aa this |
	(strm peekFor: $( ) ifFalse: [^ nil].
	rr := OrderedCollection new.
	[strm skipSeparators.
	 strm peekFor: $)] whileFalse: 
		[rr add: (Number readFrom: strm)].
	vv := OrderedCollection new.	"Value array"
	aa := OrderedCollection new.	"Attributes list"
	[(this := strm next) == nil] whileFalse: [
		this == $, ifTrue: [vv add: aa asArray.  aa := OrderedCollection new].
		this == $a ifTrue: [aa add: 
			(TextAlignment new alignment: (Integer readFrom: strm))].
		this == $f ifTrue: [aa add: 
			(TextFontChange new fontNumber: (Integer readFrom: strm))].
		this == $F ifTrue: [aa add: (TextFontReference toFont: 
			(StrikeFont familyName: (strm upTo: $#) size: (Integer readFrom: strm)))].
		this == $b ifTrue: [aa add: (TextEmphasis bold)].
		this == $i ifTrue: [aa add: (TextEmphasis italic)].
		this == $u ifTrue: [aa add: (TextEmphasis underlined)].
		this == $= ifTrue: [aa add: (TextEmphasis struckOut)].
		this == $n ifTrue: [aa add: (TextEmphasis normal)].
		this == $- ifTrue: [aa add: (TextKern kern: -1)].
		this == $+ ifTrue: [aa add: (TextKern kern: 1)].
		this == $c ifTrue: [aa add: (TextColor scanFrom: strm)]. "color"
		this == $h ifTrue: [aa add: (XpfComplexAttribute scanFrom: strm)]. "background color - CodeTalk"
		this == $L ifTrue: [aa add: (TextLink scanFrom: strm)].	"L not look like 1"
		this == $R ifTrue: [aa add: (TextURL scanFrom: strm)].
				"R capitalized so it can follow a number"
		this == $q ifTrue: [aa add: (TextSqkPageLink scanFrom: strm)].
		this == $p ifTrue: [aa add: (TextSqkProjectLink scanFrom: strm)].
		this == $P ifTrue: [aa add: (TextPrintIt scanFrom: strm)].
		this == $d ifTrue: [aa add: (TextDoIt scanFrom: strm)].
		"space, cr do nothing"
		].
	aa size > 0 ifTrue: [vv add: aa asArray].
	^ self runs: rr asArray values: vv asArray
"
RunArray scanFrom: (ReadStream on: '(14 50 312)f1,f1b,f1LInteger +;i')
"! !

!MCMethodDefinition class methodsFor: '*xpf-codetalk-override' stamp: 'mt 1/22/2010 13:51:00'!
forMethodReference: aMethodReference
	"CodeTalk: Get the markup from the method reference and put it into the definition."

	| definition |
	definition := self cachedDefinitions at: aMethodReference compiledMethod ifAbsent: [].
	(definition isNil
		or: [definition selector ~= aMethodReference methodSymbol]
		or: [definition className ~= aMethodReference classSymbol]
		or: [definition classIsMeta ~= aMethodReference classIsMeta]
		or: [definition category ~= aMethodReference category])
			ifTrue: [definition := (self 
						className: aMethodReference classSymbol
						classIsMeta: aMethodReference classIsMeta
						selector: aMethodReference methodSymbol
						category: aMethodReference category
						timeStamp: aMethodReference timeStamp
						source: aMethodReference source)
						sourceText: nil.
					self cachedDefinitions at: aMethodReference compiledMethod put: definition].
	^ definition
	! !

!MCMethodDefinition methodsFor: '*xpf-codetalk-override' stamp: 'cs 4/17/2009 18:23'!
addMethodAdditionTo: aCollection
	| methodAddition |
	methodAddition := MethodAddition new
		compile: self sourceText
		classified: category
		withStamp: timeStamp
		notifying: (SyntaxError new category: category)
		logSource: true
		inClass: self actualClass.
	"This might raise an exception and never return"
	methodAddition createCompiledMethod.
	aCollection add: methodAddition.
! !

!MCMethodDefinition methodsFor: '*xpf-codetalk-override' stamp: 'mt 6/12/2009 14:19'!
load

	self actualClass
		compile: self sourceText
		classified: category
		withStamp: timeStamp
		notifying: (SyntaxError new category: category)! !

!MCMethodDefinition methodsFor: '*xpf-codetalk' stamp: 'cs 4/20/2009 16:16'!
sourceText

	^ sourceText ifNil: [self source asText]! !

!MCMethodDefinition methodsFor: '*xpf-codetalk' stamp: 'mt 3/24/2009 15:52'!
sourceText: aText

	sourceText := aText.! !

MultiNewParagraph subclass: #XpfParagraph
	instanceVariableNames: 'textMorph showLineNumbers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfParagraph methodsFor: 'displaying-morphs' stamp: 'mt 1/16/2010 17:01'!
addAttributeMorphs
	"Add the small iconmorphs that appear for some attributes in the text."
	
	| morphs |
	self selectionStart isNil | self textMorph isNil
		ifTrue: [^ self].

	morphs := (self text
		attributesOfKind: XpfCtMorphAttribute 
		from: self selectionStart stringIndex
		to: ((self selectionStop stringIndex - 1) max: self selectionStart stringIndex))
		collect: [:attr | self textMorph addMorph: attr morph. attr morph].
	self textMorph removeAllMorphsBut: morphs.! !

!XpfParagraph methodsFor: 'displaying' stamp: 'mt 1/16/2010 17:00'!
displayOn: aCanvas using: displayScanner at: somePosition

	self
		updateProperties;
		addAttributeMorphs;
		updateAttributeMorphs;
		drawLineNumberBorderOn: aCanvas.
	
	(self lineIndexForPoint: aCanvas clipRect topLeft)
		to: (self lineIndexForPoint: aCanvas clipRect bottomRight)
		do: [ :i |
			self drawTextAttributeOn: aCanvas at: i.
			self drawLineNumber: i on: aCanvas for: (lines at: i)].
	
	super displayOn: aCanvas using: displayScanner at: somePosition.! !

!XpfParagraph methodsFor: 'displaying' stamp: 'mt 5/1/2009 16:15'!
drawLineNumber: aNumber on: aCanvas for: line

	| str |
	showLineNumbers ifFalse: [^ self].
	self textMorph ifNil: [^ self].
	
	str := (aNumber < 10 ifTrue: [' '] ifFalse: ['']), aNumber asString.
	aCanvas
		drawString: str
		from: 1
		to: str size
		at: (self textMorph position x @ (line top + 2))
		font: Preferences standardCodeFont
		color: ((self isInSelectionFor: line)
			ifTrue: [Color black]
			ifFalse: [Color gray]).! !

!XpfParagraph methodsFor: 'displaying' stamp: 'mt 5/1/2009 16:12'!
drawLineNumberBorderOn: aCanvas

	| fontWidth |
	showLineNumbers ifFalse: [^ self].
	self textMorph ifNil: [^ self].
	
	fontWidth := Preferences standardCodeFont widthOfString: '99'.
	aCanvas
		line: (self textMorph position x + fontWidth + 3) @ aCanvas clipRect top
		to: (self textMorph position x + fontWidth + 3) @ aCanvas clipRect bottom
		width: 1
		color: Color gray.! !

!XpfParagraph methodsFor: 'displaying' stamp: 'mt 1/17/2010 14:09'!
drawTextAttributeOn: aCanvas at: index 

	| textLine line nextLine|
	line := lines at: index.
	nextLine := lines size > index ifTrue: [lines at: index + 1] ifFalse: [].
	textLine := self text 
		copyFrom: line first
		to: line last.
	textLine runs withStartStopAndValueDo: [:start :stop :attributes |
		attributes 
			select: [:attr | attr isKindOf: XpfCtTextAttribute]
			thenDo: [:attr | | cb1 cb2 |
				cb1 := self characterBlockForIndex: start + (line first - 1).
				cb2 := self characterBlockForIndex: stop + (line first - 1).
	
				"Highlight the attribute."
				attr
					displayOn: aCanvas
					in: (cb1 left @ line top corner: cb2 right @ line bottom).

				(attr isKindOf: XpfCtMorphAttribute) ifTrue: [
					"Update position of the morph from the attribute."
					(self isLastOccuranceOf: attr in: textLine position: stop for: index)
						ifTrue: [self
							moveAttributeMorph: attr morph
							to: cb2 right @ (line top - attr morph height)]]]
				].! !

!XpfParagraph methodsFor: 'testing' stamp: 'mt 7/2/2009 21:42'!
isInSelectionFor: line

	(self selectionStart isNil or: [self selectionStop isNil])
		ifTrue: [^ false].
		
	^ line last >= self selectionStart textLine first
		and: [line first <= self selectionStop textLine last]! !

!XpfParagraph methodsFor: 'testing' stamp: 'mt 5/1/2009 15:31'!
isLastOccuranceOf: cAttr in: textLine position: endOfRunIndex for: lineIndex
	"Answer true if the attribute does not appear in another run past the current one."

	| nextLine |
	nextLine := lines size > lineIndex ifTrue: [lines at: lineIndex + 1] ifFalse: [].
	^ ((nextLine isNil
		or: [((self text attributesAt: nextLine first) noneSatisfy: [:att | att == cAttr])])
		and: [textLine runs size < (endOfRunIndex + 1) 
			or: [(textLine attributesAt: endOfRunIndex + 1)	noneSatisfy: [:att | att == cAttr]]])! !

!XpfParagraph methodsFor: 'displaying-morphs' stamp: 'mt 5/3/2009 13:53'!
moveAttributeMorph: aMorph to: aPosition
	"Used to display small morphs to interaction with the markup. Pay attention to the extent of the textMorph if possible."
	
	| pos |
	pos := aPosition.
	self textMorph ifNotNilDo: [:t |
		pos := (t extent x - aMorph width min: aPosition x)
			@ (aPosition y < -5 ifTrue: [aMorph height max: aPosition y] ifFalse: [aPosition y])].
	aMorph position: pos.! !

!XpfParagraph methodsFor: 'accessing' stamp: 'mt 4/22/2009 20:37'!
textMorph
	^ textMorph! !

!XpfParagraph methodsFor: 'accessing' stamp: 'mt 4/22/2009 20:37'!
textMorph: anObject
	textMorph := anObject! !

!XpfParagraph methodsFor: 'displaying-morphs' stamp: 'mt 1/16/2010 17:12'!
updateAttributeMorphs
	
	| attrs |
	self selectionStart isNil | self textMorph isNil
		ifTrue: [^ self].
	
	attrs := self text
		attributesOfKind: XpfCtMorphAttribute 
		from: self selectionStart stringIndex
		to: ((self selectionStop stringIndex - 1) max: self selectionStart stringIndex).

	attrs do: [:attr | attr
		updateMorphs: attrs
		start: self selectionStart stringIndex
		stop: self selectionStop stringIndex].! !

!XpfParagraph methodsFor: 'accessing' stamp: 'mt 5/1/2009 16:16'!
updateProperties

	showLineNumbers ifNil: [showLineNumbers := 
		(Preferences
			preferenceAt: #showLineNumbers
			ifAbsent: [Preference new rawValue: false])
			preferenceValue].! !

OBCommand subclass: #XpfCtCmdBrowseMarkups
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCtCmdBrowseMarkups methodsFor: 'accessing' stamp: 'mt 5/30/2009 18:25'!
buttonLabel

	^ 'markups'! !

!XpfCtCmdBrowseMarkups methodsFor: 'execution' stamp: 'mt 5/30/2009 10:01'!
execute

	XpfCtMarkupBrowser openOn: target copy.! !

!XpfCtCmdBrowseMarkups methodsFor: 'accessing' stamp: 'mt 5/30/2009 09:27'!
group

	^ #codetalk! !

!XpfCtCmdBrowseMarkups methodsFor: 'accessing' stamp: 'mt 5/30/2009 15:19'!
icon

	^ #xpfCtCommentsIcon! !

!XpfCtCmdBrowseMarkups methodsFor: 'accessing' stamp: 'mt 5/30/2009 15:19'!
iconOnly

	^ true! !

!XpfCtCmdBrowseMarkups methodsFor: 'testing' stamp: 'mt 5/30/2009 18:25'!
isActive

	^ target hasMarkups and: [requestor isSelected: target]! !

!XpfCtCmdBrowseMarkups methodsFor: 'accessing' stamp: 'mt 5/30/2009 18:25'!
label

	^ 'browse markups'! !

!XpfCtCmdBrowseMarkups methodsFor: 'accessing' stamp: 'mt 5/30/2009 09:28'!
longDescription

	^ 'browse markups'! !

!XpfCtCmdBrowseMarkups methodsFor: 'testing' stamp: 'mt 5/30/2009 09:28'!
wantsButton

	^ true! !

OBCommand subclass: #XpfCtCmdBrowseRemoteMethodVersions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCtCmdBrowseRemoteMethodVersions methodsFor: 'accessing' stamp: 'mt 5/30/2009 18:25'!
buttonLabel

	^ 'versions (mc)'! !

!XpfCtCmdBrowseRemoteMethodVersions methodsFor: 'execution' stamp: 'mt 5/19/2009 15:27'!
execute

	XpfCtRemoteVersionBrowser openOn: target copy.! !

!XpfCtCmdBrowseRemoteMethodVersions methodsFor: 'accessing' stamp: 'mt 5/30/2009 15:19'!
group

	^ #codetalk! !

!XpfCtCmdBrowseRemoteMethodVersions methodsFor: 'accessing' stamp: 'mt 5/30/2009 15:18'!
icon

	^ #xpfCtWorldIcon! !

!XpfCtCmdBrowseRemoteMethodVersions methodsFor: 'accessing' stamp: 'mt 5/30/2009 15:18'!
iconOnly

	^ true! !

!XpfCtCmdBrowseRemoteMethodVersions methodsFor: 'testing' stamp: 'mt 5/27/2009 14:50'!
isActive

	^ target hasVersions and: [requestor isSelected: target]! !

!XpfCtCmdBrowseRemoteMethodVersions methodsFor: 'accessing' stamp: 'mt 5/30/2009 18:26'!
label

	^ 'browse monticello versions'! !

!XpfCtCmdBrowseRemoteMethodVersions methodsFor: 'accessing' stamp: 'mt 5/27/2009 10:35'!
longDescription

  ^ 'display the different remote versions of this method - use repository of working copy'! !

!XpfCtCmdBrowseRemoteMethodVersions methodsFor: 'testing' stamp: 'mt 5/18/2009 13:16'!
wantsButton

	^ true! !

OBCommand subclass: #XpfCtEditCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

XpfCtEditCommand subclass: #XpfCtCmdAddComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCtCmdAddComment methodsFor: 'execution' stamp: 'mt 6/11/2009 17:43'!
execute

	self textMorph editor addComment.! !

!XpfCtCmdAddComment methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:49'!
group

	^ '2'! !

!XpfCtCmdAddComment methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:58'!
icon

	^ #xpfCtAddCommentIcon! !

!XpfCtCmdAddComment methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:50'!
label

	^ 'add comment'! !

XpfCtEditCommand subclass: #XpfCtCmdChangeTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCtCmdChangeTag methodsFor: 'execution' stamp: 'mt 6/11/2009 17:42'!
execute

	self textMorph editor changeMarkupTag.! !

!XpfCtCmdChangeTag methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:49'!
group

	^ '3'! !

!XpfCtCmdChangeTag methodsFor: 'testing' stamp: 'mt 1/17/2010 15:07'!
isEnabled

	^ target fullText
		includesAttributesOfKind: XpfCtReferenceAttribute
		from: target start
		to: (target stop max: target start)! !

!XpfCtCmdChangeTag methodsFor: 'accessing' stamp: 'mt 5/18/2009 10:55'!
label

	^ 'change tag'! !

XpfCtEditCommand subclass: #XpfCtCmdConvertInlineComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCtCmdConvertInlineComment methodsFor: 'execution' stamp: 'mt 6/11/2009 17:42'!
execute

	self textMorph editor convertInlineComment: target.! !

!XpfCtCmdConvertInlineComment methodsFor: 'accessing' stamp: 'mt 6/6/2009 11:17'!
group

	^ '2'! !

!XpfCtCmdConvertInlineComment methodsFor: 'accessing' stamp: 'mt 6/6/2009 13:28'!
icon

	^ #xpfCtCommentGoIcon! !

!XpfCtCmdConvertInlineComment methodsFor: 'testing' stamp: 'mt 1/17/2010 15:07'!
isEnabled

	^ target start <= target stop
		and: [(target fullText
			includesAttributesOfKind: XpfCtReferenceAttribute
			from: target start
			to: target stop) not]! !

!XpfCtCmdConvertInlineComment methodsFor: 'accessing' stamp: 'mt 6/6/2009 11:17'!
label

	^ 'convert inline comment'! !

XpfCtEditCommand subclass: #XpfCtCmdJustTalk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCtCmdJustTalk methodsFor: 'execution' stamp: 'mt 6/11/2009 17:42'!
execute

	self textMorph editor addCodeChat.! !

!XpfCtCmdJustTalk methodsFor: 'accessing' stamp: 'mt 5/2/2009 19:20'!
group

	^ '1'! !

!XpfCtCmdJustTalk methodsFor: 'accessing' stamp: 'mt 5/5/2009 15:01'!
icon

	^ #xpfCtMarkCommentIcon! !

!XpfCtCmdJustTalk methodsFor: 'accessing' stamp: 'mt 5/5/2009 15:38'!
keystroke

	^ $t! !

!XpfCtCmdJustTalk methodsFor: 'accessing' stamp: 'mt 5/5/2009 21:47'!
label

	^ 'add code chat'! !

XpfCtEditCommand subclass: #XpfCtCmdMarkBad
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCtCmdMarkBad methodsFor: 'editor-bridge' stamp: 'mt 6/11/2009 17:43'!
execute

	self textMorph editor markAsBad.! !

!XpfCtCmdMarkBad methodsFor: 'accessing' stamp: 'mt 5/5/2009 15:00'!
group

	^ '1'! !

!XpfCtCmdMarkBad methodsFor: 'accessing' stamp: 'mt 5/5/2009 15:01'!
icon

	^ #xpfCtMarkBadIcon! !

!XpfCtCmdMarkBad methodsFor: 'accessing' stamp: 'mt 5/5/2009 15:38'!
keystroke

	^ $r! !

!XpfCtCmdMarkBad methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:11'!
label
	^ 'mark bad'! !

XpfCtEditCommand subclass: #XpfCtCmdMarkForRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCtCmdMarkForRefactoring methodsFor: 'editor-bridge' stamp: 'bs 12/15/2009 13:06'!
execute

	self textMorph editor markForRefactoring.! !

!XpfCtCmdMarkForRefactoring methodsFor: 'accessing' stamp: 'bs 12/15/2009 13:07'!
group

	^ '2'! !

!XpfCtCmdMarkForRefactoring methodsFor: 'accessing' stamp: 'bs 12/15/2009 13:04'!
icon

	^ #xpfCtMarkBadIcon! !

!XpfCtCmdMarkForRefactoring methodsFor: 'accessing' stamp: 'bs 12/15/2009 13:05'!
label
	^ 'mark for refactoring'! !

XpfCtEditCommand subclass: #XpfCtCmdRemoveMarkup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCtCmdRemoveMarkup methodsFor: 'execution' stamp: 'mt 6/11/2009 17:43'!
execute
	
	self textMorph editor removeMarkup.! !

!XpfCtCmdRemoveMarkup methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:49'!
group

	^ '3'! !

!XpfCtCmdRemoveMarkup methodsFor: 'accessing' stamp: 'mt 5/2/2009 19:23'!
icon

	^ #xpfCtDeleteIcon! !

!XpfCtCmdRemoveMarkup methodsFor: 'testing' stamp: 'mt 1/17/2010 15:07'!
isEnabled

	^ target fullText
		includesAttributesOfKind: XpfCtReferenceAttribute
		from: target start
		to: (target stop max: target start)! !

!XpfCtCmdRemoveMarkup methodsFor: 'accessing' stamp: 'mt 5/3/2009 19:06'!
label

	^'remove markup'! !

XpfCtEditCommand subclass: #XpfCtCmdResize
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCtCmdResize methodsFor: 'execution' stamp: 'mt 6/11/2009 17:43'!
execute
	
	self textMorph editor resizeMarkup.! !

!XpfCtCmdResize methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:49'!
group

	^ '3'! !

!XpfCtCmdResize methodsFor: 'testing' stamp: 'mt 5/3/2009 19:17'!
icon

	^ #xpfCtPaintcanIcon! !

!XpfCtCmdResize methodsFor: 'testing' stamp: 'mt 1/17/2010 15:07'!
isEnabled

	^ target start <= target stop
		and: [(target fullText
			attributesOfKind: XpfCtReferenceAttribute
			from: target start
			to: target stop) size = 1]! !

!XpfCtCmdResize methodsFor: 'accessing' stamp: 'mt 5/3/2009 19:06'!
label

	^'resize markup'! !

!XpfCtEditCommand class methodsFor: 'testing' stamp: 'cs 5/2/2009 13:30'!
takesText

	^ true! !

!XpfCtEditCommand methodsFor: 'accessing' stamp: 'cs 5/2/2009 13:31'!
cluster

	^ #CodeTalk! !

!XpfCtEditCommand methodsFor: 'testing' stamp: 'mt 6/23/2009 08:59'!
isActive

	^ target isKindOf: OBTextSelection! !

!XpfCtEditCommand methodsFor: 'testing' stamp: 'mt 1/17/2010 15:07'!
isEnabled

	^ target stop >= target start
		and: [(target fullText
			includesAttributesOfKind: XpfCtReferenceAttribute
			from: target start
			to: target stop) not]! !

!XpfCtEditCommand methodsFor: 'execution' stamp: 'mt 6/23/2009 09:52'!
textMorph
	"The requestor has to be an OBEnhancementDefinitionPanel"
	
	^ requestor contentMorph textMorph! !

!OBPackageBrowser class methodsFor: '*xpf-codetalk-override' stamp: 'mt 10/16/2009 14:27'!
toolbarPanel

	^ (Preferences
		preferenceAt: #showCodeTalkToolbar
		ifAbsent: [Preference new rawValue: false])
		preferenceValue
			ifTrue: [XpfCtToolbar new]
			ifFalse: []! !
XpfCodeTalk initialize!
